.\" $Id: luac.man,v 1.5 1998/01/12 13:04:24 lhf Exp $
.TH LUAC 1 "23 December 1997"
.SH NAME
luac \- Lua compiler
.SH SYNOPSIS
.B luac
[
.B \-c | -u
]
[
.B \-d
]
[
.B \-l
]
[
.B \-p
]
[
.B \-q
]
[
.B \-v
]
[
.B \-o
.I outputfile
]
.I sourcefile
\&.\|.\|.
.SH DESCRIPTION
.B luac
is the Lua compiler.
It translates programs written in the Lua programming language
into binary files that can be loaded and executed with
.B lua_dofile
in C or
.B dofile
in Lua.

.BR luac
produces a single output file containing the bytecodes
for all named source files.
By default,
the output file is named
.BR luac.out ,
but you can change this with the
.B \-o
option.

You can use "-" to indicate stdin as a source file.

.BR luac
can also load and list binary files with the
.B \-u
option.

.SH OPTIONS
.LP
.TP 1i
.B \-c
compile (this is the default).
.TP
.B \-u
undump, i.e., load and list the given binary files.
If no files are given, then luac undumps
.BR luac.out .
.TP
.BI \-D " name"
predefine symbol
.IR name
for conditional compilation.
.TP
.B \-d
turns debugging on.
.TP
.B \-l
produces a listing of the compiled bytecode for Lua's virtual machine.
This is the default when undumping.
.TP
.B \-p
parses sources files but does not generate any output file.
.TP
.B \-q
quiet; procudes no listing. This is the default when compiling.
.TP
.B \-v
prints version information.
.TP
.B \-V
verbose.
.TP
.BI \-o " outputfile"
name the output file
.IR output ,
instead of the default
.BR luac.out .
The output file cannot be a source file.
.SH FILES
.PD 0
.TP 20
.B luac.out
default output file
.PD
.SH "SEE ALSO"
.BR lua (1)
.LP
.IR "Reference Manual of the Programming Language Lua"
.LP
http://www.tecgraf.puc-rio.br/lua/
.SH DIAGNOSTICS
Error messages should be self explanatory.
.SH BUGS
Inherits any bugs from Lua,
but Lua has no bugs...
.SH AUTHORS
W. Celes, R. Ierusalimschy & L. H. de Figueiredo
(lua@tecgraf.puc-rio.br)
