/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef __CCHECKROM_H__
#define __CCHECKROM_H__

#include "UDisplayMode.h"
#include "CControlPanelApp.h"
#include "CPCIHardware.h"
#include <LString.h>
#include <LCommander.h>

// ---------------------------------------------------------------------------

struct RomURsrcDesc_s
{
	int					IsNewer;
	int					RomUIndex;
	Handle				RomUHdl;
	char				RomUModel[2];
	UInt32				RomUVersion;
};
typedef struct RomURsrcDesc_s	RomURsrcDesc_t;



struct RomURsrc_s
{
	Node_t				node;
	RomURsrcDesc_t		desc;

};
typedef struct RomURsrc_s	RomURsrc_t;


// ---------------------------------------------------------------------------


class	CCheckRom	 {
public:
	
							
						CCheckRom(
							CPCIHardware *		inBoard,
							LCommander *		inCommander);
																					
	virtual				~CCheckRom();
	
public:
	
	List_t *			SetRomUList();

	Boolean				CheckRomProcess();

	void				GetAllRomUInfo(
							List_t *			inRomUList);
							
	Boolean				FindRomUInfo(
							RomURsrc_t *		inRomURsrc);

	char *				MoveMarkby(
							char *				inMark,
							int					increment);

	Handle				CheckNewerRom(
							List_t *			inRomUList);
							
	int					GetVoodooSerie(
							char *				inModelName);
							
	int					IsNewerRomVersion(
							RomURsrc_t*			inRomURsrc);

private:
	
	CPCIHardware *			mBoard;	
	LCommander*				mCommander;
};


#endif	/* __CCHECKROM_H__ */
