/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#include "CDebugView.h"
#include <Processes.h>

#include <LCaption.h>
#include <LPushButton.h>

//#include "DCon.h"


/*______________________________________________________________________________

	Constructor

*/

CDebugView::CDebugView()
{
	
}


/*______________________________________________________________________________

	Constructor (using a Stream, that's the one that will be used)

*/

CDebugView::CDebugView(
	LStream *			inStream)
	: LView ( inStream )
{
}


/*______________________________________________________________________________

	Destructor

*/

CDebugView::~CDebugView()
{
}


#pragma mark -



/*______________________________________________________________________________

	FinishCreateSelf

*/
void
CDebugView::FinishCreateSelf()
{
	LPushButton*		theTestButton = (LPushButton*) this->FindPaneByID('tst1');
	if (theTestButton != nil) theTestButton->AddListener(this);
}



/*______________________________________________________________________________

	ListenToMessage

*/

void					
CDebugView::ListenToMessage(
	MessageT 			inMessage, 
	void *				ioParam)
{
	UInt32 longParam = *(UInt32*)ioParam;
	
	switch (inMessage) {
		case 'tst1':
			QuitAllProccess();
			break;

		default:
			break;
	}

}

/*______________________________________________________________________________

	SetPCIHardware

*/

void
CDebugView::SetPCIHardware(
	CPCIHardware *		inBoard)
{
	if ( inBoard != 0 ) {
		Str255		temp;
		SInt16		clock;
		
		mBoard = inBoard;
		
					
		
	}

}


/*______________________________________________________________________________

	QuitAllProccess

*/

void
CDebugView::QuitAllProccess()
{
	
	//dprintf (">>> QuitAllProcess()\n");
	
	ProcessSerialNumber	PSN;
	ProcessInfoRec		infoRec;
	
	PSN.highLongOfPSN = 0;
	PSN.lowLongOfPSN = kNoProcess;
	int					i = 1;
	//OSType 				application = 'APPL';
	
	infoRec.processInfoLength = sizeof(ProcessInfoRec);
	infoRec.processName = nil;
	//infoRec.processAppSpec = (FSSpec*)sizeof(FSSpec);

	while (GetNextProcess( &PSN ) == noErr )
	{
		if ( GetProcessInformation( &PSN, &infoRec ) == noErr )
		{
		/*	dprintf("\n### process %d\n", i++);
			dprintf("processName: %s\n", infoRec.processName);
			dprintf("processType: %c\n", infoRec.processType);
			dprintf("processSignature: %c\n", infoRec.processSignature);
			dprintf("processType: %c\n", infoRec.processType);
			dprintf("processAppSpec.vRefNum: %d\n", infoRec.processAppSpec->vRefNum);
			dprintf("processAppSpec.parID: %d\n", infoRec.processAppSpec->parID);
			dprintf("processAppSpec.name: %s\n", infoRec.processAppSpec->name);*/
		}
	}	
}
