/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef _CDISPLAY_VIEW_H_
#define _CDISPLAY_VIEW_H_


#include <LView.h>
#include <LWindow.h>
#include "ControlPanelPPob.h"
#include "CPCIHardware.h"
#include "CControlPanel.h"
#include <LListener.h>
#include <LPopupButton.h>

#include "URequestVideo.h"
#include "UDisplayMode.h"

struct DisplayPBIndex_s
{
	SInt16	theReso;
	SInt16	theDepth;
	SInt16	theRefresh;
};
typedef struct DisplayPBIndex_s DisplayPBIndex_t;


class CDisplayView : public LView, public LListener {

public:
	enum { class_ID = FOUR_CHAR_CODE('DISP') };

	//_____ Initialization

							CDisplayView();
							CDisplayView(	
									LStream *			inStream);
	virtual					~CDisplayView();
	

//public:
	//_____ Accessors
	
	void					FinishCreateSelf();
	
	void					ListenToMessage(
									MessageT 			inMessage, 
									void *				ioParam);
									
	Boolean					LoadDisplay_View();
	
	void					MakeCPDisplayPBIndex();

	void					SetPCIHardware(
									CPCIHardware *		inBoard);
									
	void					SetControlPanelPtr(
									CControlPanel *		inControlPanel);

	void					UpdateDisplay_RefreshRate(
									SInt16				theReso);

	void					UpdateDisplay_Depth(
									SInt16				theReso,
									SInt16				theRefresh);

	void 					ChangeDisplayResolution();
	
	void 					ChangeDisplayDepth();
	
	void 					ChangeDisplayRefresh();

	Boolean					FindCPDMRequested(
									CPDisplayDesc_t *		theCPDM);
									
	CPDisplayDesc_t * 		FindBestDepthRefreshMatch(
									CPDisplayDesc_t * 		RequestedCPDM);
									
	CPDisplayDesc_t * 		FindBestDepthMatch(
									CPDisplayDesc_t * 		RequestedCPDM);
									
	DisplayPBIndex_t *		GetDisplayPBIndexSelected();
	
	void 					SetDisplayPBIndexSelected(
									DisplayPBIndex_t * 	theDPBI);
	
	CPDisplayDesc_t *		GetCurrentDisplay();
	
	Boolean					SetDisplayPopupButton(
									CPDisplayDesc_t *		theCPDM);
	
	CPDisplayDesc_t *		FindCPDMbyDataMode(
									CPDisplayDesc_t *	theCPDM);

	Boolean 				SetNewResolution(
									CPDisplayDesc_t *		theCDPM);
									
	void					EnableCancelButton();

private:

	CPCIHardware *			mBoard;
	CControlPanel *			mControlPanel;
	
	Boolean					NeedToChange;
	Boolean					FirstChange;
	CPDisplayDesc_t *		currentDisplayMode;
	LPopupButton *			PBResolution;
	LPopupButton *			PBRefresh;
	LPopupButton *			PBDepth;	

};

#endif /* _CDISPLAY_VIEW_H_ */