/*
** Copyright (c) 1999, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef __CFLASHROMWINDOW_H__
#define __CFLASHROMWINDOW_H__

#include <LWindow.h>
#include <LListener.h>
#include <LCaption.h>
#include <LPushButton.h>
#include "CPCIHardware.h"

class CControlPanel;
class CUpdateRom;
class CEndUpdateRom;

class	CFlashRomWindow :	public LWindow, public LListener
										 {
public:
	enum { class_ID = 'FSHW' };

	//_____ Initialization

							CFlashRomWindow();
							CFlashRomWindow(	
									LStream *			inStream);
	virtual					~CFlashRomWindow();


public:
	//_____ Accessors
										
	void					FinishCreateSelf();

	void					ListenToMessage(
								MessageT 				inMessage, 
								void *					ioParam);

	void					SetPCIHardware(
								CPCIHardware *			inBoard);
								
	void					SetRomUHdl(
								Handle					inHandle);
								
	Boolean					DoFlashRom();
	
	void					CenterWindowOnDisplay();
	
	void					SetControlPanel(
								CControlPanel *			inCPanel);

	CPCIHardware *			GetPCIHardware();
	
	void					SettheDone(
								Boolean 				inBoolean);
								
	Handle					GetRomUHdl();
	
	void					InitFlashRomWindows();
	
	void					StartFlashRom();
	
	void					EndFlashRomProcess();


	void					ClickInDrag(
								const EventRecord		&inMacEvent);
								
	void					DoFlashQuit();

	void					DoFlashRestart();


private:

	Boolean					theDone;
	CPCIHardware *			mBoard;
	Handle 					mRomUHdl;
	CControlPanel *			mCPanel;				

	CUpdateRom * 			mUpdateRom;
	CEndUpdateRom * 		mEndUpdateRom;
};

#endif /* __CFLASHROMWINDOW_H__ */