/*
** Copyright (c) 1999, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef __CHTTPTHREAD_H__
#define __CHTTPTHREAD_H__

#include "CUpdateDrv.h"
#include "CAboutWindow.h"

#include <LListener.h>
#include <LThread.h>
#include <LStdControl.h>
#include <LHTTPMessage.h>
#include <LHTTPConnection.h>

class CUpdateDrv;

class CHTTPSendMsgThread : public LThread, public LListener
{
public:
							CHTTPSendMsgThread(CUpdateDrv * mUpdateDrvWindow);
							~CHTTPSendMsgThread();

	void					ListenToMessage(
								MessageT 				inMessage, 
								void *					ioParam);
								
	void					FinishCreateSelf();
	
protected:
	virtual void *			Run();
	
	virtual void			BuildMessage(
								LHTTPMessage& 			theMessage);
																
	virtual void			DisplayProgress(
								char * 					theStatus);

	void					DisplayResponseError();
	
	void 					SetUpdateDrvResponse(
								LHTTPResponse * 		theResponse);
								
	Boolean 				GetInformationfromResponse(
								Handle  				theTextHandle,
								const char * 			inTagName,
								LStr255	*				outValue);

	Boolean 				IsNewerVersion(
								LStr255 *				inVersion);
								
	UInt32 					ExtrudeVersion(
								char *				inVersion,
								int					inVersionLength);
								
	void					SetCaptionDescriptor(
								ResIDT					inSTRID,
								PaneIDT					inCaptionID,
								UInt16					inTextDescriptor);
								
	void					SetCaptionDescriptor(
								PaneIDT					inCaptionID,
								LStr255					inTextDescriptor);

	CUpdateDrv * 			mUpdateDrvWindow;
	LCaption *				mProgress;
	LStr255 				mVersionFile;
	LStr255					mCaptionText;
	
};


#endif /* __CHTTPTHREAD_H__ */