/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef _CGLIDE_VIEW_H_
#define _CGLIDE_VIEW_H_


#include <LView.h>
#include "ControlPanelPPob.h"
#include "CPCIHardware.h"

#include "CKeyComboField.h"
#include <LPopupButton.h>
#include <LSlider.h>
#include <LListener.h>


class CGlideView : public LView, public LListener {

public:
	enum { class_ID = FOUR_CHAR_CODE('GLIV') };

	//_____ Initialization

							CGlideView();
							CGlideView(	
									LStream *			inStream);
	virtual					~CGlideView();


//public:
	//_____ Accessors
	
	void					SetPCIHardware(
									CPCIHardware *		inBoard);
	
	void					ListenToMessage(
									MessageT 			inMessage, 
									void *				ioParam);
									
	void					FinishCreateSelf();

	Boolean					LoadGlide_View();
	
void						SetVoodooVersion(
									int	 				inValue);

private:

	CPCIHardware *			mBoard;
	LPopupButton *			mAASampling;
	CKeyComboField *		mAAKey;
	LSlider *				mGamma;
	LPopupButton *			mVSync;
	LPopupButton *			m32Bit;
	int						mVVersion;

};

#endif /* _CGLIDE_VIEW_H_ */