/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/


#ifndef _CKEYCOMBOFIELD_H_
#define _CKEYCOMBOFIELD_H_


#include <LEditText.h>
#include <MacTypes.h>



class CKeyComboField : public LEditText {

public:
	enum { class_ID = FOUR_CHAR_CODE('KyCF') };

	//_____ Initialization

							CKeyComboField();
							CKeyComboField(	
									LStream *			inStream);
	virtual					~CKeyComboField();

	
	virtual SInt32			GetValue() const;

	virtual void			SetValue(
									SInt32				inValue);

	virtual void			ClickSelf(
									const SMouseDownEvent	&inMouseDown);
									
	virtual Boolean			HandleKeyPress(
									const EventRecord	&inKeyEvent);

private:
	Str63					mText;					// displayed text

	void					BuildCharStr(
									UInt32				inValue,
									StringPtr			inText);
};


#endif /* _CPROFILE_VIEW_H_ */


