/*
** Copyright (c) 2000, 3dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#include "CPopupButton.h"

#include <LView.h>
#include <LString.h>



/*______________________________________________________________________________

	Constructor (using a Stream, that's the one that will be used)

*/

CPopupButton::CPopupButton(
	LStream *			inStream)
	: LPopupButton ( inStream )
{
}


/*______________________________________________________________________________

	Destructor

*/

CPopupButton::~CPopupButton()
{
}


#pragma mark -


/*______________________________________________________________________________

	FinishCreateSelf

*/

void
CPopupButton::FinishCreateSelf()
{
	LView * theView = mSuperView;
	PaneIDT thePaneID = mPaneID;
	
	thePaneID &= ~0xFF;
	thePaneID |= 'h';
	
	mHintCaption = (LCaption*) theView->FindPaneByID( thePaneID );
	if ( mHintCaption )
	{
	}

}



/*______________________________________________________________________________

	SetValue

*/

void
CPopupButton::SetValue(
	SInt32				inValue)
{
	LPopupButton::SetValue( inValue );
	
	if ( mHintCaption )
	{
		LStr255 theString;
		ResIDT theStringResID;
		
		theStringResID = (*mMenuH)->menuID;
		theString.Assign( theStringResID, mValue );
		mHintCaption->SetDescriptor( &theString[0] );
	}
}


