/*
** Copyright (c) 1999, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
**
*/

#ifndef __CUPDATEDRV_H__
#define __CUPDATEDRV_H__

#include "CAboutWindow.h"
#include "CGETVerThread.h"
#include "CGETDrvThread.h"

#include <LWindow.h>
#include <LListener.h>
#include <LStdControl.h>
#include <LHTTPMessage.h>
#include <LHTTPConnection.h>
#include <LString.h>

class CHTTPSendMsgThread;

class CGETDrvThread;

class	CUpdateDrv : public LWindow, public LListener
								{
public:
	enum { class_ID = 'UPDT' };
	//_____ Initialization

							CUpdateDrv();
							CUpdateDrv(
								LStream *			inStream);

	virtual					~CUpdateDrv();


public:
	//_____ Accessors
	
	void					FinishCreateSelf();

	void					ListenToMessage(
								MessageT 			inMessage, 
								void *				ioParam);
	
	void 					CheckDriverVersion();
	
	void 					SetLastVersion(
								LStr255 & 			inLastVersion);
	
	void 					SetDriverName(
								LStr255 & 			inDriverName);
	
	void 					SetHqxName(
								LStr255 & 			inDriverName);
																
	LStr255 &				GetDriverName();
	
	LStr255 &				GetHqxName();
								
	void 					DownloadDrvNow();


public:

	CHTTPSendMsgThread * 		theHTTPThread;
	CGETDrvThread *				theGETDrvThread;
	Boolean						IsHTTPThreadActive;
	Boolean						IsGETThreadActive;
	LStr255						mLastVersion;
	LStr255						mDriverName;
	LStr255						mHqxName;
	LCaption *					mProgress;
	LCaption *					mLine1;
	
};

#endif /* __CUPDATEDRV_H__ */