/*
** Copyright  1994 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Conix Graphics;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Conix Graphics.
** 
*/

#ifndef _GLT_MATH_H
#define _GLT_MATH_H

#include "math.h"

#include "glt_constants.h"

#define gltSin(x)      (sin(x))
#define gltCos(x)      (cos(x))
#define gltTan(x)      (tan(x))
#define gltASin(x)     (((x) < -1.0) ? -GLT_PI_2 : ((x) > 1.0) ?  GLT_PI_2 : asin(x))
#define gltACos(x)     (((x) < -1.0) ?  GLT_PI   : ((x) > 1.0) ?  0.0  : acos(x))
#define gltATan2(x, y) (((y) != 0.0) ? atan2(x, y) : (((x) < 0.0) ? -GLT_PI_2 : GLT_PI_2))
#define gltATan(x)     (atan(x))
#define gltExp(x)      (exp(x))
#define gltLog(x)      ((x) > 0.0 ? log(x) : -100.0)
#define gltLog10(x)    ((x) > 0.0 ? log10(x) : -10.0)
#define gltPow(x, y)   (pow(x, y))
#define gltSqr(x)      ((x) * (x))
#define gltSqrt(x)     (sqrt(x))
#define gltMod(x, y)   (((x) > 0.0) ? fmod(x, y) : fmod(x, y) + y )

#endif /* _GLT_MATH_H */
