/*
** Copyright  1994 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Conix Graphics;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Conix Graphics.
** 
*/

#ifndef _GLT_CONVERSION_H
#define _GLT_CONVERSION_H

#define GLT_BYTE_MAX             127
#define GLT_UBYTE_MAX            255
#define GLT_SHRT_MAX             32767
#define GLT_USHRT_MAX            65535U
#define GLT_INT_MAX              2147483647
#define GLT_UINT_MAX             4294967295U

#define GLT_CHAR_MAX_INV         7.87401e-3
#define GLT_UCHAR_MAX_INV        3.92156e-3
#define GLT_SHRT_MAX_INV         3.05185e-5
#define GLT_USHRT_MAX_INV        1.52590e-5
#define GLT_INT_MAX_INV          4.656612875e-10
#define GLT_UINT_MAX_INV         2.328306437e-10

/* Float conversion */
#define gltFloatToByte(a)   ((GLbyte)  ((a) * GLT_BYTE_MAX))
#define gltFloatToUbyte(a)  ((GLubyte)  ((a) * GLT_UBYTE_MAX))
#define gltFloatToShort(a)  ((GLshort) ((a) * GLT_SHRT_MAX))
#define gltFloatToUshort(a) ((GLushort) ((a) * GLT_USHRT_MAX))
#define gltFloatToInt(a)    ((GLint)   ((a) * GLT_INT_MAX))
#define gltFloatToUint(a)   ((GLuint)   ((a) * GLT_UINT_MAX))

#define gltByteToFloat(a)   ((GLfloat) (a) * GLT_CHAR_MAX_INV)
#define gltUbyteToFloat(a)  ((GLfloat) (a) * GLT_UCHAR_MAX_INV)
#define gltShortToFloat(a)  ((GLfloat) (a) * GLT_SHRT_MAX_INV)
#define gltUshortToFloat(a) ((GLfloat) (a) * GLT_USHRT_MAX_INV)
#define gltIntToFloat(a)    ((GLfloat) (a) * GLT_INT_MAX_INV)
#define gltUintToFloat(a)   ((GLfloat) (a) * GLT_UINT_MAX_INV)

/* Unsigned byte conversion */
#define gltUbyteToByte(a)   ((a) >> 1)
#define gltUbyteToShort(a)  (((GLshort) (a) << 7) | ((GLshort) (a) >> 1))
#define gltUbyteToUshort(a) (((GLushort) (a) << 8) | ((GLushort) (a)))
#define gltUbyteToInt(a)    (((GLint) (a) << 23) | ((GLint) (a) << 15) | ((GLint) (a) << 7) | ((GLint) (a) >> 1))
#define gltUbyteToUint(a)   (((GLuint) (a) << 24) | ((GLuint) (a) << 16) | ((GLuint) (a) << 8) | ((GLuint) (a)))

#define gltByteToUbyte(a)   ((((GLubyte) (a) & 0x7F) << 1) | (((GLubyte) (a) & 0x7F) >> 6))
#define gltShortToUbyte(a)  ((a) >> 7)
#define gltUshortToUbyte(a) ((a) >> 8)
#define gltIntToUbyte(a)    ((a) >> 23)
#define gltUintToUbyte(a)   ((a) >> 24)

#define gltUshortToInt(a)   ((((GLint) (a)) << 15)  | ((GLint) (a) >> 1))
#define gltUshortToUint(a)  ((((GLuint) (a)) << 16) | ((GLuint) (a)))

#endif /* _GLT_CONVERSION_H */
