/*
** Copyright  1994 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Conix Graphics;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Conix Graphics.
** 
*/

#ifndef _GLT_TEXTURE_H
#define _GLT_TEXTURE_H

/*
** Here is what it looks like in a word:
** 	 +-+----------------+----------------+
** 	 +S+ integer        +     fraction   +
** 	 +-+----------------+----------------+
*/
#define GLT_TEXTURE_INT_BITS           6
#define GLT_TEXTURE_FRACTION_BITS      26
#define GLT_TEXTURE_ALMOST_HALF        (0x01FFFFFF)
#define GLT_TEXTURE_EXACTLY_HALF       (0x02000000)
#define GLT_TEXTURE_ALMOST_ONE         (0x03FFFFFF)
#define GLT_TEXTURE_EXACTLY_ONE        (0x04000000)
#define GLT_TEXTURE_ONE_INV            (1.49011611938e-8)

#define gltTexSignedFloatToFixed(flt)  ((GLTfixedCoord) (gltFloor((flt) * (GLTcoord) 0x00010000 + GLT_HALF)) << 10)
#define gltTexFloatToFixed(flt)        ((GLTfixedCoord) ((flt) * (GLTcoord) 0x00010000 + GLT_HALF) << 10)

#define gltTexFixedToFloat(fixed)      ((GLTcoord) (fixed) * GLT_TEXTURE_ONE_INV)
#define gltTexFixedToInt(fixed)        ((fixed) >> GLT_TEXTURE_FRACTION_BITS)
#define gltTexIntToFixed(i)            ((i) << GLT_TEXTURE_FRACTION_BITS)
#define gltTexCoordFrac(fixed)         ((fixed) & GLT_TEXTURE_ALMOST_ONE)
#define gltTexCoordAdd(f1,f2,f3)       (f1) = (f2) + (f3)
#define gltTexCoordSub(f1,f2,f3)       (f1) = (f2) - (f3)
#define gltTexCoordMult(f1,f2,f3)      (f1) = (((f2) * (f3)) >> GLT_TEXTURE_FRACTION_BITS)
#define gltTexCoordDiv(f1,f2,f3)       (f1) = (((f2) / (f3)) << GLT_TEXTURE_FRACTION_BITS)

#define GLT_TEX_COMP_TYPE       GL_UNSIGNED_BYTE

#define gltByteToTexComp(src)   (((GLubyte) ((src) & 0x7F) << 1) | ((GLubyte) ((src) & 0x40) >> 6))
#define gltUbyteToTexComp(src)  (src)
#define gltShortToTexComp(src)  (((src) & 0x7F80) >> 7)
#define gltUshortToTexComp(src) ((src) >> 8)
#define gltIntToTexComp(src)    (((src) & 0x7F800000) >> 23)
#define gltUintToTexComp(src)   ((src) >> 24)
#define gltFloatToTexComp(src)  (gltMax(gltMin(src, 1.0), 0.0) * GLT_UBYTE_MAX)

#define gltTexCompToByte(src)   ((src) >> 1)
#define gltTexCompToUbyte(src)  (src)
#define gltTexCompToShort(src)  ((GLshort) (src) << 7 | (GLshort) (src) >> 1)
#define gltTexCompToUshort(src) ((GLushort) (src) << 8 | (GLushort) (src))
#define gltTexCompToInt(src)    ((GLint) (src) << 23 | (GLint) (src) << 15 | (GLint) (src) << 7 | (GLint) (src) >> 1)
#define gltTexCompToUint(src)   ((GLuint) (src) << 24 | (GLuint) (src) << 16 | (GLuint) (src) << 8 | (GLuint) (src))
#define gltTexCompToFloat(src)  ((GLfloat) (src) * GLT_UCHAR_MAX_INV)

#if GLT_FIXED_COLOR_BITS == 15
	#define gltTexCompToFixedColor(c)    gltUbyteToShort(c)
#elif GLT_FIXED_COLOR_BITS == 16
	#define gltTexCompToFixedColor(c)    gltUbyteToUshort(c)
#else
	#error
#endif

#endif /* _GLT_TEXTURE_H */
