/*
** Copyright  1994 - 1998, Conix Graphics.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Conix Graphics;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Conix Graphics.
** 
*/

#ifndef _GLT_UTILITY_H
#define _GLT_UTILITY_H

#define gltAbs(x)             (((x) < 0 ? -(x) : (x)))
#define gltIsZero(x)          (gltAbs(x) < GLT_EPSILON)
#define gltBooleanZero(x)     (((x) == 0) ? GL_FALSE : GL_TRUE)
#define gltSwap(a, b, t)      ((t) = (a), (a) = (b), (b) = (t))
#define gltSign(a)            ((a < 0) ? (-1) : (1))
#define gltMax(a, b)          ((a) < (b) ? (b) : (a))
#define gltMin(a, b)          ((a) > (b) ? (b) : (a))
#define gltClamp(a, min, max) ((a) < (min) ? (min) : (a) > (max) ? (max) : (a))
#define gltRound(a)           (a + GLT_HALF)
#define gltFloor(a)           ((a) > 0.0 ? ((GLint) (a)) : ((GLint) (a - 0.99999999)))
#define gltFrac(a)            ((a) - gltFloor(a))

#endif /* _GLT_UTILITY_H */
