//
// Copyright (c) 1996, 3Dfx Interactive, Inc.
// All Rights Reserved.
//
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
// the contents of this file may not be disclosed to third parties, copied or
// duplicated in any form, in whole or in part, without the prior written
// permission of 3Dfx Interactive, Inc.
//
// RESTRICTED RIGHTS LEGEND:
// Use, duplication or disclosure by the Government is subject to restrictions
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
// rights reserved under the Copyright Laws of the United States.
//
// --------------------------------------------------------------------------
//
// Tables of register write values to set the various VGA graphics modes
//
//
// $Log: 
//  2    3dfx      1.0.1.0     10/11/00 Brent           Forced check in to enforce
//       branching.
//  1    3dfx      1.0         09/11/99 StarTeam VTS Administrator 
// $
** 
** 1     1/20/98 3:57p Anderson
// Revision 1.6  1997/05/31 05:53:18  psmith
// changed special simulation video mode to 64x2
//
// Revision 1.5  1997/05/29 19:01:08  psmith
// this rev and the previous one changed the special sim-only video mode
// from 16x16 to 16x2 (i.e., 2 horizontal lines instead of 16)
//
// Revision 1.4  1997/05/29 18:57:43  psmith
// *** empty log message ***
//
// Revision 1.3  1997/05/29 18:28:55  bangell
// Fixed duplicate calls by adding static declaration to vga_mode
//
// Revision 1.2  1997/05/29 00:48:50  psmith
// added special 16x16 video mode for simulation
//
// Revision 1.1  1997/05/27 16:22:06  psmith
// This is a copy of the file "vga_modes.h" originally located in
// h3/src/vga/csim.  Presumably, this file originated as part of the PVGA
// csim.
//
//

#define MISC_REG 0
#define SEQ_REG 1
#define GR_REG 6
#define CRTC_REG 15
#define ATTR_REG 40


static ulong mode0_200[] = {
					0x63,									/* Misc */
					0x03, 0x09, 0x03, 0x00, 0x02,	/* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x10, 0x0E, 0x00, 0xFF,
					0x2D, 0x27, 0x28, 0x90, 0x2B, /* CRTC Registers */
					0xA0, 0xBF, 0x0f, 0x00, 0xC7, 
					0x26, 0x07, 0x00, 0x00, 0x00, 
					0x35, 0x9C, 0x0E, 0x8F, 0x14, 
					0x04, 0x96, 0xB9, 0xA3, 0xFF,
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */
					0x05, 0x06, 0x07, 0x10, 0x11, 
					0x12, 0x13, 0x14, 0x15, 0x16, 
					0x17, 0x00, 0xBD, 0x0F, 0x00
				};
				
static ulong mode0_350[] = {
					0xA3, 								/* Misc */
					0x03, 0x09, 0x03, 0x00, 0x02, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x10, 0x0E, 0x00, 0xFF, 
					0x2D, 0x27, 0x28, 0x90, 0x2B, /* CRTC Registers */
					0xA0, 0xBF, 0x1F, 0x06, 0x4D, 
					0x2B, 0x0C, 0x00, 0x00, 0x00, 
					0x00, 0x83, 0x05, 0x5D, 0x14, 
					0x1F, 0x63, 0xBA, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x00, 0xBD, 0x0F, 0x00 
};

static ulong mode0_400[] = {
					0x63, 								/* Misc */
					0x03, 0x08, 0x03, 0x00, 0x02, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x10, 0x0E, 0x00, 0xFF, 
					0x2D, 0x27, 0x28, 0x90, 0x2B, /* CRTC Registers */
					0xA0, 0xBF, 0x1F, 0x00, 0x4F, 
					0x2D, 0x0E, 0x02, 0xAA, 0x00, 
					0x00, 0x9C, 0x0E, 0x8F, 0x14, 
					0x0F, 0x96, 0xB9, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x04, 0xBD, 0x0F, 0x08 
};

static ulong mode0_480[] = {
					0xE3,  								/* Misc */
					0x03, 0x09, 0x03, 0x00, 0x02, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x10, 0x0E, 0x00, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */
					0x80, 0xF2, 0x0F, 0x66, 0x0F, 
					0x01, 0x6E, 0x09, 0x5B, 0x02, 
					0x3E, 0xE5, 0x0B, 0xAE, 0x28, 
					0x0F, 0xE1, 0xED, 0xA3, 0x7B, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x20, 0x00, 0x0F, 0x07
};

static ulong mode2_200[] = {
					0x63,									/* Misc */
					0x03, 0x01, 0x03, 0x00, 0x02,	/* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x10, 0x0E, 0x00, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x55, /* CRTC Registers */
					0x81, 0xBF, 0x1F, 0x00, 0xC7, 
					0x26, 0x07, 0x00, 0x00, 0x00, 
					0x03, 0x9C, 0x0E, 0x8F, 0x28, 
					0x03, 0x96, 0xB9, 0xA3, 0xFF,
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */
					0x05, 0x06, 0x07, 0x10, 0x11,
					0x12, 0x13, 0x14, 0x15, 0x16, 
					0x17, 0x00, 0xBD, 0x0F, 0x00
				};

static ulong mode2_400[] = {
					0x67, 								/* Misc */
					0x03, 0x00, 0x03, 0x00, 0x02, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */
					0x11, 0x0E, 0x00, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x55,  /* CRTC Registers */
					0x81, 0xBF, 0x1F, 0x00, 0x4F, 
					0x10, 0x0E, 0x00, 0x00, 0x00, 
					0x00, 0x9C, 0x0E, 0x8F, 0x28, 
					0x1F, 0x96, 0xB9, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x04, 0xBD, 0x0F, 0x08 
};

static ulong mode2_480[] = {
					0xE3,  								/* Misc */
					0x03, 0x01, 0x03, 0x00, 0x02, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x10, 0x0E, 0x00, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x55, /* CRTC Registers */ 
					0x81, 0xF2, 0x1F, 0x00, 0x4F, 
					0x01, 0x0E, 0x00, 0x00, 0x00, 
					0x00, 0xE5, 0x0B, 0xDF, 0x28, 
					0x0F, 0xE1, 0xED, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x04, 0x00, 0x0F, 0x00 
};

static ulong mode4_200[] = {
					0x63,  								/* Misc */
					0x03, 0x09, 0x03, 0x00, 0x02, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x30, 0x0F, 0x00, 0xFF, 
					0x2D, 0x27, 0x28, 0x90, 0x2B, /* CRTC Registers */ 
					0x80, 0xBF, 0x1F, 0x00, 0xC1, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0x9C, 0x0E, 0x8F, 0x14, 
					0x00, 0x96, 0xB9, 0xA3, 0xFF, 
					0x00, 0x11, 0x22, 0x33, 0x02, /* Attr Registers */ 
					0x04, 0x06, 0x07, 0x10, 0x11, 
					0x12, 0x13, 0x14, 0x15, 0x16, 
					0x17, 0x01, 0xBD, 0x03, 0x00
};

static ulong mode6_200[] = {
					0x63,  								/* Misc */
					0x03, 0x01, 0x01, 0x00, 0x06, /* Seq Registers */
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x00, 0x0D, 0x00, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */ 
					0x80, 0xBF, 0x1F, 0x00, 0xC1, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0x9C, 0x0E, 0x8F, 0x28, 
					0x00, 0x96, 0xB9, 0xC3, 0xFF, 
					0x00, 0x17, 0x17, 0x17, 0x17, /* Attr Registers */ 
					0x17, 0x17, 0x17, 0x17, 0x17, 
					0x17, 0x17, 0x17, 0x17, 0x17, 
					0x17, 0x01, 0xBD, 0x01, 0x00 
};

static ulong mode03_200[] = {
					0x63,  								/* Misc */
					0x03, 0x09, 0x0F, 0x00, 0x06, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x00, 0x05, 0x0F, 0xFF, 
					0x2D, 0x27, 0x28, 0x90, 0x2B, /* CRTC Registers */ 
					0x80, 0xBF, 0x1F, 0x00, 0xC0, 
					0x00, 0x00, 0x00, 0x02, 0x00, 
					0x00, 0x9C, 0x0E, 0x8F, 0x14, 
					0x00, 0x96, 0xB9, 0xE3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x06, 0x07, 0x10, 0x11, 
					0x12, 0x13, 0x14, 0x15, 0x16, 
					0x17, 0x01, 0xBD, 0x0F, 0x00 
};

static ulong mode0e_200[] = {
					0x63,  								/* Misc */
					0x03, 0x01, 0x0F, 0x00, 0x06, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x00, 0x05, 0x0F, 0xFF, 
					0x5f, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */ 
					0x80, 0xBF, 0x1D, 0x00, 0xC0, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0x9C, 0x0E, 0xCB, 0x28, 
					0x00, 0x96, 0xB9, 0xE3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x06, 0x07, 0x10, 0x11, 
					0x12, 0x13, 0x14, 0x15, 0x16, 
					0x17, 0x01, 0xBD, 0x0F, 0x00
};

static ulong mode10_350[] = {
					0xA3,  								/* Misc */
					0x03, 0x01, 0x0F, 0x00, 0x06, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x01, 0x05, 0x0F, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */ 
					0x80, 0xBF, 0x0D, 0x60, 0x00, 
					0x00, 0x00, 0x01, 0xAA, 0x00, 
					0x00, 0x83, 0x05, 0x64, 0x28, 
					0x0F, 0x63, 0xBA, 0xE3, 0x5A, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x21, 0x22, 0x0F, 0x03 
};

static ulong mode12_480[] = {
					0xE3,  								/* Misc */
					0x03, 0x01, 0x0F, 0x00, 0x06, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x00, 0x05, 0x0F, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */ 
					0x80, 0x0B, 0x3E, 0x00, 0x40, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0xEA, 0x8C, 0xDF, 0x28, 
					0x00, 0xE7, 0x04, 0xE3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x14, 0x07, 0x38, 0x39, 
					0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 
					0x3F, 0x01, 0xBD, 0x0F, 0x00 
};

static ulong mode13_200[] = {
					0x63,  								/* Misc */
					0x03, 0x01, 0x0F, 0x00, 0x0E, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x40, 0x05, 0x0F, 0xFF, 
					0x5F, 0x4F, 0x50, 0x82, 0x54, /* CRTC Registers */ 
					0x80, 0xBF, 0x1F, 0x00, 0x41, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0x9C, 0x80, 0x8F, 0x28, 
					0x40, 0x96, 0xB9, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x06, 0x07, 0x08, 0x09, 
					0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 
					0x0F, 0x41, 0x00, 0x0F, 0x00 
};

// special simulation mode 64x2

static ulong modeFF_16[] = {
					0x63,  			      /* Misc */
					0x03, 0x01, 0x0F, 0x00, 0x0E, /* Seq Registers */ 
					0x00, 0x00, 0x00, 0x00, 0x00, /* Graphics Registers */ 
					0x40, 0x05, 0x0F, 0xFF, 
					0x06, 0x07, 0x07, 0x0a, 0x08, /* CRTC Registers */ 
					0x09, 0x03, 0x00, 0x00, 0x00, 
					0x00, 0x00, 0x00, 0x00, 0x00, 
					0x00, 0x02, 0x03, 0x01, 0x00, 
					0x00, 0x01, 0x04, 0xA3, 0xFF, 
					0x00, 0x01, 0x02, 0x03, 0x04, /* Attr Registers */ 
					0x05, 0x06, 0x07, 0x08, 0x09, 
					0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 
					0x0F, 0x41, 0x00, 0x0F, 0x00 
};
