/* -*-c++-*- */
/* $Header: dfptable.h, 2, 10/11/00 8:54:09 PM, Brent$ */
/*
** Copyright (c) 1995-1999, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished  -
** rights reserved under the Copyright Laws of the United States.
**
** File name:   dfptable.h
**
** Description: Mode table that contains DFP modes and related register values.
**
** $Revision: 2$
** $Date: 10/11/00 8:54:09 PM$
**
** $History: dfptable.h $
** 
** *****************  Version 1  *****************
** User: Dalev        Date: 8/20/99    Time: 4:29p
** Created in $/devel/h5/Win9x/dx/minivdd
** Original;  CRTC mode tables for non-scaling DFP's.
** 
**
*/
// STB-SR 01/07/99 I had assumed that SR1 (Sequencer Register 1), 
// was always 0x21.  Bit 0 defines wether or not the character
// width is 8 or 9.  1->8 pixel wide char, 0->9 pixel char.  The actual change
// was made in minivdd\modetabl.h
// STB-SR 02/11/99 Adding STB & 3Dfx unified modes for Voodoo3

// If you need to make changes to the modetable, you must also edit
// dd16\h3.c and dd16\setmode.c
//              r[0]  r[1]  r[2]  r[3]  r[4]  r[5]  r[6]  r[7]  r[8]  r[9]  r[10] r[11] r[12] r[13] r[14] r[15] r[16] r[17] r[18] r[19] r[20]
// x    y  rr,    0h    1h    2h    3h    4h    5h    6h    7h    9h   10h    11h   12h   15h   16h   1ah   1bh  3c2   SR1  pllctrl0  dacmode
// x    y  rr, Htotl HDEnE HBlSt HBlEn HSySt HSyEn Vtotl Ovflw MxSLn VSySt  VSyEn VDEnE VBlSt VBlEn HExtn VExtn MiscO  SR1  pllctrl0  dacmode 
// New Standardized modetable for both 3Dfx and STB
{  320,  200,  70, 0x2d, 0x27, 0x27, 0x91, 0x28, 0x8e, 0xbf, 0x1f, 0xc0, 0x9c,
	0x2e, 0x8f, 0x97, 0xb8, 0x80, 0x00, 0x4f, 0x21, 0x73, 0xd1, 0x00},
{  320,  200,  85, 0x2f, 0x27, 0x27, 0x93, 0x29, 0x8d, 0xbb, 0x1f, 0xc0, 0x90,
	0x23, 0x8f, 0x8f, 0xbc, 0x80, 0x00, 0x4f, 0x21, 0xd5, 0x77, 0x00},
{  320,  240,  60, 0x2d, 0x27, 0x27, 0x91, 0x28, 0x8e, 0x0b, 0x3e, 0xc0, 0xe9,
	0x2b, 0xdf, 0xdf, 0x0c, 0x80, 0x00, 0xcf, 0x21, 0x73, 0xd1, 0x00},
{  320,  240,  72, 0x2f, 0x27, 0x27, 0x93, 0x29, 0x8b, 0x06, 0x3e, 0xc0, 0xe8,
	0x2b, 0xdf, 0xdf, 0x07, 0x80, 0x00, 0xcf, 0x21, 0xd5, 0x77, 0x00},
{  320,  240,  75, 0x30, 0x27, 0x27, 0x94, 0x28, 0x8c, 0xf2, 0x1f, 0xc0, 0xe0,
	0x23, 0xdf, 0xdf, 0xf3, 0x80, 0x00, 0xcf, 0x21, 0xca, 0xe5, 0x00},
{  320,  240,  85, 0x2f, 0x27, 0x27, 0x93, 0x2a, 0x8e, 0xfb, 0x1f, 0xc0, 0xe0,
	0x23, 0xdf, 0xdf, 0xfc, 0x80, 0x00, 0xcf, 0x21, 0x86, 0xae, 0x00},
{  400,  300,  60, 0x3d, 0x31, 0x31, 0x81, 0x34, 0x1c, 0x72, 0xf0, 0xe0, 0x58,
	0x2c, 0x57, 0x57, 0x73, 0xa0, 0x00, 0x0f, 0x21, 0x3f, 0xbc, 0x00},
{  400,  300,  72, 0x3c, 0x31, 0x31, 0x80, 0x35, 0x1c, 0x98, 0xf0, 0xe0, 0x7c,
	0x22, 0x57, 0x57, 0x99, 0xa0, 0x00, 0x0f, 0x21, 0xfd, 0xe1, 0x00},
{  400,  300,  75, 0x3d, 0x31, 0x31, 0x81, 0x32, 0x17, 0x6f, 0xf0, 0xe0, 0x58,
	0x2b, 0x57, 0x57, 0x70, 0xa0, 0x00, 0x0f, 0x21, 0x8a, 0xf7, 0x00},
{  400,  300,  85, 0x3d, 0x31, 0x31, 0x81, 0x33, 0x17, 0x75, 0xf0, 0xe0, 0x58,
	0x2b, 0x57, 0x57, 0x76, 0xa0, 0x00, 0x0f, 0x21, 0x2f, 0xcc, 0x00},
{  512,  384,  60, 0x4f, 0x3f, 0x3f, 0x93, 0x41, 0x09, 0x24, 0xf5, 0xe0, 0x02,
	0x28, 0xff, 0xff, 0x25, 0x20, 0x00, 0xcf, 0x21, 0xc1, 0xe1, 0x00},
{  512,  384,  70, 0x4e, 0x3f, 0x3f, 0x92, 0x41, 0x09, 0x24, 0xf5, 0xe0, 0x02,
	0x28, 0xff, 0xff, 0x25, 0x20, 0x00, 0xcf, 0x21, 0x2b, 0xf9, 0x00},
{  512,  384,  75, 0x4d, 0x3f, 0x3f, 0x91, 0x40, 0x06, 0x1e, 0xf5, 0xe0, 0x00,
	0x23, 0xff, 0xff, 0x1f, 0x20, 0x00, 0xcf, 0x21, 0x26, 0x77, 0x00},
{  512,  384,  85, 0x51, 0x3f, 0x3f, 0x95, 0x42, 0x08, 0x26, 0xf5, 0xe0, 0x00,
	0x23, 0xff, 0xff, 0x27, 0x20, 0x00, 0xcf, 0x21, 0x21, 0x40, 0x00},
{  640,  400,  70, 0x5f, 0x4f, 0x50, 0x82, 0x51, 0x9d, 0xbf, 0x1f, 0x40, 0x9c,
	0x2e, 0x8f, 0x97, 0xb8, 0x20, 0x00, 0x4f, 0x21, 0x72, 0xd1, 0x00},
{  640,  400,  85, 0x63, 0x4f, 0x4f, 0x87, 0x53, 0x9b, 0xbb, 0x1f, 0x40, 0x90,
	0x23, 0x8f, 0x8f, 0xbc, 0x20, 0x00, 0x4f, 0x21, 0xd4, 0x77, 0x00},
//{  640,  480,  60, 0x5f, 0x4f, 0x50, 0x82, 0x51, 0x9d, 0x0b, 0x3e, 0x40, 0xe9,
//	0x2b, 0xdf, 0xe7, 0x04, 0x20, 0x00, 0xcf, 0x21, 0x72, 0xd1, 0x00},
{  640,  480,  60, 0xa3, 0x4f, 0x60, 0x8c, 0x68, 0x1c, 0x20, 0xb3, 0x60, 0x70,
	0x01, 0xdf, 0x67, 0x88, 0x20, 0x00, 0xcf, 0x21, 0x29, 0x6b, 0x00},
{  640,  480,  72, 0x63, 0x4f, 0x50, 0x86, 0x52, 0x97, 0x06, 0x3e, 0x40, 0xe8,
	0x2b, 0xdf, 0xe7, 0xff, 0x20, 0x00, 0xcf, 0x21, 0xd4, 0x77, 0x00},
{  640,  480,  75, 0x64, 0x4f, 0x4f, 0x88, 0x51, 0x99, 0xf2, 0x1f, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0xf3, 0x20, 0x00, 0xcf, 0x21, 0xd4, 0x77, 0x00},
{  640,  480,  85, 0x63, 0x4f, 0x4f, 0x87, 0x56, 0x9d, 0xfb, 0x1f, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0xfc, 0x20, 0x00, 0xcf, 0x21, 0x85, 0xae, 0x00},
{  640,  480, 100, 0x65, 0x4f, 0x4f, 0x89, 0x54, 0x9c, 0xfb, 0x1f, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0xfc, 0x20, 0x00, 0x4f, 0x21, 0x1f, 0xd7, 0x00},
{  640,  480, 120, 0x65, 0x4f, 0x4f, 0x89, 0x54, 0x9c, 0x01, 0x3e, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0x02, 0x20, 0x00, 0x4f, 0x21, 0x17, 0xcb, 0x00},
{  640,  480, 140, 0x67, 0x4f, 0x4f, 0x8b, 0x54, 0x9d, 0x07, 0x3e, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0x08, 0x20, 0x00, 0x4f, 0x21, 0x22, 0xae, 0x00},
{  640,  480, 160, 0x67, 0x4f, 0x4f, 0x8b, 0x54, 0x9d, 0x0d, 0x3e, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0x0e, 0x20, 0x00, 0x4f, 0x21, 0x24, 0x36, 0x00},
{  720,  480,  60, 0x6b, 0x59, 0x59, 0x8f, 0x5b, 0x8a, 0x0b, 0x3e, 0x40, 0xe9,
	0x2b, 0xdf, 0xdf, 0x0c, 0xa0, 0x00, 0xcf, 0x21, 0xfc, 0x7e, 0x00},
{  720,  480,  72, 0x6e, 0x59, 0x59, 0x92, 0x5b, 0x8c, 0x06, 0x3e, 0x40, 0xe8,
	0x2b, 0xdf, 0xdf, 0x07, 0xa0, 0x00, 0xcf, 0x21, 0xc9, 0xfb, 0x00},
{  720,  480,  85, 0x70, 0x59, 0x59, 0x94, 0x61, 0x89, 0xfb, 0x1f, 0x40, 0xe0,
	0x23, 0xdf, 0xdf, 0xfc, 0xa0, 0x00, 0xcf, 0x21, 0x1b, 0xb3, 0x00},
{  720,  576,  72, 0x70, 0x59, 0x59, 0x94, 0x5d, 0x89, 0x80, 0xf0, 0x60, 0x41,
	0x25, 0x3f, 0x3f, 0x81, 0xa0, 0x00, 0x0f, 0x21, 0x2a, 0x8f, 0x00},
{  720,  576, 100, 0x70, 0x59, 0x59, 0x94, 0x5d, 0x89, 0x80, 0xf0, 0x60, 0x41,
	0x25, 0x3f, 0x3f, 0x81, 0xa0, 0x00, 0x0f, 0x21, 0x17, 0xe9, 0x00},
{  800,  600,  56, 0x7b, 0x63, 0x63, 0x9f, 0x66, 0x8f, 0x6f, 0xf0, 0x60, 0x58,
	0x2a, 0x57, 0x57, 0x70, 0xa0, 0x00, 0x0f, 0x21, 0x85, 0xae, 0x00},
//{  800,  600,  60, 0x7f, 0x63, 0x63, 0x83, 0x68, 0x18, 0x72, 0xf0, 0x60, 0x58,
//  0x2c, 0x57, 0x57, 0x73, 0x80, 0x00, 0x0f, 0x21, 0x26, 0x79, 0x00},
{  800,  600,  60, 0xa3, 0x63, 0x70, 0x98, 0x74, 0x06, 0x20, 0xf1, 0x60, 0xa0,
   0x0d, 0x57, 0xa0, 0xc1, 0x00, 0x00, 0xcf, 0x21, 0x29, 0x6b, 0x00},
{  800,  600,  72, 0x7d, 0x63, 0x63, 0x81, 0x6a, 0x19, 0x98, 0xf0, 0x60, 0x7c,
	0x22, 0x57, 0x57, 0x99, 0x80, 0x00, 0x0f, 0x21, 0x1f, 0xf9, 0x00},
{  800,  600,  75, 0x7f, 0x63, 0x63, 0x83, 0x65, 0x0f, 0x6f, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x70, 0x80, 0x00, 0x0f, 0x21, 0x1f, 0xf7, 0x00},
{  800,  600,  85, 0x7e, 0x63, 0x63, 0x82, 0x67, 0x0f, 0x75, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x76, 0x80, 0x00, 0x0f, 0x21, 0x17, 0xda, 0x00},
{  800,  600, 100, 0x81, 0x63, 0x63, 0x85, 0x69, 0x14, 0x7a, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x7b, 0x80, 0x00, 0x4f, 0x21, 0x2a, 0xe3, 0x00},
{  800,  600, 120, 0x83, 0x63, 0x63, 0x87, 0x6a, 0x15, 0x81, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x82, 0x80, 0x00, 0x4f, 0x21, 0x1e, 0xd1, 0x00},
{  800,  600, 140, 0x83, 0x63, 0x63, 0x87, 0x6a, 0x15, 0x89, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x8a, 0x80, 0x00, 0x4f, 0x21, 0x15, 0x5f, 0x00},
{  800,  600, 160, 0x85, 0x63, 0x63, 0x89, 0x6b, 0x16, 0x91, 0xf0, 0x60, 0x58,
	0x2b, 0x57, 0x57, 0x92, 0x80, 0x00, 0x4f, 0x21, 0x29, 0xc1, 0x00},
//{  960,  720,  60, 0x97, 0x77, 0x77, 0x9b, 0x7d, 0x09, 0xe8, 0xf0, 0x60, 0xd0,
//	0x23, 0xcf, 0xcf, 0xe9, 0x00, 0x00, 0x4f, 0x21, 0x22, 0x9a, 0x00},
{  960,  720,  60, 0xa3, 0x77, 0x80, 0xa5, 0x80, 0x94, 0x24, 0xf5, 0x60, 0x00,
   0x09, 0xd0, 0xf0, 0x16, 0x00, 0x00, 0x4f, 0x21, 0x07, 0x6b, 0x00},
{  960,  720,  75, 0x9b, 0x77, 0x77, 0x9f, 0x7e, 0x0b, 0xee, 0xf0, 0x60, 0xd0,
	0x23, 0xcf, 0xcf, 0xef, 0x00, 0x00, 0x4f, 0x21, 0x29, 0x77, 0x00},
{  960,  720,  85, 0x9b, 0x77, 0x77, 0x9f, 0x7e, 0x0b, 0xf2, 0xf0, 0x60, 0xd0,
	0x23, 0xcf, 0xcf, 0xf3, 0x00, 0x00, 0x4f, 0x21, 0x21, 0x71, 0x00},
{ 1024,  768,  60, 0xa3, 0x7f, 0x7f, 0x87, 0x82, 0x93, 0x24, 0xf5, 0x60, 0x02,
	0x28, 0xff, 0xff, 0x25, 0x00, 0x00, 0xcf, 0x21, 0x29, 0x6b, 0x00},
{ 1024,  768,  70, 0xa1, 0x7f, 0x7f, 0x85, 0x82, 0x93, 0x24, 0xf5, 0x60, 0x02,
	0x28, 0xff, 0xff, 0x25, 0x00, 0x00, 0xcf, 0x21, 0x2a, 0xf9, 0x00},
{ 1024,  768,  75, 0x9f, 0x7f, 0x7f, 0x83, 0x81, 0x8d, 0x1e, 0xf5, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x0f, 0x21, 0x25, 0x77, 0x00},
{ 1024,  768,  85, 0xa7, 0x7f, 0x7f, 0x8b, 0x85, 0x91, 0x26, 0xf5, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x27, 0x00, 0x00, 0x0f, 0x21, 0x20, 0x40, 0x00},
{ 1024,  768, 100, 0xa9, 0x7f, 0x7f, 0x8d, 0x88, 0x96, 0x2c, 0xf5, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x2d, 0x00, 0x00, 0x4f, 0x21, 0x28, 0x5d, 0x00},
{ 1024,  768, 120, 0xab, 0x7f, 0x7f, 0x8f, 0x89, 0x97, 0x35, 0xf5, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x36, 0x00, 0x00, 0x4f, 0x21, 0x15, 0x86, 0x00},
{ 1152,  864,  60, 0xb3, 0x8f, 0x8f, 0x97, 0x93, 0x9f, 0x87, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x88, 0x00, 0x00, 0x0f, 0x21, 0x25, 0x79, 0x00},
{ 1152,  864,  70, 0xb4, 0x8f, 0x8f, 0x98, 0x93, 0x9f, 0x8e, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x8f, 0x00, 0x00, 0x0f, 0x21, 0x20, 0x40, 0x00},
{ 1152,  864,  75, 0xc3, 0x8f, 0x8f, 0x87, 0x97, 0x07, 0x82, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x83, 0xa0, 0x00, 0x0f, 0x21, 0x29, 0xb3, 0x00},
{ 1152,  864,  85, 0xbf, 0x8f, 0x8f, 0x83, 0x97, 0x07, 0x8d, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x8e, 0xa0, 0x00, 0x0f, 0x21, 0x28, 0x64, 0x00},
{ 1152,  864, 100, 0xbf, 0x8f, 0x8f, 0x83, 0x99, 0x09, 0x91, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x92, 0xa0, 0x00, 0x4f, 0x21, 0x24, 0x6c, 0x00},
{ 1152,  864, 120, 0xc1, 0x8f, 0x8f, 0x85, 0x9a, 0x0a, 0x9c, 0xff, 0x60, 0x60,
	0x23, 0x5f, 0x5f, 0x9d, 0xa0, 0x00, 0x4f, 0x21, 0x21, 0xf4, 0x00},
{ 1280,  960,  60, 0xdc, 0x9f, 0x9f, 0x80, 0xab, 0x99, 0xe6, 0xff, 0x60, 0xc0,
	0x23, 0xbf, 0xbf, 0xe7, 0xa0, 0x00, 0x0f, 0x21, 0x29, 0xb3, 0x00},
{ 1280,  960,  75, 0xd3, 0x9f, 0x9f, 0x97, 0xaa, 0x1b, 0xe8, 0xff, 0x60, 0xc0,
	0x23, 0xbf, 0xbf, 0xe9, 0xa0, 0x00, 0x4f, 0x21, 0x15, 0x7d, 0x00},
{ 1280,  960,  85, 0xd3, 0x9f, 0x9f, 0x97, 0xa7, 0x1b, 0xf1, 0xff, 0x60, 0xc0,
	0x23, 0xbf, 0xbf, 0xf2, 0xa0, 0x00, 0x0f, 0x21, 0x18, 0x51, 0x00},
{ 1280, 1024,  60, 0xce, 0x9f, 0x9f, 0x92, 0xa5, 0x13, 0x28, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x29, 0xa0, 0x41, 0x0f, 0x21, 0x29, 0xb3, 0x00},
{ 1280, 1024,  75, 0xce, 0x9f, 0x9f, 0x92, 0xa1, 0x13, 0x28, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x29, 0xa0, 0x41, 0x0f, 0x21, 0x14, 0x40, 0x00},
{ 1280, 1024,  85, 0xd3, 0x9f, 0x9f, 0x97, 0xa7, 0x1b, 0x2e, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x2f, 0xa0, 0x41, 0x0f, 0x21, 0x24, 0x77, 0x00},
{ 1280, 1024, 100, 0x69, 0x4f, 0x4f, 0x8d, 0x55, 0x9e, 0x3b, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x3c, 0x20, 0x41, 0x4f, 0x21, 0x28, 0x9e, 0x01},
{ 1600, 1024,  60, 0x07, 0xc7, 0xc7, 0x8b, 0xd4, 0x09, 0x22, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x23, 0x81, 0x41, 0x4f, 0x21, 0x29, 0xe3, 0x00},
{ 1600, 1024,  76, 0x7e, 0x63, 0x63, 0x82, 0x65, 0x0f, 0x2c, 0x5a, 0x60, 0x02,
	0x25, 0xff, 0xff, 0x2d, 0x80, 0x41, 0xcf, 0x21, 0x21, 0xec, 0x01},
{ 1600, 1024,  85, 0x83, 0x63, 0x63, 0x87, 0x6a, 0x15, 0x31, 0x5a, 0x60, 0x00,
	0x23, 0xff, 0xff, 0x32, 0x80, 0x41, 0x4f, 0x21, 0x1d, 0xf8, 0x01},
{ 1600, 1200,  60, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x19, 0xb3, 0x01},
{ 1600, 1200,  65, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x28, 0x91, 0x01},
{ 1600, 1200,  70, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x20, 0x82, 0x01},
{ 1600, 1200,  75, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x14, 0x61, 0x01},
{ 1600, 1200,  80, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x11, 0xb3, 0x01},
{ 1600, 1200,  85, 0x82, 0x63, 0x63, 0x86, 0x67, 0x13, 0xe0, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xe1, 0x80, 0x55, 0x0f, 0x21, 0x0c, 0x4e, 0x01},
{ 1600, 1200, 100, 0x85, 0x63, 0x63, 0x89, 0x6b, 0x16, 0xf5, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xf6, 0x80, 0x55, 0x4f, 0x21, 0x0c, 0x60, 0x01},
{ 1792, 1344,  60, 0x94, 0x6f, 0x6f, 0x98, 0x77, 0x04, 0x70, 0x1f, 0x40, 0x40,
	0x23, 0x3f, 0x3f, 0x71, 0x00, 0x55, 0x4f, 0x21, 0x0d, 0x8d, 0x01},
{ 1792, 1344,  75, 0x95, 0x6f, 0x6f, 0x99, 0x75, 0x03, 0x87, 0x1f, 0x40, 0x40,
	0x23, 0x3f, 0x3f, 0x88, 0x00, 0x55, 0x4f, 0x21, 0x15, 0xfd, 0x01},
{ 1856, 1392,  60, 0x99, 0x73, 0x73, 0x9d, 0x79, 0x07, 0x9d, 0x1f, 0x40, 0x70,
	0x23, 0x6f, 0x6f, 0x9e, 0x00, 0x55, 0x4f, 0x21, 0x11, 0xb5, 0x01},
{ 1856, 1392,  75, 0x9b, 0x73, 0x73, 0x9f, 0x7b, 0x09, 0xda, 0x1f, 0x40, 0x70,
	0x23, 0x6f, 0x6f, 0xdb, 0x00, 0x55, 0x4f, 0x21, 0x09, 0x9f, 0x01},
{ 1920, 1080,  60, 0x23, 0xef, 0xef, 0x87, 0xf3, 0x85, 0x63, 0x10, 0x40, 0x3a,
	0x2d, 0x37, 0x37, 0x64, 0x01, 0x55, 0xcf, 0x21, 0x28, 0x84, 0x00},
{ 1920, 1080,  72, 0x9b, 0x77, 0x77, 0x9f, 0x7a, 0x08, 0x92, 0x10, 0x40, 0x3a,
	0x2d, 0x37, 0x37, 0x93, 0x00, 0x55, 0xcf, 0x21, 0x11, 0xb3, 0x01},
{ 1920, 1080,  75, 0x9e, 0x77, 0x77, 0x82, 0x7f, 0x8c, 0x66, 0x10, 0x40, 0x38,
	0x2b, 0x37, 0x37, 0x67, 0x00, 0x55, 0x4f, 0x21, 0x11, 0xb7, 0x01},
{ 1920, 1080,  85, 0x9f, 0x77, 0x77, 0x83, 0x80, 0x8d, 0x6c, 0x10, 0x40, 0x38,
	0x2b, 0x37, 0x37, 0x6d, 0x00, 0x55, 0x4f, 0x21, 0x11, 0xd2, 0x01},
{ 1920, 1200,  60, 0x9d, 0x77, 0x77, 0x81, 0x7f, 0x8c, 0xd8, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xd9, 0x00, 0x55, 0x4f, 0x21, 0x15, 0xbb, 0x01},
{ 1920, 1200,  76, 0x9c, 0x77, 0x77, 0x80, 0x7b, 0x8b, 0xe0, 0x10, 0x40, 0xb2,
	0x25, 0xaf, 0xaf, 0xe1, 0x00, 0x55, 0xcf, 0x21, 0x14, 0x76, 0x01},
{ 1920, 1200,  85, 0xa0, 0x77, 0x77, 0x84, 0x80, 0x8d, 0xea, 0x10, 0x40, 0xb0,
	0x23, 0xaf, 0xaf, 0xeb, 0x00, 0x55, 0x4f, 0x21, 0x08, 0x4d, 0x01},
{ 1920, 1440,  60, 0x9d, 0x77, 0x77, 0x81, 0x7f, 0x8c, 0xda, 0x1f, 0x40, 0xa0,
	0x23, 0x9f, 0x9f, 0xdb, 0x00, 0x55, 0x4f, 0x21, 0x10, 0x60, 0x01},
{ 1920, 1440,  75, 0xa0, 0x77, 0x77, 0x84, 0x80, 0x8e, 0xda, 0x1f, 0x40, 0xa0,
	0x23, 0x9f, 0x9f, 0xdb, 0x00, 0x55, 0x4f, 0x21, 0x08, 0x51, 0x01},
{ 2048, 1536,  60, 0x97, 0x7f, 0x7f, 0x9b, 0x82, 0x0f, 0x3b, 0xba, 0x40, 0x00,
	0x23, 0xff, 0xff, 0x3c, 0x00, 0x55, 0x0f, 0x21, 0x11, 0xc7, 0x01},
{ 2048, 1536,  75, 0xa1, 0x7f, 0x7f, 0x85, 0x83, 0x90, 0x44, 0xba, 0x40, 0x00,
	0x23, 0xff, 0xff, 0x45, 0x00, 0x55, 0x0f, 0x21, 0x10, 0x84, 0x01},
{ 2048, 1536,  85, 0x9c, 0x7f, 0x7f, 0x80, 0x7f, 0x8b, 0x30, 0x3e, 0x40, 0xff,
	0x22, 0xff, 0xff, 0x31, 0x00, 0x55, 0x0f, 0x21, 0x10, 0x8f, 0x01},

