/* -*-c++-*- */
/* $Header: h4plltable.h, 2, 10/11/00 8:58:19 PM, Brent$ */
/*
** Copyright (c) 1995, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished  -
** rights reserved under the Copyright Laws of the United States.
**
**
** $Revision: 2$
** $Date: 10/11/00 8:58:19 PM$
**
** $History: h4plltable.h $
** 
** *****************  Version 2  *****************
** User: Bob          Date: 3/04/99    Time: 5:19p
** Updated in $/devel/h3/WinNT/src/Video/Miniport/Voodoo3
** PRS 4331
** 
** Glide requires that the registry settings for Glide_*, FX_*, and
** SSTH3_OVERLAY_FILTER_2X2 variables appear in device node 3Dfx, rather
** than the Voodoo3 node.
** 
** Removed dependence on H3 PLL table, since we no longer use it.
** 
** Removed old 3Dfx mode lists from h3data.c, and included default gamma
** table for instances where registry entry is absent. Names for the mode
** structures are now H4*, to reflect the new reality.
** 
** *****************  Version 1  *****************
** User: Bob          Date: 11/17/98   Time: 2:34p
** Created in $/devel/h3/WinNT/src/Video/Miniport/h3
** Restructured clock control to separate the clocks for Banshee and
** Avenger.  This addition must be used with the checkin occuring on the
** same day.
**
*/

//
// generated by gen_plltable.pl at Thu Nov	5 12:38:23 1998
//
ULONG H4oempllTable[] = {
	NO_CLOCK,	 //  0 MHz -- Invalid clock setting
	NO_CLOCK,	 //  1 MHz -- Invalid clock setting
	NO_CLOCK,	 //  2 MHz -- Invalid clock setting
	NO_CLOCK,	 //  3 MHz -- Invalid clock setting
	NO_CLOCK,	 //  4 MHz -- Invalid clock setting
	NO_CLOCK,	 //  5 MHz -- Invalid clock setting
	NO_CLOCK,	 //  6 MHz -- Invalid clock setting
	NO_CLOCK,	 //  7 MHz -- Invalid clock setting
	NO_CLOCK,	 //  8 MHz -- Invalid clock setting
	NO_CLOCK,	 //  9 MHz -- Invalid clock setting
	NO_CLOCK,	 // 10 MHz -- Invalid clock setting
	NO_CLOCK,	 // 11 MHz -- Invalid clock setting
	NO_CLOCK,	 // 12 MHz -- Invalid clock setting
	NO_CLOCK,	 // 13 MHz -- Invalid clock setting
	NO_CLOCK,	 // 14 MHz -- Invalid clock setting
	NO_CLOCK,	 // 15 MHz -- Invalid clock setting
	NO_CLOCK,	 // 16 MHz -- Invalid clock setting
	NO_CLOCK,	 // 17 MHz -- Invalid clock setting
	NO_CLOCK,	 // 18 MHz -- Invalid clock setting
	NO_CLOCK,	 // 19 MHz -- Invalid clock setting
	NO_CLOCK,	 // 20 MHz -- Invalid clock setting
	NO_CLOCK,	 // 21 MHz -- Invalid clock setting
	NO_CLOCK,	 // 22 MHz -- Invalid clock setting
	NO_CLOCK,	 // 23 MHz -- Invalid clock setting
	NO_CLOCK,	 // 24 MHz -- Invalid clock setting
	NO_CLOCK,	 // 25 MHz -- Invalid clock setting
	NO_CLOCK,	 // 26 MHz -- Invalid clock setting
	NO_CLOCK,	 // 27 MHz -- Invalid clock setting
	NO_CLOCK,	 // 28 MHz -- Invalid clock setting
	NO_CLOCK,	 // 29 MHz -- Invalid clock setting

//	   pllCtrl        n   m   k actual(MHz)
//	   -------      --- --- --- -----------
	0x00003460,  //  52  24   0 29.737758
	0x00003660,  //  54  24   0 30.839157
	0x00003860,  //  56  24   0 31.940555
	0x00003A60,  //  58  24   0 33.041954
	0x00003C60,  //  60  24   0 34.143352
	0x00003E60,  //  62  24   0 35.244751
	0x00003F60,  //  63  24   0 35.795450
	0x00004160,  //  65  24   0 36.896848
	0x00004360,  //  67  24   0 37.998247
	0x00004560,  //  69  24   0 39.099645
	0x00004760,  //  71  24   0 40.201044
	0x00004860,  //  72  24   0 40.751743
	0x00004A60,  //  74  24   0 41.853142
	0x00004C60,  //  76  24   0 42.954540
	0x00004E60,  //  78  24   0 44.055938
	0x00005060,  //  80  24   0 45.157337
	0x00005260,  //  82  24   0 46.258735
	0x00005360,  //  83  24   0 46.809435
	0x00005560,  //  85  24   0 47.910833
	0x00005760,  //  87  24   0 49.012232
	0x00005960,  //  89  24   0 50.113630
	0x00005B60,  //  91  24   0 51.215028
	0x00005C60,  //  92  24   0 51.765728
	0x00005E60,  //  94  24   0 52.867126
	0x00006060,  //  96  24   0 53.968525
	0x00006260,  //  98  24   0 55.069923
	0x00006460,  // 100  24   0 56.171322
	0x00006660,  // 102  24   0 57.272720
	0x00006760,  // 103  24   0 57.823419
	0x00006960,  // 105  24   0 58.924818
	0x00006B60,  // 107  24   0 60.026216
	0x00006D60,  // 109  24   0 61.127615
	0x00006F60,  // 111  24   0 62.229013
	0x00007060,  // 112  24   0 62.779712
	0x00007260,  // 114  24   0 63.881111
	0x00007460,  // 116  24   0 64.982509
	0x00007660,  // 118  24   0 66.083908
	0x00007860,  // 120  24   0 67.185306
	0x00007960,  // 121  24   0 67.736005
	0x00007B60,  // 123  24   0 68.837404
	0x00007D60,  // 125  24   0 69.938802
	0x00007F60,  // 127  24   0 71.040201
	0x00008160,  // 129  24   0 72.141599
	0x00008360,  // 131  24   0 73.242998
	0x00008460,  // 132  24   0 73.793697
	0x00008660,  // 134  24   0 74.895095
	0x00008860,  // 136  24   0 75.996494
	0x00008A60,  // 138  24   0 77.097892
	0x00008C60,  // 140  24   0 78.199291
	0x00008D60,  // 141  24   0 78.749990
	0x00008F60,  // 143  24   0 79.851388
	0x00009160,  // 145  24   0 80.952787
	0x00009360,  // 147  24   0 82.054185
	0x00009560,  // 149  24   0 83.155584
	0x00009760,  // 151  24   0 84.256982
	0x00009860,  // 152  24   0 84.807682
	0x00009A60,  // 154  24   0 85.909080
	0x00009C60,  // 156  24   0 87.010478
	0x00009E60,  // 158  24   0 88.111877
	0x0000A060,  // 160  24   0 89.213275
	0x0000A160,  // 161  24   0 89.763975
	0x0000A360,  // 163  24   0 90.865373
	0x0000A560,  // 165  24   0 91.966772
	0x0000A760,  // 167  24   0 93.068170
	0x0000A960,  // 169  24   0 94.169568
	0x0000AB60,  // 171  24   0 95.270967
	0x0000AC60,  // 172  24   0 95.821666
	0x0000AE60,  // 174  24   0 96.923065
	0x0000B060,  // 176  24   0 98.024463
	0x0000B260,  // 178  24   0 99.125862
	0x0000B460,  // 180  24   0 100.227260
	0x0000B560,  // 181  24   0 100.777959
	0x0000B760,  // 183  24   0 101.879358
	0x0000B960,  // 185  24   0 102.980756
	0x0000BB60,  // 187  24   0 104.082155
	0x0000BD60,  // 189  24   0 105.183553
	0x0000BE60,  // 190  24   0 105.734252
	0x0000C060,  // 192  24   0 106.835651
	0x0000C260,  // 194  24   0 107.937049
	0x0000C460,  // 196  24   0 109.038448
	0x0000C660,  // 198  24   0 110.139846
	0x0000C860,  // 200  24   0 111.241245
	0x0000C960,  // 201  24   0 111.791944
	0x0000CB60,  // 203  24   0 112.893342
	0x0000CD60,  // 205  24   0 113.994741
	0x0000CF60,  // 207  24   0 115.096139
	0x0000D160,  // 209  24   0 116.197538
	0x0000D260,  // 210  24   0 116.748237
	0x0000D460,  // 212  24   0 117.849635
	0x0000D660,  // 214  24   0 118.951034
	0x0000D860,  // 216  24   0 120.052432
	0x0000DA60,  // 218  24   0 121.153831
	0x0000DC60,  // 220  24   0 122.255229
	0x0000DD60,  // 221  24   0 122.805928
	0x0000DF60,  // 223  24   0 123.907327
	0x0000E160,  // 225  24   0 125.008725
	0x0000E360,  // 227  24   0 126.110124
	0x0000E560,  // 229  24   0 127.211522
	0x0000E660,  // 230  24   0 127.762222
	0x0000E860,  // 232  24   0 128.863620
	0x0000EA60,  // 234  24   0 129.965018
	0x0000EC60,  // 236  24   0 131.066417
	0x0000EE60,  // 238  24   0 132.167815
	0x0000F060,  // 240  24   0 133.269214
	0x0000F160,  // 241  24   0 133.819913
	0x0000F360,  // 243  24   0 134.921312
	0x0000F560,  // 245  24   0 136.022710
	0x0000F760,  // 247  24   0 137.124108
	0x0000F960,  // 249  24   0 138.225507
	0x0000FA60,  // 250  24   0 138.776206
	0x0000FC60,  // 252  24   0 139.877605
	0x0000FE60,  // 254  24   0 140.979003
	0x00007528,  // 117  10   0 141.988618
	0x00001200,  //  18   0   0 143.181800
	0x0000B340,  // 179  16   0 143.977254
	0x00004F18,  //  79   6   0 144.971573
	0x0000310C,  //  49   3   0 146.045436
	0x00009834,  // 152  13   0 146.999981
	0x00001D04,  //  29   1   0 147.954527
	0x0000E350,  // 227  20   0 149.039237
	0x0000DA4C,  // 218  19   0 149.999981
	0x00007224,  // 114   9   0 150.991716
	0x0000882C,  // 136  11   0 151.992988
	0x0000C944,  // 201  17   0 152.978449
	0x00002908,  //  41   2   0 153.920435
	0x0000F754,  // 247  21   0 155.009862
	0x0000CD44,  // 205  17   0 155.992803
	0x0000FA54,  // 250  21   0 156.877450
	0x0000FC54,  // 252  21   0 158.122510
	0x0000D144,  // 209  17   0 159.007157
	0x0000BC3C,  // 188  15   0 160.026718
	0x00002B08,  //  43   2   0 161.079525
	0x0000D544,  // 213  17   0 162.021511
	0x0000922C,  // 146  11   0 163.006972
	0x00007C24,  // 124   9   0 164.008244
	0x0000F04C,  // 240  19   0 164.999979
	0x0000FD50,  // 253  20   0 165.960723
	0x00002104,  //  33   1   0 167.045433
	0x0000AE34,  // 174  13   0 167.999979
	0x0000390C,  //  57   3   0 168.954524
	0x00005D18,  //  93   6   0 170.028388
	0x0000D540,  // 213  16   0 171.022706
	0x00001600,  //  22   0   0 171.818160
	0x00008F28,  // 143  10   0 173.011342
	0x00009C2C,  // 156  11   0 174.020957
	0x00006C1C,  // 108   7   0 174.999978
	0x0000CF3C,  // 207  15   0 176.029389
	0x00008624,  // 134   9   0 177.024771
	0x00005514,  //  85   5   0 177.954523
	0x00001700,  //  23   0   0 178.977250
	0x00005614,  //  86   5   0 179.999977
	0x0000AF30,  // 175  12   0 181.022704
	0x00005714,  //  87   5   0 182.045431
	0x0000711C,  // 113   7   0 182.954522
	0x0000A52C,  // 165  11   0 183.933543
	0x0000A62C,  // 166  11   0 185.034942
	0x00001800,  //  24   0   0 186.136340
	0x0000DC3C,  // 220  15   0 186.978586
	0x0000C334,  // 195  13   0 188.045431
	0x0000400C,  //  64   3   0 188.999976
	0x00009024,  // 144   9   0 190.041298
	0x00002604,  //  38   1   0 190.909067
	0x0000E23C,  // 226  15   0 192.032061
	0x0000FE44,  // 254  17   0 192.918636
	0x00009324,  // 147   9   0 193.946256
	0x0000AF2C,  // 175  11   0 194.947528
	0x0000D938,  // 217  14   0 195.980089
	0x0000E83C,  // 232  15   0 197.085536
	0x00005110,  //  81   4   0 198.068157
	0x00008920,  // 137   8   0 199.022702
	0x0000F940,  // 249  16   0 199.659066
	0x0000FB40,  // 251  16   0 201.249974
	0x00007D1C,  // 125   7   0 202.045429
	0x0000EF3C,  // 239  15   0 202.981258
	0x00003708,  //  55   2   0 204.034065
	0x0000E338,  // 227  14   0 204.928951
	0x0000B92C,  // 185  11   0 205.961512
	0x00009D24,  // 157   9   0 206.962784
	0x0000F53C,  // 245  15   0 208.034733
	0x0000470C,  //  71   3   0 209.045428
	0x00002A04,  //  42   1   0 209.999973
	0x0000DB34,  // 219  13   0 210.954519
	0x0000EB38,  // 235  14   0 212.088041
	0x00007518,  // 117   6   0 212.982927
	0x0000FC3C,  // 252  15   0 213.930454
	0x00001C00,  //  28   0   0 214.772700
	0x0000B328,  // 179  10   0 215.965882
	0x0000C32C,  // 195  11   0 216.975497
	0x0000871C,  // 135   7   0 217.954518
	0x00009720,  // 151   8   0 219.068154
	0x0000A724,  // 167   9   0 219.979311
};

//
// generated by gen_plltable_at.pl at Sun Nov 15 14:16:18 1998
//
ULONG H4pllTable[] = {
	NO_CLOCK,	 //  0 MHz -- Invalid clock setting
	NO_CLOCK,	 //  1 MHz -- Invalid clock setting
	NO_CLOCK,	 //  2 MHz -- Invalid clock setting
	NO_CLOCK,	 //  3 MHz -- Invalid clock setting
	NO_CLOCK,	 //  4 MHz -- Invalid clock setting
	NO_CLOCK,	 //  5 MHz -- Invalid clock setting
	NO_CLOCK,	 //  6 MHz -- Invalid clock setting
	NO_CLOCK,	 //  7 MHz -- Invalid clock setting
	NO_CLOCK,	 //  8 MHz -- Invalid clock setting
	NO_CLOCK,	 //  9 MHz -- Invalid clock setting
	NO_CLOCK,	 // 10 MHz -- Invalid clock setting
	NO_CLOCK,	 // 11 MHz -- Invalid clock setting
	NO_CLOCK,	 // 12 MHz -- Invalid clock setting
	NO_CLOCK,	 // 13 MHz -- Invalid clock setting
	NO_CLOCK,	 // 14 MHz -- Invalid clock setting
	NO_CLOCK,	 // 15 MHz -- Invalid clock setting
	NO_CLOCK,	 // 16 MHz -- Invalid clock setting
	NO_CLOCK,	 // 17 MHz -- Invalid clock setting
	NO_CLOCK,	 // 18 MHz -- Invalid clock setting
	NO_CLOCK,	 // 19 MHz -- Invalid clock setting
	NO_CLOCK,	 // 20 MHz -- Invalid clock setting
	NO_CLOCK,	 // 21 MHz -- Invalid clock setting
	NO_CLOCK,	 // 22 MHz -- Invalid clock setting
	NO_CLOCK,	 // 23 MHz -- Invalid clock setting
	NO_CLOCK,	 // 24 MHz -- Invalid clock setting
	NO_CLOCK,	 // 25 MHz -- Invalid clock setting
	NO_CLOCK,	 // 26 MHz -- Invalid clock setting
	NO_CLOCK,	 // 27 MHz -- Invalid clock setting
	NO_CLOCK,	 // 28 MHz -- Invalid clock setting
	NO_CLOCK,	 // 29 MHz -- Invalid clock setting

//	   pllCtrl        n   m   k actual(MHz)
//	   -------      --- --- --- -----------
	0x00000B05,  //  11   1   1 31.022723
	0x00000B05,  //  11   1   1 31.022723
	0x00000B05,  //  11   1   1 31.022723
	0x00000C05,  //  12   1   1 33.409087
	0x00000C05,  //  12   1   1 33.409087
	0x00000D05,  //  13   1   1 35.795450
	0x00000D05,  //  13   1   1 35.795450
	0x00000E05,  //  14   1   1 38.181813
	0x00000E05,  //  14   1   1 38.181813
	0x00000E05,  //  14   1   1 38.181813
	0x00000F05,  //  15   1   1 40.568177
	0x00000F05,  //  15   1   1 40.568177
	0x00001005,  //  16   1   1 42.954540
	0x00001005,  //  16   1   1 42.954540
	0x00001005,  //  16   1   1 42.954540
	0x00001105,  //  17   1   1 45.340903
	0x00001105,  //  17   1   1 45.340903
	0x00001205,  //  18   1   1 47.727267
	0x00001205,  //  18   1   1 47.727267
	0x00001305,  //  19   1   1 50.113630
	0x00001305,  //  19   1   1 50.113630
	0x00001305,  //  19   1   1 50.113630
	0x00001405,  //  20   1   1 52.499993
	0x00001405,  //  20   1   1 52.499993
	0x00001505,  //  21   1   1 54.886357
	0x00001505,  //  21   1   1 54.886357
	0x00001505,  //  21   1   1 54.886357
	0x00001605,  //  22   1   1 57.272720
	0x00001605,  //  22   1   1 57.272720
	0x00001705,  //  23   1   1 59.659083
	0x00001705,  //  23   1   1 59.659083
	0x00001805,  //  24   1   1 62.045447
	0x00001805,  //  24   1   1 62.045447
	0x00001805,  //  24   1   1 62.045447
	0x00001905,  //  25   1   1 64.431810
	0x00001905,  //  25   1   1 64.431810
	0x00001A05,  //  26   1   1 66.818173
	0x00001A05,  //  26   1   1 66.818173
	0x00001A05,  //  26   1   1 66.818173
	0x00001B05,  //  27   1   1 69.204537
	0x00001B05,  //  27   1   1 69.204537
	0x00001C05,  //  28   1   1 71.590900
	0x00001C05,  //  28   1   1 71.590900
	0x00001D05,  //  29   1   1 73.977263
	0x00001D05,  //  29   1   1 73.977263
	0x00001D05,  //  29   1   1 73.977263
	0x00001E05,  //  30   1   1 76.363627
	0x00001E05,  //  30   1   1 76.363627
	0x00001F05,  //  31   1   1 78.749990
	0x00001F05,  //  31   1   1 78.749990
	0x00002005,  //  32   1   1 81.136353
	0x00002005,  //  32   1   1 81.136353
	0x00002005,  //  32   1   1 81.136353
	0x00002105,  //  33   1   1 83.522717
	0x00002105,  //  33   1   1 83.522717
	0x00002205,  //  34   1   1 85.909080
	0x00002205,  //  34   1   1 85.909080
	0x00002205,  //  34   1   1 85.909080
	0x00002305,  //  35   1   1 88.295443
	0x00002305,  //  35   1   1 88.295443
	0x00002405,  //  36   1   1 90.681807
	0x00002405,  //  36   1   1 90.681807
	0x00002505,  //  37   1   1 93.068170
	0x00002505,  //  37   1   1 93.068170
	0x00002505,  //  37   1   1 93.068170
	0x00002605,  //  38   1   1 95.454533
	0x00002605,  //  38   1   1 95.454533
	0x00002705,  //  39   1   1 97.840897
	0x00002705,  //  39   1   1 97.840897
	0x00002705,  //  39   1   1 97.840897
	0x00002805,  //  40   1   1 100.227260
	0x00002805,  //  40   1   1 100.227260
	0x00002905,  //  41   1   1 102.613623
	0x00002905,  //  41   1   1 102.613623
	0x00002A05,  //  42   1   1 104.999987
	0x00002A05,  //  42   1   1 104.999987
	0x00002A05,  //  42   1   1 104.999987
	0x00002B05,  //  43   1   1 107.386350
	0x00002B05,  //  43   1   1 107.386350
	0x00002C05,  //  44   1   1 109.772713
	0x00002C05,  //  44   1   1 109.772713
	0x00002D05,  //  45   1   1 112.159077
	0x00002D05,  //  45   1   1 112.159077
	0x00002D05,  //  45   1   1 112.159077
	0x00002E05,  //  46   1   1 114.545440
	0x00002E05,  //  46   1   1 114.545440
	0x00002F05,  //  47   1   1 116.931803
	0x00002F05,  //  47   1   1 116.931803
	0x00002F05,  //  47   1   1 116.931803
	0x00003005,  //  48   1   1 119.318167
	0x00003005,  //  48   1   1 119.318167
	0x00003105,  //  49   1   1 121.704530
	0x00003105,  //  49   1   1 121.704530
	0x00003205,  //  50   1   1 124.090893
	0x00003205,  //  50   1   1 124.090893
	0x00003205,  //  50   1   1 124.090893
	0x00003305,  //  51   1   1 126.477257
	0x00003305,  //  51   1   1 126.477257
	0x00003405,  //  52   1   1 128.863620
	0x00003405,  //  52   1   1 128.863620
	0x00003405,  //  52   1   1 128.863620
	0x00003505,  //  53   1   1 131.249983
	0x00003505,  //  53   1   1 131.249983
	0x00003605,  //  54   1   1 133.636347
	0x00003605,  //  54   1   1 133.636347
	0x00003705,  //  55   1   1 136.022710
	0x00003705,  //  55   1   1 136.022710
	0x00003705,  //  55   1   1 136.022710
	0x00003805,  //  56   1   1 138.409073
	0x00003805,  //  56   1   1 138.409073
	0x00003905,  //  57   1   1 140.795437
	0x00003905,  //  57   1   1 140.795437
	0x00003A05,  //  58   1   1 143.181800
	0x00003A05,  //  58   1   1 143.181800
	0x00003A05,  //  58   1   1 143.181800
	0x00003B05,  //  59   1   1 145.568163
	0x00003B05,  //  59   1   1 145.568163
	0x00003C05,  //  60   1   1 147.954527
	0x00003C05,  //  60   1   1 147.954527
	0x00003C05,  //  60   1   1 147.954527
	0x00003D05,  //  61   1   1 150.340890
	0x00003D05,  //  61   1   1 150.340890
	0x00003E05,  //  62   1   1 152.727253
	0x00003E05,  //  62   1   1 152.727253
	0x00003F05,  //  63   1   1 155.113617
	0x00003F05,  //  63   1   1 155.113617
	0x00003F05,  //  63   1   1 155.113617
	0x00004005,  //  64   1   1 157.499980
	0x00004005,  //  64   1   1 157.499980
	0x00004105,  //  65   1   1 159.886343
	0x00004105,  //  65   1   1 159.886343
	0x00004105,  //  65   1   1 159.886343
	0x00004205,  //  66   1   1 162.272707
	0x00004205,  //  66   1   1 162.272707
	0x00004305,  //  67   1   1 164.659070
	0x00004305,  //  67   1   1 164.659070
	0x00004405,  //  68   1   1 167.045433
	0x00004405,  //  68   1   1 167.045433
	0x00004405,  //  68   1   1 167.045433
	0x00004505,  //  69   1   1 169.431797
	0x00004505,  //  69   1   1 169.431797
	0x00004605,  //  70   1   1 171.818160
	0x00004605,  //  70   1   1 171.818160
	0x00004605,  //  70   1   1 171.818160
	0x00004705,  //  71   1   1 174.204523
	0x00004705,  //  71   1   1 174.204523
	0x00004805,  //  72   1   1 176.590887
	0x00004805,  //  72   1   1 176.590887
	0x00004905,  //  73   1   1 178.977250
	0x00004905,  //  73   1   1 178.977250
	0x00004905,  //  73   1   1 178.977250
	0x00004A05,  //  74   1   1 181.363613
	0x00004A05,  //  74   1   1 181.363613
	0x00004B05,  //  75   1   1 183.749977
	0x00004B05,  //  75   1   1 183.749977
	0x00004C05,  //  76   1   1 186.136340
	0x00004C05,  //  76   1   1 186.136340
	0x00004C05,  //  76   1   1 186.136340
	0x00004D05,  //  77   1   1 188.522703
	0x00004D05,  //  77   1   1 188.522703
	0x00004E05,  //  78   1   1 190.909067
	0x00004E05,  //  78   1   1 190.909067
	0x00004E05,  //  78   1   1 190.909067
	0x00004F05,  //  79   1   1 193.295430
	0x00004F05,  //  79   1   1 193.295430
	0x00005005,  //  80   1   1 195.681793
	0x00005005,  //  80   1   1 195.681793
	0x00005105,  //  81   1   1 198.068157
	0x00005105,  //  81   1   1 198.068157
	0x00005105,  //  81   1   1 198.068157
	0x00005205,  //  82   1   1 200.454520
	0x00005205,  //  82   1   1 200.454520
	0x00005305,  //  83   1   1 202.840883
	0x00005305,  //  83   1   1 202.840883
	0x00005305,  //  83   1   1 202.840883
	0x00005405,  //  84   1   1 205.227247
	0x00005405,  //  84   1   1 205.227247
	0x00005505,  //  85   1   1 207.613610
	0x00005505,  //  85   1   1 207.613610
	0x00005605,  //  86   1   1 209.999973
	0x00005605,  //  86   1   1 209.999973
	0x00005605,  //  86   1   1 209.999973
	0x00005705,  //  87   1   1 212.386337
	0x00005705,  //  87   1   1 212.386337
	0x00005805,  //  88   1   1 214.772700
	0x00005805,  //  88   1   1 214.772700
	0x00005905,  //  89   1   1 217.159063
	0x00005905,  //  89   1   1 217.159063
	0x00005905,  //  89   1   1 217.159063
	0x00005A05,  //  90   1   1 219.545427
	0x00005A05,  //  90   1   1 219.545427
};
