##
##  Makefile for SOLARIS
##


CC     = cc
CFLAGS = -g
LEX    = flex -Cf

LEXOBJS = tdOBJ.o
LEXSRCS = $(LEXOBJS:.o=.c)
OBJS    = tdDraw.o tdDecimate.o tdError.o tdFile.o tdGenerate.o tdMisc.o \
	  tdRGB.o \
	  tdOFF.o $(LEXOBJS)


all		: libtd.a


# dependencies	
$(OBJS)		: td.h tdPrivate.h


# rules
libtd.a		: $(OBJS)
	rm -f libtd.a
	ar cq libtd.a $(OBJS)

tdOBJ.c		: tdOBJ.l tdOBJ.h
	$(LEX) -PyyOBJ tdOBJ.l
	mv lex.yyOBJ.c $@


# default rules	
.c.o		: 
	$(CC) $(CFLAGS) -c $<

# clean
clean		: ;
	rm -f core $(LEXOBJS) $(OBJS) $(LEXSRCS) *~ #*
	rm -f libtd.a
