
/*----------------------------------------------------------------------------*/

#ifndef FLTCODE_H_
#define FLTCODE_H_

#include "fltecode.h"

/*----------------------------------------------------------------------------*/

#ifdef _WIN32

#ifdef _FLTDATA_
#define FLTACCESS __declspec(dllexport)
#else
#define FLTACCESS __declspec(dllimport) 
#endif	/* _FLTDATA_ */

#else
#define FLTACCESS extern
#endif	/* _WIN32 */

#ifdef __cplusplus
extern "C" {
#endif

FLTACCESS mgcode FltRecordCodeMap[FLT_RECORD_MAX - FLTOP_RECORD_OFFSET];
FLTACCESS mgcode FltDataCodeMap[FLT_DATA_MAX - FLTOP_DATA_OFFSET];

#ifdef __cplusplus
}
#endif

/*----------------------------------------------------------------------------*/

/* Record table index defines */
#define fltBoundingCenter (FltRecordCodeMap[eFltBoundingCenter - FLTOP_RECORD_OFFSET])
#define fltBoundingOrientation (FltRecordCodeMap[eFltBoundingOrientation - FLTOP_RECORD_OFFSET])
#define fltBoundingSphere (FltRecordCodeMap[eFltBoundingSphere - FLTOP_RECORD_OFFSET])
#define fltBoundingCylinder (FltRecordCodeMap[eFltBoundingCylinder - FLTOP_RECORD_OFFSET])
#define fltBoundingHull (FltRecordCodeMap[eFltBoundingHull - FLTOP_RECORD_OFFSET])
#define fltBHNext (FltRecordCodeMap[eFltBHNext - FLTOP_RECORD_OFFSET])
#define fltBHPnt1 (FltRecordCodeMap[eFltBHPnt1 - FLTOP_RECORD_OFFSET])
#define fltBHPnt2 (FltRecordCodeMap[eFltBHPnt2 - FLTOP_RECORD_OFFSET])
#define fltBHPnt3 (FltRecordCodeMap[eFltBHPnt3 - FLTOP_RECORD_OFFSET])
#define fltBoundingHistogram (FltRecordCodeMap[eFltBoundingHistogram - FLTOP_RECORD_OFFSET])
#define fltHistPosts (FltRecordCodeMap[eFltHistPosts - FLTOP_RECORD_OFFSET])
#define fltXrefGfxCntx (FltRecordCodeMap[eFltXrefGfxCntx - FLTOP_RECORD_OFFSET])
#define fltPolyGfxCntx (FltRecordCodeMap[eFltPolyGfxCntx - FLTOP_RECORD_OFFSET])
#define fltTxtGeoCoordData (FltRecordCodeMap[eFltTxtGeoCoordData - FLTOP_RECORD_OFFSET])
#define fltTxtGeoCoord (FltRecordCodeMap[eFltTxtGeoCoord - FLTOP_RECORD_OFFSET])
#define fltTxtGetCoordLst (FltRecordCodeMap[eFltTxtGetCoordLst - FLTOP_RECORD_OFFSET])
#define fltTGData (FltRecordCodeMap[eFltTGData - FLTOP_RECORD_OFFSET])
#define fltTGNext (FltRecordCodeMap[eFltTGNext - FLTOP_RECORD_OFFSET])
#define fltTGCoords (FltRecordCodeMap[eFltTGCoords - FLTOP_RECORD_OFFSET])
#define fltImgGeoCoords (FltRecordCodeMap[eFltImgGeoCoords - FLTOP_RECORD_OFFSET])
#define fltSound (FltRecordCodeMap[eFltSound - FLTOP_RECORD_OFFSET])
#define fltSoundPalette (FltRecordCodeMap[eFltSoundPalette - FLTOP_RECORD_OFFSET])
#define fltSndNext (FltRecordCodeMap[eFltSndNext - FLTOP_RECORD_OFFSET])
#define fltSndOffset (FltRecordCodeMap[eFltSndOffset - FLTOP_RECORD_OFFSET])
#define fltSndNormal (FltRecordCodeMap[eFltSndNormal - FLTOP_RECORD_OFFSET])
#define fltPath (FltRecordCodeMap[eFltPath - FLTOP_RECORD_OFFSET])
#define fltFCoord (FltRecordCodeMap[eFltFCoord - FLTOP_RECORD_OFFSET])
#define fltEyePoint (FltRecordCodeMap[eFltEyePoint - FLTOP_RECORD_OFFSET])
#define fltEyeRotCenter (FltRecordCodeMap[eFltEyeRotCenter - FLTOP_RECORD_OFFSET])
#define fltEyeRotMatrix (FltRecordCodeMap[eFltEyeRotMatrix - FLTOP_RECORD_OFFSET])
#define fltEyeFlyMatrix (FltRecordCodeMap[eFltEyeFlyMatrix - FLTOP_RECORD_OFFSET])
#define fltEyeLookFrom (FltRecordCodeMap[eFltEyeLookFrom - FLTOP_RECORD_OFFSET])
#define fltEyeEyeDir (FltRecordCodeMap[eFltEyeEyeDir - FLTOP_RECORD_OFFSET])
#define fltEyeImageOffset (FltRecordCodeMap[eFltEyeImageOffset - FLTOP_RECORD_OFFSET])
#define fltFPoint (FltRecordCodeMap[eFltFPoint - FLTOP_RECORD_OFFSET])
#define fltSWIfmt (FltRecordCodeMap[eFltSWIfmt - FLTOP_RECORD_OFFSET])
#define fltTerTrans (FltRecordCodeMap[eFltTerTrans - FLTOP_RECORD_OFFSET])
#define fltAmbient (FltRecordCodeMap[eFltAmbient - FLTOP_RECORD_OFFSET])
#define fltBottomLeftFront (FltRecordCodeMap[eFltBottomLeftFront - FLTOP_RECORD_OFFSET])
#define fltBoundingBox (FltRecordCodeMap[eFltBoundingBox - FLTOP_RECORD_OFFSET])
#define fltBox (FltRecordCodeMap[eFltBox - FLTOP_RECORD_OFFSET])
#define fltBsp (FltRecordCodeMap[eFltBsp - FLTOP_RECORD_OFFSET])
#define fltColorRGBA (FltRecordCodeMap[eFltColorRGBA - FLTOP_RECORD_OFFSET])
#define fltCylinder (FltRecordCodeMap[eFltCylinder - FLTOP_RECORD_OFFSET])
#define fltDPlane (FltRecordCodeMap[eFltDPlane - FLTOP_RECORD_OFFSET])
#define fltIDblInfo (FltRecordCodeMap[eFltIDblInfo - FLTOP_RECORD_OFFSET])
#define fltIDfadInfo (FltRecordCodeMap[eFltIDfadInfo - FLTOP_RECORD_OFFSET])
#define fltVDfadInfo (FltRecordCodeMap[eFltVDfadInfo - FLTOP_RECORD_OFFSET])
#define fltDiffuse (FltRecordCodeMap[eFltDiffuse - FLTOP_RECORD_OFFSET])
#define fltDof (FltRecordCodeMap[eFltDof - FLTOP_RECORD_OFFSET])
#define fltIDownBead (FltRecordCodeMap[eFltIDownBead - FLTOP_RECORD_OFFSET])
#define fltEmissive (FltRecordCodeMap[eFltEmissive - FLTOP_RECORD_OFFSET])
#define fltFMaterial (FltRecordCodeMap[eFltFMaterial - FLTOP_RECORD_OFFSET])
#define fltIFirstInstance (FltRecordCodeMap[eFltIFirstInstance - FLTOP_RECORD_OFFSET])
#define fltGfxCntx (FltRecordCodeMap[eFltGfxCntx - FLTOP_RECORD_OFFSET])
#define fltGroup (FltRecordCodeMap[eFltGroup - FLTOP_RECORD_OFFSET])
#define fltHeader (FltRecordCodeMap[eFltHeader - FLTOP_RECORD_OFFSET])
#define fltIMaterial (FltRecordCodeMap[eFltIMaterial - FLTOP_RECORD_OFFSET])
#define fltIPoint (FltRecordCodeMap[eFltIPoint - FLTOP_RECORD_OFFSET])
#define fltIbead (FltRecordCodeMap[eFltIbead - FLTOP_RECORD_OFFSET])
#define fltIcoord (FltRecordCodeMap[eFltIcoord - FLTOP_RECORD_OFFSET])
#define fltImage (FltRecordCodeMap[eFltImage - FLTOP_RECORD_OFFSET])
#define fltImgPivot (FltRecordCodeMap[eFltImgPivot - FLTOP_RECORD_OFFSET])
#define fltImgUp (FltRecordCodeMap[eFltImgUp - FLTOP_RECORD_OFFSET])
#define fltIInsert (FltRecordCodeMap[eFltIInsert - FLTOP_RECORD_OFFSET])
#define fltLightSource (FltRecordCodeMap[eFltLightSource - FLTOP_RECORD_OFFSET])
#define fltLightSourcePalette (FltRecordCodeMap[eFltLightSourcePalette - FLTOP_RECORD_OFFSET])
#define fltILinkInfo (FltRecordCodeMap[eFltILinkInfo - FLTOP_RECORD_OFFSET])
#define fltVLinkInfo (FltRecordCodeMap[eFltVLinkInfo - FLTOP_RECORD_OFFSET])
#define fltLodCenterPoint (FltRecordCodeMap[eFltLodCenterPoint - FLTOP_RECORD_OFFSET])
#define fltLod (FltRecordCodeMap[eFltLod - FLTOP_RECORD_OFFSET])
#define fltLtsPosition (FltRecordCodeMap[eFltLtsPosition - FLTOP_RECORD_OFFSET])
#define fltLtspAmbient (FltRecordCodeMap[eFltLtspAmbient - FLTOP_RECORD_OFFSET])
#define fltLtspDiffuse (FltRecordCodeMap[eFltLtspDiffuse - FLTOP_RECORD_OFFSET])
#define fltLtspSpecular (FltRecordCodeMap[eFltLtspSpecular - FLTOP_RECORD_OFFSET])
#define fltIMasterBead (FltRecordCodeMap[eFltIMasterBead - FLTOP_RECORD_OFFSET])
#define fltMatrix (FltRecordCodeMap[eFltMatrix - FLTOP_RECORD_OFFSET])
#define fltIMesh (FltRecordCodeMap[eFltIMesh - FLTOP_RECORD_OFFSET])
#define fltINextBead (FltRecordCodeMap[eFltINextBead - FLTOP_RECORD_OFFSET])
#define fltVNextBead (FltRecordCodeMap[eFltVNextBead - FLTOP_RECORD_OFFSET])
#define fltINextInstance (FltRecordCodeMap[eFltINextInstance - FLTOP_RECORD_OFFSET])
#define fltINextSelect (FltRecordCodeMap[eFltINextSelect - FLTOP_RECORD_OFFSET])
#define fltVNextSelect (FltRecordCodeMap[eFltVNextSelect - FLTOP_RECORD_OFFSET])
#define fltINextSelect2 (FltRecordCodeMap[eFltINextSelect2 - FLTOP_RECORD_OFFSET])
#define fltVNextSelect2 (FltRecordCodeMap[eFltVNextSelect2 - FLTOP_RECORD_OFFSET])
#define fltNormColor (FltRecordCodeMap[eFltNormColor - FLTOP_RECORD_OFFSET])
#define fltOSWIfmt (FltRecordCodeMap[eFltOSWIfmt - FLTOP_RECORD_OFFSET])
#define fltObject (FltRecordCodeMap[eFltObject - FLTOP_RECORD_OFFSET])
#define fltOterTrans (FltRecordCodeMap[eFltOterTrans - FLTOP_RECORD_OFFSET])
#define fltPackedColor (FltRecordCodeMap[eFltPackedColor - FLTOP_RECORD_OFFSET])
#define fltPolyColor2Rgb (FltRecordCodeMap[eFltPolyColor2Rgb - FLTOP_RECORD_OFFSET])
#define fltPolyColorRgb (FltRecordCodeMap[eFltPolyColorRgb - FLTOP_RECORD_OFFSET])
#define fltPolygon (FltRecordCodeMap[eFltPolygon - FLTOP_RECORD_OFFSET])
#define fltRecDummy (FltRecordCodeMap[eFltRecDummy - FLTOP_RECORD_OFFSET])
#define fltIRecInfo (FltRecordCodeMap[eFltIRecInfo - FLTOP_RECORD_OFFSET])
#define fltVExtInfo (FltRecordCodeMap[eFltVExtInfo - FLTOP_RECORD_OFFSET])
#define fltVRecInfo (FltRecordCodeMap[eFltVRecInfo - FLTOP_RECORD_OFFSET])
#define fltRecUndef (FltRecordCodeMap[eFltRecUndef - FLTOP_RECORD_OFFSET])
#define fltShareVtxS (FltRecordCodeMap[eFltShareVtxS - FLTOP_RECORD_OFFSET])
#define fltISoundPath (FltRecordCodeMap[eFltISoundPath - FLTOP_RECORD_OFFSET])
#define fltSpecular (FltRecordCodeMap[eFltSpecular - FLTOP_RECORD_OFFSET])
#define fltISplit (FltRecordCodeMap[eFltISplit - FLTOP_RECORD_OFFSET])
#define fltStrucrec (FltRecordCodeMap[eFltStrucrec - FLTOP_RECORD_OFFSET])
#define fltISubBead (FltRecordCodeMap[eFltISubBead - FLTOP_RECORD_OFFSET])
#define fltVSubVertex (FltRecordCodeMap[eFltVSubVertex - FLTOP_RECORD_OFFSET])
#define fltISuperBead (FltRecordCodeMap[eFltISuperBead - FLTOP_RECORD_OFFSET])
#define fltVSuperVertex (FltRecordCodeMap[eFltVSuperVertex - FLTOP_RECORD_OFFSET])
#define fltSwSwitches (FltRecordCodeMap[eFltSwSwitches - FLTOP_RECORD_OFFSET])
#define fltSwitch (FltRecordCodeMap[eFltSwitch - FLTOP_RECORD_OFFSET])
#define fltTopRightBack (FltRecordCodeMap[eFltTopRightBack - FLTOP_RECORD_OFFSET])
#define fltIUpBead (FltRecordCodeMap[eFltIUpBead - FLTOP_RECORD_OFFSET])
#define fltVUpBead (FltRecordCodeMap[eFltVUpBead - FLTOP_RECORD_OFFSET])
#define fltVNormal (FltRecordCodeMap[eFltVNormal - FLTOP_RECORD_OFFSET])
#define fltVertex (FltRecordCodeMap[eFltVertex - FLTOP_RECORD_OFFSET])
#define fltVector (FltRecordCodeMap[eFltVector - FLTOP_RECORD_OFFSET])
#define fltXformPtr (FltRecordCodeMap[eFltXformPtr - FLTOP_RECORD_OFFSET])
#define fltXmDblInfo (FltRecordCodeMap[eFltXmDblInfo - FLTOP_RECORD_OFFSET])
#define fltXmGeneral (FltRecordCodeMap[eFltXmGeneral - FLTOP_RECORD_OFFSET])
#define fltXmHeader (FltRecordCodeMap[eFltXmHeader - FLTOP_RECORD_OFFSET])
#define fltXmLimits (FltRecordCodeMap[eFltXmLimits - FLTOP_RECORD_OFFSET])
#define fltXmNext (FltRecordCodeMap[eFltXmNext - FLTOP_RECORD_OFFSET])
#define fltXmPut (FltRecordCodeMap[eFltXmPut - FLTOP_RECORD_OFFSET])
#define fltXmPutFromAlign (FltRecordCodeMap[eFltXmPutFromAlign - FLTOP_RECORD_OFFSET])
#define fltXmPutFromOrigin (FltRecordCodeMap[eFltXmPutFromOrigin - FLTOP_RECORD_OFFSET])
#define fltXmPutFromTrack (FltRecordCodeMap[eFltXmPutFromTrack - FLTOP_RECORD_OFFSET])
#define fltXmPutToAlign (FltRecordCodeMap[eFltXmPutToAlign - FLTOP_RECORD_OFFSET])
#define fltXmPutToOrigin (FltRecordCodeMap[eFltXmPutToOrigin - FLTOP_RECORD_OFFSET])
#define fltXmPutToTrack (FltRecordCodeMap[eFltXmPutToTrack - FLTOP_RECORD_OFFSET])
#define fltXmRotRefPoint1 (FltRecordCodeMap[eFltXmRotRefPoint1 - FLTOP_RECORD_OFFSET])
#define fltXmRotRefPoint2 (FltRecordCodeMap[eFltXmRotRefPoint2 - FLTOP_RECORD_OFFSET])
#define fltXmScaleRefPoint1 (FltRecordCodeMap[eFltXmScaleRefPoint1 - FLTOP_RECORD_OFFSET])
#define fltXmScaleRefPoint2 (FltRecordCodeMap[eFltXmScaleRefPoint2 - FLTOP_RECORD_OFFSET])
#define fltXmRotate (FltRecordCodeMap[eFltXmRotate - FLTOP_RECORD_OFFSET])
#define fltXmRotateAxis (FltRecordCodeMap[eFltXmRotateAxis - FLTOP_RECORD_OFFSET])
#define fltXmRotateCenter (FltRecordCodeMap[eFltXmRotateCenter - FLTOP_RECORD_OFFSET])
#define fltXmRotateEdge (FltRecordCodeMap[eFltXmRotateEdge - FLTOP_RECORD_OFFSET])
#define fltXmScale (FltRecordCodeMap[eFltXmScale - FLTOP_RECORD_OFFSET])
#define fltXmScaleCenter (FltRecordCodeMap[eFltXmScaleCenter - FLTOP_RECORD_OFFSET])
#define fltXmScalePointCenter (FltRecordCodeMap[eFltXmScalePointCenter - FLTOP_RECORD_OFFSET])
#define fltXmScaleToPoint (FltRecordCodeMap[eFltXmScaleToPoint - FLTOP_RECORD_OFFSET])
#define fltXmTranslate (FltRecordCodeMap[eFltXmTranslate - FLTOP_RECORD_OFFSET])
#define fltXmTranslateDelta (FltRecordCodeMap[eFltXmTranslateDelta - FLTOP_RECORD_OFFSET])
#define fltXmTranslateFrom (FltRecordCodeMap[eFltXmTranslateFrom - FLTOP_RECORD_OFFSET])
#define fltXref (FltRecordCodeMap[eFltXref - FLTOP_RECORD_OFFSET])

/* Data table index defines */
#define fltNlhash (FltDataCodeMap[eFltNlhash - FLTOP_DATA_OFFSET])
#define fltDofId (FltDataCodeMap[eFltDofId - FLTOP_DATA_OFFSET])
#define fltVtxType (FltDataCodeMap[eFltVtxType - FLTOP_DATA_OFFSET])
#define fltDblOrig (FltDataCodeMap[eFltDblOrig - FLTOP_DATA_OFFSET])
#define fltSoundid (FltDataCodeMap[eFltSoundid - FLTOP_DATA_OFFSET])
#define fltPathid (FltDataCodeMap[eFltPathid - FLTOP_DATA_OFFSET])
#define fltClipid (FltDataCodeMap[eFltClipid - FLTOP_DATA_OFFSET])
#define fltTextid (FltDataCodeMap[eFltTextid - FLTOP_DATA_OFFSET])
#define fltBspid (FltDataCodeMap[eFltBspid - FLTOP_DATA_OFFSET])
#define fltSwitchid (FltDataCodeMap[eFltSwitchid - FLTOP_DATA_OFFSET])
#define fltLtsrcid (FltDataCodeMap[eFltLtsrcid - FLTOP_DATA_OFFSET])
#define fltLtpntid (FltDataCodeMap[eFltLtpntid - FLTOP_DATA_OFFSET])
#define fltRoadid (FltDataCodeMap[eFltRoadid - FLTOP_DATA_OFFSET])
#define fltCatid (FltDataCodeMap[eFltCatid - FLTOP_DATA_OFFSET])
#define fltBYaw (FltDataCodeMap[eFltBYaw - FLTOP_DATA_OFFSET])
#define fltBPitch (FltDataCodeMap[eFltBPitch - FLTOP_DATA_OFFSET])
#define fltBRoll (FltDataCodeMap[eFltBRoll - FLTOP_DATA_OFFSET])
#define fltBSRadius (FltDataCodeMap[eFltBSRadius - FLTOP_DATA_OFFSET])
#define fltBCRadius (FltDataCodeMap[eFltBCRadius - FLTOP_DATA_OFFSET])
#define fltBCHeight (FltDataCodeMap[eFltBCHeight - FLTOP_DATA_OFFSET])
#define fltNumXincs (FltDataCodeMap[eFltNumXincs - FLTOP_DATA_OFFSET])
#define fltNumYincs (FltDataCodeMap[eFltNumYincs - FLTOP_DATA_OFFSET])
#define fltPlateauFunc (FltDataCodeMap[eFltPlateauFunc - FLTOP_DATA_OFFSET])
#define fltLodSpecial1 (FltDataCodeMap[eFltLodSpecial1 - FLTOP_DATA_OFFSET])
#define fltLodSpecial2 (FltDataCodeMap[eFltLodSpecial2 - FLTOP_DATA_OFFSET])
#define fltPolyFlagFootprint (FltDataCodeMap[eFltPolyFlagFootprint - FLTOP_DATA_OFFSET])
#define fltPolyFlagHidden (FltDataCodeMap[eFltPolyFlagHidden - FLTOP_DATA_OFFSET])
#define fltPolyTexmap (FltDataCodeMap[eFltPolyTexmap - FLTOP_DATA_OFFSET])
#define fltPolyTexmap1 (FltDataCodeMap[eFltPolyTexmap1 - FLTOP_DATA_OFFSET])
#define fltPolyPrimeColor (FltDataCodeMap[eFltPolyPrimeColor - FLTOP_DATA_OFFSET])
#define fltPolyPrimeIntensity (FltDataCodeMap[eFltPolyPrimeIntensity - FLTOP_DATA_OFFSET])
#define fltPolyAltColor (FltDataCodeMap[eFltPolyAltColor - FLTOP_DATA_OFFSET])
#define fltPolyAltIntensity (FltDataCodeMap[eFltPolyAltIntensity - FLTOP_DATA_OFFSET])
#define fltImgFocalLength (FltDataCodeMap[eFltImgFocalLength - FLTOP_DATA_OFFSET])
#define fltImgPixelScale (FltDataCodeMap[eFltImgPixelScale - FLTOP_DATA_OFFSET])
#define fltImgPrinciplePtx (FltDataCodeMap[eFltImgPrinciplePtx - FLTOP_DATA_OFFSET])
#define fltImgPrinciplePty (FltDataCodeMap[eFltImgPrinciplePty - FLTOP_DATA_OFFSET])
#define fltImgLon0 (FltDataCodeMap[eFltImgLon0 - FLTOP_DATA_OFFSET])
#define fltImgLat0 (FltDataCodeMap[eFltImgLat0 - FLTOP_DATA_OFFSET])
#define fltImgLat1 (FltDataCodeMap[eFltImgLat1 - FLTOP_DATA_OFFSET])
#define fltImgLat2 (FltDataCodeMap[eFltImgLat2 - FLTOP_DATA_OFFSET])
#define fltNpscale (FltDataCodeMap[eFltNpscale - FLTOP_DATA_OFFSET])
#define fltImgProjection (FltDataCodeMap[eFltImgProjection - FLTOP_DATA_OFFSET])
#define fltImgEarthModel (FltDataCodeMap[eFltImgEarthModel - FLTOP_DATA_OFFSET])
#define fltImgCameraType (FltDataCodeMap[eFltImgCameraType - FLTOP_DATA_OFFSET])
#define fltImgUTMzone (FltDataCodeMap[eFltImgUTMzone - FLTOP_DATA_OFFSET])
#define fltImgImageOrigin (FltDataCodeMap[eFltImgImageOrigin - FLTOP_DATA_OFFSET])
#define fltImgUnits (FltDataCodeMap[eFltImgUnits - FLTOP_DATA_OFFSET])
#define fltPixelScaleUnits (FltDataCodeMap[eFltPixelScaleUnits - FLTOP_DATA_OFFSET])
#define fltImgFocalLengthUnits (FltDataCodeMap[eFltImgFocalLengthUnits - FLTOP_DATA_OFFSET])
#define fltImgHemisphere (FltDataCodeMap[eFltImgHemisphere - FLTOP_DATA_OFFSET])
#define fltImgFalseEasting (FltDataCodeMap[eFltImgFalseEasting - FLTOP_DATA_OFFSET])
#define fltImgFalseNorthing (FltDataCodeMap[eFltImgFalseNorthing - FLTOP_DATA_OFFSET])
#define fltMirrorSmoothFlags (FltDataCodeMap[eFltMirrorSmoothFlags - FLTOP_DATA_OFFSET])
#define fltImgVersion (FltDataCodeMap[eFltImgVersion - FLTOP_DATA_OFFSET])
#define fltSndIndex (FltDataCodeMap[eFltSndIndex - FLTOP_DATA_OFFSET])
#define fltSndOrder (FltDataCodeMap[eFltSndOrder - FLTOP_DATA_OFFSET])
#define fltSndFound (FltDataCodeMap[eFltSndFound - FLTOP_DATA_OFFSET])
#define fltSndFilename (FltDataCodeMap[eFltSndFilename - FLTOP_DATA_OFFSET])
#define fltSndPathname (FltDataCodeMap[eFltSndPathname - FLTOP_DATA_OFFSET])
#define fltSndName (FltDataCodeMap[eFltSndName - FLTOP_DATA_OFFSET])
#define fltSndAmplitude (FltDataCodeMap[eFltSndAmplitude - FLTOP_DATA_OFFSET])
#define fltSndPitchBend (FltDataCodeMap[eFltSndPitchBend - FLTOP_DATA_OFFSET])
#define fltSndPriority (FltDataCodeMap[eFltSndPriority - FLTOP_DATA_OFFSET])
#define fltSndFallOff (FltDataCodeMap[eFltSndFallOff - FLTOP_DATA_OFFSET])
#define fltSndWidth (FltDataCodeMap[eFltSndWidth - FLTOP_DATA_OFFSET])
#define fltSndDoppler (FltDataCodeMap[eFltSndDoppler - FLTOP_DATA_OFFSET])
#define fltSndAbsorption (FltDataCodeMap[eFltSndAbsorption - FLTOP_DATA_OFFSET])
#define fltSndDelay (FltDataCodeMap[eFltSndDelay - FLTOP_DATA_OFFSET])
#define fltSndDirection (FltDataCodeMap[eFltSndDirection - FLTOP_DATA_OFFSET])
#define fltSndActive (FltDataCodeMap[eFltSndActive - FLTOP_DATA_OFFSET])
#define fltTGNumCoords (FltDataCodeMap[eFltTGNumCoords - FLTOP_DATA_OFFSET])
#define fltTGUnits (FltDataCodeMap[eFltTGUnits - FLTOP_DATA_OFFSET])
#define fltTGX (FltDataCodeMap[eFltTGX - FLTOP_DATA_OFFSET])
#define fltTGY (FltDataCodeMap[eFltTGY - FLTOP_DATA_OFFSET])
#define fltTGZ (FltDataCodeMap[eFltTGZ - FLTOP_DATA_OFFSET])
#define fltTGU (FltDataCodeMap[eFltTGU - FLTOP_DATA_OFFSET])
#define fltTGV (FltDataCodeMap[eFltTGV - FLTOP_DATA_OFFSET])
#define fltTGLat (FltDataCodeMap[eFltTGLat - FLTOP_DATA_OFFSET])
#define fltTGLon (FltDataCodeMap[eFltTGLon - FLTOP_DATA_OFFSET])
#define fltPathName (FltDataCodeMap[eFltPathName - FLTOP_DATA_OFFSET])
#define fltPathSpeedlimit (FltDataCodeMap[eFltPathSpeedlimit - FLTOP_DATA_OFFSET])
#define fltPathNoPass (FltDataCodeMap[eFltPathNoPass - FLTOP_DATA_OFFSET])
#define fltPathType (FltDataCodeMap[eFltPathType - FLTOP_DATA_OFFSET])
#define fltEyeYaw (FltDataCodeMap[eFltEyeYaw - FLTOP_DATA_OFFSET])
#define fltEyePitch (FltDataCodeMap[eFltEyePitch - FLTOP_DATA_OFFSET])
#define fltEyeRoll (FltDataCodeMap[eFltEyeRoll - FLTOP_DATA_OFFSET])
#define fltEyeFov (FltDataCodeMap[eFltEyeFov - FLTOP_DATA_OFFSET])
#define fltEyeScale (FltDataCodeMap[eFltEyeScale - FLTOP_DATA_OFFSET])
#define fltEyeNearClip (FltDataCodeMap[eFltEyeNearClip - FLTOP_DATA_OFFSET])
#define fltEyeFarClip (FltDataCodeMap[eFltEyeFarClip - FLTOP_DATA_OFFSET])
#define fltFCoordX (FltDataCodeMap[eFltFCoordX - FLTOP_DATA_OFFSET])
#define fltFCoordY (FltDataCodeMap[eFltFCoordY - FLTOP_DATA_OFFSET])
#define fltFCoordZ (FltDataCodeMap[eFltFCoordZ - FLTOP_DATA_OFFSET])
#define fltEyeFlyYaw (FltDataCodeMap[eFltEyeFlyYaw - FLTOP_DATA_OFFSET])
#define fltEyeFlyPitch (FltDataCodeMap[eFltEyeFlyPitch - FLTOP_DATA_OFFSET])
#define fltEyeNoFly (FltDataCodeMap[eFltEyeNoFly - FLTOP_DATA_OFFSET])
#define fltEyeOrthoFlag (FltDataCodeMap[eFltEyeOrthoFlag - FLTOP_DATA_OFFSET])
#define fltEyeActive (FltDataCodeMap[eFltEyeActive - FLTOP_DATA_OFFSET])
#define fltEyeImageZoom (FltDataCodeMap[eFltEyeImageZoom - FLTOP_DATA_OFFSET])
#define fltBHPnt1X (FltDataCodeMap[eFltBHPnt1X - FLTOP_DATA_OFFSET])
#define fltBHPnt1Y (FltDataCodeMap[eFltBHPnt1Y - FLTOP_DATA_OFFSET])
#define fltBHPnt1Z (FltDataCodeMap[eFltBHPnt1Z - FLTOP_DATA_OFFSET])
#define fltBHPnt2X (FltDataCodeMap[eFltBHPnt2X - FLTOP_DATA_OFFSET])
#define fltBHPnt2Y (FltDataCodeMap[eFltBHPnt2Y - FLTOP_DATA_OFFSET])
#define fltBHPnt2Z (FltDataCodeMap[eFltBHPnt2Z - FLTOP_DATA_OFFSET])
#define fltBHPnt3X (FltDataCodeMap[eFltBHPnt3X - FLTOP_DATA_OFFSET])
#define fltBHPnt3Y (FltDataCodeMap[eFltBHPnt3Y - FLTOP_DATA_OFFSET])
#define fltBHPnt3Z (FltDataCodeMap[eFltBHPnt3Z - FLTOP_DATA_OFFSET])
#define fltSWCornerLat1 (FltDataCodeMap[eFltSWCornerLat1 - FLTOP_DATA_OFFSET])
#define fltSWCornerLong1 (FltDataCodeMap[eFltSWCornerLong1 - FLTOP_DATA_OFFSET])
#define fltNECornerLat1 (FltDataCodeMap[eFltNECornerLat1 - FLTOP_DATA_OFFSET])
#define fltNECornerLong1 (FltDataCodeMap[eFltNECornerLong1 - FLTOP_DATA_OFFSET])
#define fltOriginLat1 (FltDataCodeMap[eFltOriginLat1 - FLTOP_DATA_OFFSET])
#define fltOriginLong1 (FltDataCodeMap[eFltOriginLong1 - FLTOP_DATA_OFFSET])
#define fltUpperLat1 (FltDataCodeMap[eFltUpperLat1 - FLTOP_DATA_OFFSET])
#define fltLowerLat1 (FltDataCodeMap[eFltLowerLat1 - FLTOP_DATA_OFFSET])
#define fltFPointX (FltDataCodeMap[eFltFPointX - FLTOP_DATA_OFFSET])
#define fltFPointY (FltDataCodeMap[eFltFPointY - FLTOP_DATA_OFFSET])
#define fltAlpha (FltDataCodeMap[eFltAlpha - FLTOP_DATA_OFFSET])
#define fltIAltColor (FltDataCodeMap[eFltIAltColor - FLTOP_DATA_OFFSET])
#define fltIAltIntensity (FltDataCodeMap[eFltIAltIntensity - FLTOP_DATA_OFFSET])
#define fltBlue (FltDataCodeMap[eFltBlue - FLTOP_DATA_OFFSET])
#define fltBoundingType (FltDataCodeMap[eFltBoundingType - FLTOP_DATA_OFFSET])
#define fltICface (FltDataCodeMap[eFltICface - FLTOP_DATA_OFFSET])
#define fltIChanged (FltDataCodeMap[eFltIChanged - FLTOP_DATA_OFFSET])
#define fltVChanged (FltDataCodeMap[eFltVChanged - FLTOP_DATA_OFFSET])
#define fltIColor (FltDataCodeMap[eFltIColor - FLTOP_DATA_OFFSET])
#define fltIIntensity (FltDataCodeMap[eFltIIntensity - FLTOP_DATA_OFFSET])
#define fltColorA (FltDataCodeMap[eFltColorA - FLTOP_DATA_OFFSET])
#define fltColorB (FltDataCodeMap[eFltColorB - FLTOP_DATA_OFFSET])
#define fltColorG (FltDataCodeMap[eFltColorG - FLTOP_DATA_OFFSET])
#define fltColorR (FltDataCodeMap[eFltColorR - FLTOP_DATA_OFFSET])
#define fltIConstructFlag (FltDataCodeMap[eFltIConstructFlag - FLTOP_DATA_OFFSET])
#define fltICurtex (FltDataCodeMap[eFltICurtex - FLTOP_DATA_OFFSET])
#define fltICurtex1 (FltDataCodeMap[eFltICurtex1 - FLTOP_DATA_OFFSET])
#define fltICurtex2 (FltDataCodeMap[eFltICurtex2 - FLTOP_DATA_OFFSET])
#define fltICurtex3 (FltDataCodeMap[eFltICurtex3 - FLTOP_DATA_OFFSET])
#define fltDPlaneA (FltDataCodeMap[eFltDPlaneA - FLTOP_DATA_OFFSET])
#define fltDPlaneB (FltDataCodeMap[eFltDPlaneB - FLTOP_DATA_OFFSET])
#define fltDPlaneC (FltDataCodeMap[eFltDPlaneC - FLTOP_DATA_OFFSET])
#define fltDPlaneD (FltDataCodeMap[eFltDPlaneD - FLTOP_DATA_OFFSET])
#define fltDataUndef (FltDataCodeMap[eFltDataUndef - FLTOP_DATA_OFFSET])
#define fltIDeadBead (FltDataCodeMap[eFltIDeadBead - FLTOP_DATA_OFFSET])
#define fltVDeadBead (FltDataCodeMap[eFltVDeadBead - FLTOP_DATA_OFFSET])
#define fltIDfd1 (FltDataCodeMap[eFltIDfd1 - FLTOP_DATA_OFFSET])
#define fltIDfd2 (FltDataCodeMap[eFltIDfd2 - FLTOP_DATA_OFFSET])
#define fltIDfd3 (FltDataCodeMap[eFltIDfd3 - FLTOP_DATA_OFFSET])
#define fltIDfd4 (FltDataCodeMap[eFltIDfd4 - FLTOP_DATA_OFFSET])
#define fltIDisable (FltDataCodeMap[eFltIDisable - FLTOP_DATA_OFFSET])
#define fltIDisplay (FltDataCodeMap[eFltIDisplay - FLTOP_DATA_OFFSET])
#define fltVDisplay (FltDataCodeMap[eFltVDisplay - FLTOP_DATA_OFFSET])
#define fltIDisplayMask (FltDataCodeMap[eFltIDisplayMask - FLTOP_DATA_OFFSET])
#define fltDofCurAzim (FltDataCodeMap[eFltDofCurAzim - FLTOP_DATA_OFFSET])
#define fltDofCurIncl (FltDataCodeMap[eFltDofCurIncl - FLTOP_DATA_OFFSET])
#define fltDofCurTwist (FltDataCodeMap[eFltDofCurTwist - FLTOP_DATA_OFFSET])
#define fltDofCurX (FltDataCodeMap[eFltDofCurX - FLTOP_DATA_OFFSET])
#define fltDofCurXScale (FltDataCodeMap[eFltDofCurXScale - FLTOP_DATA_OFFSET])
#define fltDofCurY (FltDataCodeMap[eFltDofCurY - FLTOP_DATA_OFFSET])
#define fltDofCurYScale (FltDataCodeMap[eFltDofCurYScale - FLTOP_DATA_OFFSET])
#define fltDofCurZ (FltDataCodeMap[eFltDofCurZ - FLTOP_DATA_OFFSET])
#define fltDofCurZScale (FltDataCodeMap[eFltDofCurZScale - FLTOP_DATA_OFFSET])
#define fltDofIncrementAzim (FltDataCodeMap[eFltDofIncrementAzim - FLTOP_DATA_OFFSET])
#define fltDofIncrementIncl (FltDataCodeMap[eFltDofIncrementIncl - FLTOP_DATA_OFFSET])
#define fltDofIncrementTwist (FltDataCodeMap[eFltDofIncrementTwist - FLTOP_DATA_OFFSET])
#define fltDofIncrementX (FltDataCodeMap[eFltDofIncrementX - FLTOP_DATA_OFFSET])
#define fltDofIncrementXScale (FltDataCodeMap[eFltDofIncrementXScale - FLTOP_DATA_OFFSET])
#define fltDofIncrementY (FltDataCodeMap[eFltDofIncrementY - FLTOP_DATA_OFFSET])
#define fltDofIncrementYScale (FltDataCodeMap[eFltDofIncrementYScale - FLTOP_DATA_OFFSET])
#define fltDofIncrementZ (FltDataCodeMap[eFltDofIncrementZ - FLTOP_DATA_OFFSET])
#define fltDofIncrementZScale (FltDataCodeMap[eFltDofIncrementZScale - FLTOP_DATA_OFFSET])
#define fltDofMaxAzim (FltDataCodeMap[eFltDofMaxAzim - FLTOP_DATA_OFFSET])
#define fltDofMaxIncl (FltDataCodeMap[eFltDofMaxIncl - FLTOP_DATA_OFFSET])
#define fltDofMaxTwist (FltDataCodeMap[eFltDofMaxTwist - FLTOP_DATA_OFFSET])
#define fltDofMaxX (FltDataCodeMap[eFltDofMaxX - FLTOP_DATA_OFFSET])
#define fltDofMaxXScale (FltDataCodeMap[eFltDofMaxXScale - FLTOP_DATA_OFFSET])
#define fltDofMaxY (FltDataCodeMap[eFltDofMaxY - FLTOP_DATA_OFFSET])
#define fltDofMaxYScale (FltDataCodeMap[eFltDofMaxYScale - FLTOP_DATA_OFFSET])
#define fltDofMaxZ (FltDataCodeMap[eFltDofMaxZ - FLTOP_DATA_OFFSET])
#define fltDofMaxZScale (FltDataCodeMap[eFltDofMaxZScale - FLTOP_DATA_OFFSET])
#define fltDofMinAzim (FltDataCodeMap[eFltDofMinAzim - FLTOP_DATA_OFFSET])
#define fltDofMinIncl (FltDataCodeMap[eFltDofMinIncl - FLTOP_DATA_OFFSET])
#define fltDofMinTwist (FltDataCodeMap[eFltDofMinTwist - FLTOP_DATA_OFFSET])
#define fltDofMinX (FltDataCodeMap[eFltDofMinX - FLTOP_DATA_OFFSET])
#define fltDofMinXScale (FltDataCodeMap[eFltDofMinXScale - FLTOP_DATA_OFFSET])
#define fltDofMinY (FltDataCodeMap[eFltDofMinY - FLTOP_DATA_OFFSET])
#define fltDofMinYScale (FltDataCodeMap[eFltDofMinYScale - FLTOP_DATA_OFFSET])
#define fltDofMinZ (FltDataCodeMap[eFltDofMinZ - FLTOP_DATA_OFFSET])
#define fltDofMinZScale (FltDataCodeMap[eFltDofMinZScale - FLTOP_DATA_OFFSET])
#define fltDofPutAnchorX (FltDataCodeMap[eFltDofPutAnchorX - FLTOP_DATA_OFFSET])
#define fltDofPutAnchorY (FltDataCodeMap[eFltDofPutAnchorY - FLTOP_DATA_OFFSET])
#define fltDofPutAnchorZ (FltDataCodeMap[eFltDofPutAnchorZ - FLTOP_DATA_OFFSET])
#define fltDofPutAlignX (FltDataCodeMap[eFltDofPutAlignX - FLTOP_DATA_OFFSET])
#define fltDofPutAlignY (FltDataCodeMap[eFltDofPutAlignY - FLTOP_DATA_OFFSET])
#define fltDofPutAlignZ (FltDataCodeMap[eFltDofPutAlignZ - FLTOP_DATA_OFFSET])
#define fltDofPutTrackX (FltDataCodeMap[eFltDofPutTrackX - FLTOP_DATA_OFFSET])
#define fltDofPutTrackY (FltDataCodeMap[eFltDofPutTrackY - FLTOP_DATA_OFFSET])
#define fltDofPutTrackZ (FltDataCodeMap[eFltDofPutTrackZ - FLTOP_DATA_OFFSET])
#define fltIDontExport (FltDataCodeMap[eFltIDontExport - FLTOP_DATA_OFFSET])
#define fltIDontExportDl (FltDataCodeMap[eFltIDontExportDl - FLTOP_DATA_OFFSET])
#define fltIDontExportInfo (FltDataCodeMap[eFltIDontExportInfo - FLTOP_DATA_OFFSET])
#define fltIDownCnt (FltDataCodeMap[eFltIDownCnt - FLTOP_DATA_OFFSET])
#define fltDummyPtr (FltDataCodeMap[eFltDummyPtr - FLTOP_DATA_OFFSET])
#define fltVEdge (FltDataCodeMap[eFltVEdge - FLTOP_DATA_OFFSET])
#define fltIExternal (FltDataCodeMap[eFltIExternal - FLTOP_DATA_OFFSET])
#define fltIFootprint (FltDataCodeMap[eFltIFootprint - FLTOP_DATA_OFFSET])
#define fltFreezeBox (FltDataCodeMap[eFltFreezeBox - FLTOP_DATA_OFFSET])
#define fltIFreezeMesh (FltDataCodeMap[eFltIFreezeMesh - FLTOP_DATA_OFFSET])
#define fltVFrozen (FltDataCodeMap[eFltVFrozen - FLTOP_DATA_OFFSET])
#define fltIGc (FltDataCodeMap[eFltIGc - FLTOP_DATA_OFFSET])
#define fltGcColPal (FltDataCodeMap[eFltGcColPal - FLTOP_DATA_OFFSET])
#define fltGcDrawMode (FltDataCodeMap[eFltGcDrawMode - FLTOP_DATA_OFFSET])
#define fltGcLightMode (FltDataCodeMap[eFltGcLightMode - FLTOP_DATA_OFFSET])
#define fltGcLinPal (FltDataCodeMap[eFltGcLinPal - FLTOP_DATA_OFFSET])
#define fltGcLitPal (FltDataCodeMap[eFltGcLitPal - FLTOP_DATA_OFFSET])
#define fltGcMatPal (FltDataCodeMap[eFltGcMatPal - FLTOP_DATA_OFFSET])
#define fltGcSndPal (FltDataCodeMap[eFltGcSndPal - FLTOP_DATA_OFFSET])
#define fltGcTxtPal (FltDataCodeMap[eFltGcTxtPal - FLTOP_DATA_OFFSET])
#define fltGreen (FltDataCodeMap[eFltGreen - FLTOP_DATA_OFFSET])
#define fltGrpFlagAnimation (FltDataCodeMap[eFltGrpFlagAnimation - FLTOP_DATA_OFFSET])
#define fltGrpFlagAnimationFB (FltDataCodeMap[eFltGrpFlagAnimationFB - FLTOP_DATA_OFFSET])
#define fltGrpFlagBoxed (FltDataCodeMap[eFltGrpFlagBoxed - FLTOP_DATA_OFFSET])
#define fltGrpFlagDefaultParent (FltDataCodeMap[eFltGrpFlagDefaultParent - FLTOP_DATA_OFFSET])
#define fltGrpFlagFreezeBox (FltDataCodeMap[eFltGrpFlagFreezeBox - FLTOP_DATA_OFFSET])
#define fltGrpFlagTerrain (FltDataCodeMap[eFltGrpFlagTerrain - FLTOP_DATA_OFFSET])
#define fltGrpLayer (FltDataCodeMap[eFltGrpLayer - FLTOP_DATA_OFFSET])
#define fltGrpPrio (FltDataCodeMap[eFltGrpPrio - FLTOP_DATA_OFFSET])
#define fltGrpSignificance (FltDataCodeMap[eFltGrpSignificance - FLTOP_DATA_OFFSET])
#define fltGrpSpecial1 (FltDataCodeMap[eFltGrpSpecial1 - FLTOP_DATA_OFFSET])
#define fltGrpSpecial2 (FltDataCodeMap[eFltGrpSpecial2 - FLTOP_DATA_OFFSET])
#define fltVHard (FltDataCodeMap[eFltVHard - FLTOP_DATA_OFFSET])
#define fltVHard2 (FltDataCodeMap[eFltVHard2 - FLTOP_DATA_OFFSET])
#define fltHdrDbRev (FltDataCodeMap[eFltHdrDbRev - FLTOP_DATA_OFFSET])
#define fltHdrFlagVtxNorms (FltDataCodeMap[eFltHdrFlagVtxNorms - FLTOP_DATA_OFFSET])
#define fltHdrFormatRev (FltDataCodeMap[eFltHdrFormatRev - FLTOP_DATA_OFFSET])
#define fltHdrLastDate (FltDataCodeMap[eFltHdrLastDate - FLTOP_DATA_OFFSET])
#define fltHdrNextFacId (FltDataCodeMap[eFltHdrNextFacId - FLTOP_DATA_OFFSET])
#define fltHdrNextGrpId (FltDataCodeMap[eFltHdrNextGrpId - FLTOP_DATA_OFFSET])
#define fltHdrNextLodId (FltDataCodeMap[eFltHdrNextLodId - FLTOP_DATA_OFFSET])
#define fltHdrNextObjId (FltDataCodeMap[eFltHdrNextObjId - FLTOP_DATA_OFFSET])
#define fltHdrTexWhite (FltDataCodeMap[eFltHdrTexWhite - FLTOP_DATA_OFFSET])
#define fltHdrUdiv (FltDataCodeMap[eFltHdrUdiv - FLTOP_DATA_OFFSET])
#define fltHdrUnits (FltDataCodeMap[eFltHdrUnits - FLTOP_DATA_OFFSET])
#define fltHeight (FltDataCodeMap[eFltHeight - FLTOP_DATA_OFFSET])
#define fltIHidden (FltDataCodeMap[eFltIHidden - FLTOP_DATA_OFFSET])
#define fltIAlpha (FltDataCodeMap[eFltIAlpha - FLTOP_DATA_OFFSET])
#define fltIcoordX (FltDataCodeMap[eFltIcoordX - FLTOP_DATA_OFFSET])
#define fltIcoordY (FltDataCodeMap[eFltIcoordY - FLTOP_DATA_OFFSET])
#define fltIcoordZ (FltDataCodeMap[eFltIcoordZ - FLTOP_DATA_OFFSET])
#define fltIdbl1 (FltDataCodeMap[eFltIdbl1 - FLTOP_DATA_OFFSET])
#define fltIdbl2 (FltDataCodeMap[eFltIdbl2 - FLTOP_DATA_OFFSET])
#define fltIdbl3 (FltDataCodeMap[eFltIdbl3 - FLTOP_DATA_OFFSET])
#define fltIdbl4 (FltDataCodeMap[eFltIdbl4 - FLTOP_DATA_OFFSET])
#define fltIdbl5 (FltDataCodeMap[eFltIdbl5 - FLTOP_DATA_OFFSET])
#define fltIdbl6 (FltDataCodeMap[eFltIdbl6 - FLTOP_DATA_OFFSET])
#define fltIdbl7 (FltDataCodeMap[eFltIdbl7 - FLTOP_DATA_OFFSET])
#define fltIdbl8 (FltDataCodeMap[eFltIdbl8 - FLTOP_DATA_OFFSET])
#define fltImgChanged (FltDataCodeMap[eFltImgChanged - FLTOP_DATA_OFFSET])
#define fltImgClamp (FltDataCodeMap[eFltImgClamp - FLTOP_DATA_OFFSET])
#define fltImgComment (FltDataCodeMap[eFltImgComment - FLTOP_DATA_OFFSET])
#define fltImgControlPoint (FltDataCodeMap[eFltImgControlPoint - FLTOP_DATA_OFFSET])
#define fltImgDblOrig (FltDataCodeMap[eFltImgDblOrig - FLTOP_DATA_OFFSET])
#define fltImgDetail (FltDataCodeMap[eFltImgDetail - FLTOP_DATA_OFFSET])
#define fltImgEnvType (FltDataCodeMap[eFltImgEnvType - FLTOP_DATA_OFFSET])
#define fltImgExternalFormat (FltDataCodeMap[eFltImgExternalFormat - FLTOP_DATA_OFFSET])
#define fltImgFormatRev (FltDataCodeMap[eFltImgFormatRev - FLTOP_DATA_OFFSET])
#define fltImgHeight (FltDataCodeMap[eFltImgHeight - FLTOP_DATA_OFFSET])
#define fltImgInAlpha (FltDataCodeMap[eFltImgInAlpha - FLTOP_DATA_OFFSET])
#define fltImgInternalFormat (FltDataCodeMap[eFltImgInternalFormat - FLTOP_DATA_OFFSET])
#define fltImgJ (FltDataCodeMap[eFltImgJ - FLTOP_DATA_OFFSET])
#define fltImgK (FltDataCodeMap[eFltImgK - FLTOP_DATA_OFFSET])
#define fltImgKernel (FltDataCodeMap[eFltImgKernel - FLTOP_DATA_OFFSET])
#define fltImgLod0 (FltDataCodeMap[eFltImgLod0 - FLTOP_DATA_OFFSET])
#define fltImgLod1 (FltDataCodeMap[eFltImgLod1 - FLTOP_DATA_OFFSET])
#define fltImgLod2 (FltDataCodeMap[eFltImgLod2 - FLTOP_DATA_OFFSET])
#define fltImgLod3 (FltDataCodeMap[eFltImgLod3 - FLTOP_DATA_OFFSET])
#define fltImgLod4 (FltDataCodeMap[eFltImgLod4 - FLTOP_DATA_OFFSET])
#define fltImgLod5 (FltDataCodeMap[eFltImgLod5 - FLTOP_DATA_OFFSET])
#define fltImgLod6 (FltDataCodeMap[eFltImgLod6 - FLTOP_DATA_OFFSET])
#define fltImgLod7 (FltDataCodeMap[eFltImgLod7 - FLTOP_DATA_OFFSET])
#define fltImgLowerLeftU (FltDataCodeMap[eFltImgLowerLeftU - FLTOP_DATA_OFFSET])
#define fltImgLowerLeftV (FltDataCodeMap[eFltImgLowerLeftV - FLTOP_DATA_OFFSET])
#define fltImgM (FltDataCodeMap[eFltImgM - FLTOP_DATA_OFFSET])
#define fltImgMagFilter (FltDataCodeMap[eFltImgMagFilter - FLTOP_DATA_OFFSET])
#define fltImgMagFilterAlpha (FltDataCodeMap[eFltImgMagFilterAlpha - FLTOP_DATA_OFFSET])
#define fltImgMagFilterColor (FltDataCodeMap[eFltImgMagFilterColor - FLTOP_DATA_OFFSET])
#define fltImgMinFilter (FltDataCodeMap[eFltImgMinFilter - FLTOP_DATA_OFFSET])
#define fltImgN (FltDataCodeMap[eFltImgN - FLTOP_DATA_OFFSET])
#define fltImgRwSizeU (FltDataCodeMap[eFltImgRwSizeU - FLTOP_DATA_OFFSET])
#define fltImgRwSizeUf (FltDataCodeMap[eFltImgRwSizeUf - FLTOP_DATA_OFFSET])
#define fltImgRwSizeV (FltDataCodeMap[eFltImgRwSizeV - FLTOP_DATA_OFFSET])
#define fltImgRwSizeVf (FltDataCodeMap[eFltImgRwSizeVf - FLTOP_DATA_OFFSET])
#define fltImgScale0 (FltDataCodeMap[eFltImgScale0 - FLTOP_DATA_OFFSET])
#define fltImgScale1 (FltDataCodeMap[eFltImgScale1 - FLTOP_DATA_OFFSET])
#define fltImgScale2 (FltDataCodeMap[eFltImgScale2 - FLTOP_DATA_OFFSET])
#define fltImgScale3 (FltDataCodeMap[eFltImgScale3 - FLTOP_DATA_OFFSET])
#define fltImgScale4 (FltDataCodeMap[eFltImgScale4 - FLTOP_DATA_OFFSET])
#define fltImgScale5 (FltDataCodeMap[eFltImgScale5 - FLTOP_DATA_OFFSET])
#define fltImgScale6 (FltDataCodeMap[eFltImgScale6 - FLTOP_DATA_OFFSET])
#define fltImgScale7 (FltDataCodeMap[eFltImgScale7 - FLTOP_DATA_OFFSET])
#define fltImgScramble (FltDataCodeMap[eFltImgScramble - FLTOP_DATA_OFFSET])
#define fltImgTile (FltDataCodeMap[eFltImgTile - FLTOP_DATA_OFFSET])
#define fltImgType (FltDataCodeMap[eFltImgType - FLTOP_DATA_OFFSET])
#define fltImgU64AlphaClip (FltDataCodeMap[eFltImgU64AlphaClip - FLTOP_DATA_OFFSET])
#define fltImgU64CustomSize (FltDataCodeMap[eFltImgU64CustomSize - FLTOP_DATA_OFFSET])
#define fltImgU64Format (FltDataCodeMap[eFltImgU64Format - FLTOP_DATA_OFFSET])
#define fltImgU64GenS (FltDataCodeMap[eFltImgU64GenS - FLTOP_DATA_OFFSET])
#define fltImgU64GenT (FltDataCodeMap[eFltImgU64GenT - FLTOP_DATA_OFFSET])
#define fltImgU64Height (FltDataCodeMap[eFltImgU64Height - FLTOP_DATA_OFFSET])
#define fltImgU64MaxResDir (FltDataCodeMap[eFltImgU64MaxResDir - FLTOP_DATA_OFFSET])
#define fltImgU64Mipmap (FltDataCodeMap[eFltImgU64Mipmap - FLTOP_DATA_OFFSET])
#define fltImgU64PixSize (FltDataCodeMap[eFltImgU64PixSize - FLTOP_DATA_OFFSET])
#define fltImgU64ShrinkFlag (FltDataCodeMap[eFltImgU64ShrinkFlag - FLTOP_DATA_OFFSET])
#define fltImgU64Width (FltDataCodeMap[eFltImgU64Width - FLTOP_DATA_OFFSET])
#define fltImgU64WrapS (FltDataCodeMap[eFltImgU64WrapS - FLTOP_DATA_OFFSET])
#define fltImgU64WrapT (FltDataCodeMap[eFltImgU64WrapT - FLTOP_DATA_OFFSET])
#define fltImgUpperRightU (FltDataCodeMap[eFltImgUpperRightU - FLTOP_DATA_OFFSET])
#define fltImgUpperRightV (FltDataCodeMap[eFltImgUpperRightV - FLTOP_DATA_OFFSET])
#define fltImgUseFilter (FltDataCodeMap[eFltImgUseFilter - FLTOP_DATA_OFFSET])
#define fltImgUser1 (FltDataCodeMap[eFltImgUser1 - FLTOP_DATA_OFFSET])
#define fltImgUser2 (FltDataCodeMap[eFltImgUser2 - FLTOP_DATA_OFFSET])
#define fltImgUser3 (FltDataCodeMap[eFltImgUser3 - FLTOP_DATA_OFFSET])
#define fltImgUser4 (FltDataCodeMap[eFltImgUser4 - FLTOP_DATA_OFFSET])
#define fltImgUser5 (FltDataCodeMap[eFltImgUser5 - FLTOP_DATA_OFFSET])
#define fltImgUser6 (FltDataCodeMap[eFltImgUser6 - FLTOP_DATA_OFFSET])
#define fltImgUser7 (FltDataCodeMap[eFltImgUser7 - FLTOP_DATA_OFFSET])
#define fltImgUser8 (FltDataCodeMap[eFltImgUser8 - FLTOP_DATA_OFFSET])
#define fltImgWidth (FltDataCodeMap[eFltImgWidth - FLTOP_DATA_OFFSET])
#define fltImgWrap (FltDataCodeMap[eFltImgWrap - FLTOP_DATA_OFFSET])
#define fltImgWrapU (FltDataCodeMap[eFltImgWrapU - FLTOP_DATA_OFFSET])
#define fltImgWrapV (FltDataCodeMap[eFltImgWrapV - FLTOP_DATA_OFFSET])
#define fltIImmediate (FltDataCodeMap[eFltIImmediate - FLTOP_DATA_OFFSET])
#define fltIInstBelow (FltDataCodeMap[eFltIInstBelow - FLTOP_DATA_OFFSET])
#define fltIpointX (FltDataCodeMap[eFltIpointX - FLTOP_DATA_OFFSET])
#define fltIpointY (FltDataCodeMap[eFltIpointY - FLTOP_DATA_OFFSET])
#define fltIIrColor (FltDataCodeMap[eFltIIrColor - FLTOP_DATA_OFFSET])
#define fltILayer (FltDataCodeMap[eFltILayer - FLTOP_DATA_OFFSET])
#define fltVLeaveNorm (FltDataCodeMap[eFltVLeaveNorm - FLTOP_DATA_OFFSET])
#define fltILevel (FltDataCodeMap[eFltILevel - FLTOP_DATA_OFFSET])
#define fltVLevel (FltDataCodeMap[eFltVLevel - FLTOP_DATA_OFFSET])
#define fltILibrary (FltDataCodeMap[eFltILibrary - FLTOP_DATA_OFFSET])
#define fltILight (FltDataCodeMap[eFltILight - FLTOP_DATA_OFFSET])
#define fltILightMode (FltDataCodeMap[eFltILightMode - FLTOP_DATA_OFFSET])
#define fltILineStyle (FltDataCodeMap[eFltILineStyle - FLTOP_DATA_OFFSET])
#define fltLodFlagAdditive (FltDataCodeMap[eFltLodFlagAdditive - FLTOP_DATA_OFFSET])
#define fltLodFlagFreezeCenter (FltDataCodeMap[eFltLodFlagFreezeCenter - FLTOP_DATA_OFFSET])
#define fltLodFlagRange (FltDataCodeMap[eFltLodFlagRange - FLTOP_DATA_OFFSET])
#define fltLodSwitchIn (FltDataCodeMap[eFltLodSwitchIn - FLTOP_DATA_OFFSET])
#define fltLodSwitchOut (FltDataCodeMap[eFltLodSwitchOut - FLTOP_DATA_OFFSET])
#define fltLodTransition (FltDataCodeMap[eFltLodTransition - FLTOP_DATA_OFFSET])
#define fltLowerLat (FltDataCodeMap[eFltLowerLat - FLTOP_DATA_OFFSET])
#define fltLtsAttachedToEye (FltDataCodeMap[eFltLtsAttachedToEye - FLTOP_DATA_OFFSET])
#define fltLtsEnabled (FltDataCodeMap[eFltLtsEnabled - FLTOP_DATA_OFFSET])
#define fltLtsError1 (FltDataCodeMap[eFltLtsError1 - FLTOP_DATA_OFFSET])
#define fltLtsExport (FltDataCodeMap[eFltLtsExport - FLTOP_DATA_OFFSET])
#define fltLtsGlobal (FltDataCodeMap[eFltLtsGlobal - FLTOP_DATA_OFFSET])
#define fltLtsIndex (FltDataCodeMap[eFltLtsIndex - FLTOP_DATA_OFFSET])
#define fltLtsPitch (FltDataCodeMap[eFltLtsPitch - FLTOP_DATA_OFFSET])
#define fltLtsYaw (FltDataCodeMap[eFltLtsYaw - FLTOP_DATA_OFFSET])
#define fltLtspConstAtten (FltDataCodeMap[eFltLtspConstAtten - FLTOP_DATA_OFFSET])
#define fltLtspLinearAtten (FltDataCodeMap[eFltLtspLinearAtten - FLTOP_DATA_OFFSET])
#define fltLtspModeling (FltDataCodeMap[eFltLtspModeling - FLTOP_DATA_OFFSET])
#define fltLtspName (FltDataCodeMap[eFltLtspName - FLTOP_DATA_OFFSET])
#define fltLtspOnFlag (FltDataCodeMap[eFltLtspOnFlag - FLTOP_DATA_OFFSET])
#define fltLtspPaletteId (FltDataCodeMap[eFltLtspPaletteId - FLTOP_DATA_OFFSET])
#define fltLtspPitch (FltDataCodeMap[eFltLtspPitch - FLTOP_DATA_OFFSET])
#define fltLtspQuadAtten (FltDataCodeMap[eFltLtspQuadAtten - FLTOP_DATA_OFFSET])
#define fltLtspSpotExp (FltDataCodeMap[eFltLtspSpotExp - FLTOP_DATA_OFFSET])
#define fltLtspSpotSpread (FltDataCodeMap[eFltLtspSpotSpread - FLTOP_DATA_OFFSET])
#define fltLtspType (FltDataCodeMap[eFltLtspType - FLTOP_DATA_OFFSET])
#define fltLtspYaw (FltDataCodeMap[eFltLtspYaw - FLTOP_DATA_OFFSET])
#define fltMatActive (FltDataCodeMap[eFltMatActive - FLTOP_DATA_OFFSET])
#define fltMatAlpha (FltDataCodeMap[eFltMatAlpha - FLTOP_DATA_OFFSET])
#define fltMatIndex (FltDataCodeMap[eFltMatIndex - FLTOP_DATA_OFFSET])
#define fltMatName (FltDataCodeMap[eFltMatName - FLTOP_DATA_OFFSET])
#define fltMatUsed (FltDataCodeMap[eFltMatUsed - FLTOP_DATA_OFFSET])
#define fltMaterial (FltDataCodeMap[eFltMaterial - FLTOP_DATA_OFFSET])
#define fltMatrix00 (FltDataCodeMap[eFltMatrix00 - FLTOP_DATA_OFFSET])
#define fltMatrix01 (FltDataCodeMap[eFltMatrix01 - FLTOP_DATA_OFFSET])
#define fltMatrix02 (FltDataCodeMap[eFltMatrix02 - FLTOP_DATA_OFFSET])
#define fltMatrix03 (FltDataCodeMap[eFltMatrix03 - FLTOP_DATA_OFFSET])
#define fltMatrix10 (FltDataCodeMap[eFltMatrix10 - FLTOP_DATA_OFFSET])
#define fltMatrix11 (FltDataCodeMap[eFltMatrix11 - FLTOP_DATA_OFFSET])
#define fltMatrix12 (FltDataCodeMap[eFltMatrix12 - FLTOP_DATA_OFFSET])
#define fltMatrix13 (FltDataCodeMap[eFltMatrix13 - FLTOP_DATA_OFFSET])
#define fltMatrix20 (FltDataCodeMap[eFltMatrix20 - FLTOP_DATA_OFFSET])
#define fltMatrix21 (FltDataCodeMap[eFltMatrix21 - FLTOP_DATA_OFFSET])
#define fltMatrix22 (FltDataCodeMap[eFltMatrix22 - FLTOP_DATA_OFFSET])
#define fltMatrix23 (FltDataCodeMap[eFltMatrix23 - FLTOP_DATA_OFFSET])
#define fltMatrix30 (FltDataCodeMap[eFltMatrix30 - FLTOP_DATA_OFFSET])
#define fltMatrix31 (FltDataCodeMap[eFltMatrix31 - FLTOP_DATA_OFFSET])
#define fltMatrix32 (FltDataCodeMap[eFltMatrix32 - FLTOP_DATA_OFFSET])
#define fltMatrix33 (FltDataCodeMap[eFltMatrix33 - FLTOP_DATA_OFFSET])
#define fltIMgTemplate (FltDataCodeMap[eFltIMgTemplate - FLTOP_DATA_OFFSET])
#define fltVMorphPercent (FltDataCodeMap[eFltVMorphPercent - FLTOP_DATA_OFFSET])
#define fltNColorB (FltDataCodeMap[eFltNColorB - FLTOP_DATA_OFFSET])
#define fltNColorG (FltDataCodeMap[eFltNColorG - FLTOP_DATA_OFFSET])
#define fltNColorR (FltDataCodeMap[eFltNColorR - FLTOP_DATA_OFFSET])
#define fltNECornerLat (FltDataCodeMap[eFltNECornerLat - FLTOP_DATA_OFFSET])
#define fltNECornerLong (FltDataCodeMap[eFltNECornerLong - FLTOP_DATA_OFFSET])
#define fltVNameNdx (FltDataCodeMap[eFltVNameNdx - FLTOP_DATA_OFFSET])
#define fltINoBack (FltDataCodeMap[eFltINoBack - FLTOP_DATA_OFFSET])
#define fltINoIllum (FltDataCodeMap[eFltINoIllum - FLTOP_DATA_OFFSET])
#define fltINoShade (FltDataCodeMap[eFltINoShade - FLTOP_DATA_OFFSET])
#define fltObjFlagDay (FltDataCodeMap[eFltObjFlagDay - FLTOP_DATA_OFFSET])
#define fltObjFlagDusk (FltDataCodeMap[eFltObjFlagDusk - FLTOP_DATA_OFFSET])
#define fltObjFlagNight (FltDataCodeMap[eFltObjFlagNight - FLTOP_DATA_OFFSET])
#define fltObjFlagNoillum (FltDataCodeMap[eFltObjFlagNoillum - FLTOP_DATA_OFFSET])
#define fltObjFlagNoshade (FltDataCodeMap[eFltObjFlagNoshade - FLTOP_DATA_OFFSET])
#define fltObjFlagShadow (FltDataCodeMap[eFltObjFlagShadow - FLTOP_DATA_OFFSET])
#define fltObjFlagTerrain (FltDataCodeMap[eFltObjFlagTerrain - FLTOP_DATA_OFFSET])
#define fltObjPrio (FltDataCodeMap[eFltObjPrio - FLTOP_DATA_OFFSET])
#define fltObjSignificance (FltDataCodeMap[eFltObjSignificance - FLTOP_DATA_OFFSET])
#define fltObjSpecial1 (FltDataCodeMap[eFltObjSpecial1 - FLTOP_DATA_OFFSET])
#define fltObjSpecial2 (FltDataCodeMap[eFltObjSpecial2 - FLTOP_DATA_OFFSET])
#define fltObjTransparency (FltDataCodeMap[eFltObjTransparency - FLTOP_DATA_OFFSET])
#define fltIOn (FltDataCodeMap[eFltIOn - FLTOP_DATA_OFFSET])
#define fltOriginLat (FltDataCodeMap[eFltOriginLat - FLTOP_DATA_OFFSET])
#define fltOriginLong (FltDataCodeMap[eFltOriginLong - FLTOP_DATA_OFFSET])
#define fltIOriginalColor (FltDataCodeMap[eFltIOriginalColor - FLTOP_DATA_OFFSET])
#define fltIPath (FltDataCodeMap[eFltIPath - FLTOP_DATA_OFFSET])
#define fltIPathCnt (FltDataCodeMap[eFltIPathCnt - FLTOP_DATA_OFFSET])
#define fltVPathCnt (FltDataCodeMap[eFltVPathCnt - FLTOP_DATA_OFFSET])
#define fltIPercentTxt (FltDataCodeMap[eFltIPercentTxt - FLTOP_DATA_OFFSET])
#define fltIPhantom (FltDataCodeMap[eFltIPhantom - FLTOP_DATA_OFFSET])
#define fltIPln (FltDataCodeMap[eFltIPln - FLTOP_DATA_OFFSET])
#define fltPolyColorName (FltDataCodeMap[eFltPolyColorName - FLTOP_DATA_OFFSET])
#define fltPolyColorName2 (FltDataCodeMap[eFltPolyColorName2 - FLTOP_DATA_OFFSET])
#define fltPolyDrawType (FltDataCodeMap[eFltPolyDrawType - FLTOP_DATA_OFFSET])
#define fltPolyDrawTypeOld (FltDataCodeMap[eFltPolyDrawTypeOld - FLTOP_DATA_OFFSET])
#define fltPolyFid (FltDataCodeMap[eFltPolyFid - FLTOP_DATA_OFFSET])
#define fltPolyFlagNocolor (FltDataCodeMap[eFltPolyFlagNocolor - FLTOP_DATA_OFFSET])
#define fltPolyFlagNocolor2 (FltDataCodeMap[eFltPolyFlagNocolor2 - FLTOP_DATA_OFFSET])
#define fltPolyFlagRgbMode (FltDataCodeMap[eFltPolyFlagRgbMode - FLTOP_DATA_OFFSET])
#define fltPolyFlagTerrain (FltDataCodeMap[eFltPolyFlagTerrain - FLTOP_DATA_OFFSET])
#define fltPolyInfrared (FltDataCodeMap[eFltPolyInfrared - FLTOP_DATA_OFFSET])
#define fltPolyIrMaterial (FltDataCodeMap[eFltPolyIrMaterial - FLTOP_DATA_OFFSET])
#define fltPolyLineStyle (FltDataCodeMap[eFltPolyLineStyle - FLTOP_DATA_OFFSET])
#define fltPolyLodControl (FltDataCodeMap[eFltPolyLodControl - FLTOP_DATA_OFFSET])
#define fltPolyMaterial (FltDataCodeMap[eFltPolyMaterial - FLTOP_DATA_OFFSET])
#define fltPolyMgTemplate (FltDataCodeMap[eFltPolyMgTemplate - FLTOP_DATA_OFFSET])
#define fltPolyPrio (FltDataCodeMap[eFltPolyPrio - FLTOP_DATA_OFFSET])
#define fltPolySmc (FltDataCodeMap[eFltPolySmc - FLTOP_DATA_OFFSET])
#define fltPolyTexWhite (FltDataCodeMap[eFltPolyTexWhite - FLTOP_DATA_OFFSET])
#define fltPolyTexture (FltDataCodeMap[eFltPolyTexture - FLTOP_DATA_OFFSET])
#define fltPolyTexture1 (FltDataCodeMap[eFltPolyTexture1 - FLTOP_DATA_OFFSET])
#define fltPolyTransparency (FltDataCodeMap[eFltPolyTransparency - FLTOP_DATA_OFFSET])
#define fltIPrio (FltDataCodeMap[eFltIPrio - FLTOP_DATA_OFFSET])
#define fltProjection (FltDataCodeMap[eFltProjection - FLTOP_DATA_OFFSET])
#define fltRadius (FltDataCodeMap[eFltRadius - FLTOP_DATA_OFFSET])
#define fltIReadOnly (FltDataCodeMap[eFltIReadOnly - FLTOP_DATA_OFFSET])
#define fltRed (FltDataCodeMap[eFltRed - FLTOP_DATA_OFFSET])
#define fltRepCnt (FltDataCodeMap[eFltRepCnt - FLTOP_DATA_OFFSET])
#define fltIRepSel (FltDataCodeMap[eFltIRepSel - FLTOP_DATA_OFFSET])
#define fltRGBA (FltDataCodeMap[eFltRGBA - FLTOP_DATA_OFFSET])
#define fltIRgbMode (FltDataCodeMap[eFltIRgbMode - FLTOP_DATA_OFFSET])
#define fltVRgbMode (FltDataCodeMap[eFltVRgbMode - FLTOP_DATA_OFFSET])
#define fltIRoad (FltDataCodeMap[eFltIRoad - FLTOP_DATA_OFFSET])
#define fltSWCornerLat (FltDataCodeMap[eFltSWCornerLat - FLTOP_DATA_OFFSET])
#define fltSWCornerLong (FltDataCodeMap[eFltSWCornerLong - FLTOP_DATA_OFFSET])
#define fltIScratch (FltDataCodeMap[eFltIScratch - FLTOP_DATA_OFFSET])
#define fltShininess (FltDataCodeMap[eFltShininess - FLTOP_DATA_OFFSET])
#define fltISif1 (FltDataCodeMap[eFltISif1 - FLTOP_DATA_OFFSET])
#define fltISif2 (FltDataCodeMap[eFltISif2 - FLTOP_DATA_OFFSET])
#define fltISif3 (FltDataCodeMap[eFltISif3 - FLTOP_DATA_OFFSET])
#define fltISif4 (FltDataCodeMap[eFltISif4 - FLTOP_DATA_OFFSET])
#define fltISif5 (FltDataCodeMap[eFltISif5 - FLTOP_DATA_OFFSET])
#define fltISif6 (FltDataCodeMap[eFltISif6 - FLTOP_DATA_OFFSET])
#define fltISif7 (FltDataCodeMap[eFltISif7 - FLTOP_DATA_OFFSET])
#define fltISif8 (FltDataCodeMap[eFltISif8 - FLTOP_DATA_OFFSET])
#define fltISliced (FltDataCodeMap[eFltISliced - FLTOP_DATA_OFFSET])
#define fltISpt (FltDataCodeMap[eFltISpt - FLTOP_DATA_OFFSET])
#define fltStrucCnt (FltDataCodeMap[eFltStrucCnt - FLTOP_DATA_OFFSET])
#define fltIStrucOn (FltDataCodeMap[eFltIStrucOn - FLTOP_DATA_OFFSET])
#define fltVSubVtx (FltDataCodeMap[eFltVSubVtx - FLTOP_DATA_OFFSET])
#define fltSwCount (FltDataCodeMap[eFltSwCount - FLTOP_DATA_OFFSET])
#define fltSwCurMask (FltDataCodeMap[eFltSwCurMask - FLTOP_DATA_OFFSET])
#define fltSwDynamic (FltDataCodeMap[eFltSwDynamic - FLTOP_DATA_OFFSET])
#define fltSwMaxMask (FltDataCodeMap[eFltSwMaxMask - FLTOP_DATA_OFFSET])
#define fltITemplateAxis (FltDataCodeMap[eFltITemplateAxis - FLTOP_DATA_OFFSET])
#define fltITemplatePoint (FltDataCodeMap[eFltITemplatePoint - FLTOP_DATA_OFFSET])
#define fltITerrain (FltDataCodeMap[eFltITerrain - FLTOP_DATA_OFFSET])
#define fltITexMap (FltDataCodeMap[eFltITexMap - FLTOP_DATA_OFFSET])
#define fltITexMap1 (FltDataCodeMap[eFltITexMap1 - FLTOP_DATA_OFFSET])
#define fltITexMap2 (FltDataCodeMap[eFltITexMap2 - FLTOP_DATA_OFFSET])
#define fltITexMap3 (FltDataCodeMap[eFltITexMap3 - FLTOP_DATA_OFFSET])
#define fltITexWhite (FltDataCodeMap[eFltITexWhite - FLTOP_DATA_OFFSET])
#define fltITmesh (FltDataCodeMap[eFltITmesh - FLTOP_DATA_OFFSET])
#define fltIToggle (FltDataCodeMap[eFltIToggle - FLTOP_DATA_OFFSET])
#define fltVU (FltDataCodeMap[eFltVU - FLTOP_DATA_OFFSET])
#define fltVU1 (FltDataCodeMap[eFltVU1 - FLTOP_DATA_OFFSET])
#define fltUpperLat (FltDataCodeMap[eFltUpperLat - FLTOP_DATA_OFFSET])
#define fltVV (FltDataCodeMap[eFltVV - FLTOP_DATA_OFFSET])
#define fltVV1 (FltDataCodeMap[eFltVV1 - FLTOP_DATA_OFFSET])
#define fltVColor (FltDataCodeMap[eFltVColor - FLTOP_DATA_OFFSET])
#define fltVIntensity (FltDataCodeMap[eFltVIntensity - FLTOP_DATA_OFFSET])
#define fltVdbl1 (FltDataCodeMap[eFltVdbl1 - FLTOP_DATA_OFFSET])
#define fltVdbl2 (FltDataCodeMap[eFltVdbl2 - FLTOP_DATA_OFFSET])
#define fltVdbl3 (FltDataCodeMap[eFltVdbl3 - FLTOP_DATA_OFFSET])
#define fltVdbl4 (FltDataCodeMap[eFltVdbl4 - FLTOP_DATA_OFFSET])
#define fltVdbl5 (FltDataCodeMap[eFltVdbl5 - FLTOP_DATA_OFFSET])
#define fltVdbl6 (FltDataCodeMap[eFltVdbl6 - FLTOP_DATA_OFFSET])
#define fltVdbl7 (FltDataCodeMap[eFltVdbl7 - FLTOP_DATA_OFFSET])
#define fltVdbl8 (FltDataCodeMap[eFltVdbl8 - FLTOP_DATA_OFFSET])
#define fltVectorI (FltDataCodeMap[eFltVectorI - FLTOP_DATA_OFFSET])
#define fltVectorJ (FltDataCodeMap[eFltVectorJ - FLTOP_DATA_OFFSET])
#define fltVectorK (FltDataCodeMap[eFltVectorK - FLTOP_DATA_OFFSET])
#define fltIVertical (FltDataCodeMap[eFltIVertical - FLTOP_DATA_OFFSET])
#define fltVConstructFlag (FltDataCodeMap[eFltVConstructFlag - FLTOP_DATA_OFFSET])
#define fltVtxCoordX (FltDataCodeMap[eFltVtxCoordX - FLTOP_DATA_OFFSET])
#define fltVtxCoordY (FltDataCodeMap[eFltVtxCoordY - FLTOP_DATA_OFFSET])
#define fltVtxCoordZ (FltDataCodeMap[eFltVtxCoordZ - FLTOP_DATA_OFFSET])
#define fltVtxDummy (FltDataCodeMap[eFltVtxDummy - FLTOP_DATA_OFFSET])
#define fltXmLimitCur (FltDataCodeMap[eFltXmLimitCur - FLTOP_DATA_OFFSET])
#define fltXmLimitInc (FltDataCodeMap[eFltXmLimitInc - FLTOP_DATA_OFFSET])
#define fltXmLimitMax (FltDataCodeMap[eFltXmLimitMax - FLTOP_DATA_OFFSET])
#define fltXmLimitMin (FltDataCodeMap[eFltXmLimitMin - FLTOP_DATA_OFFSET])
#define fltXmOpcode (FltDataCodeMap[eFltXmOpcode - FLTOP_DATA_OFFSET])
#define fltXmRotateAngle (FltDataCodeMap[eFltXmRotateAngle - FLTOP_DATA_OFFSET])
#define fltXmRotEdgeAngle (FltDataCodeMap[eFltXmRotEdgeAngle - FLTOP_DATA_OFFSET])
#define fltXmScaleRotAngle (FltDataCodeMap[eFltXmScaleRotAngle - FLTOP_DATA_OFFSET])
#define fltXmScaleAxis (FltDataCodeMap[eFltXmScaleAxis - FLTOP_DATA_OFFSET])
#define fltXmScaleOverAll (FltDataCodeMap[eFltXmScaleOverAll - FLTOP_DATA_OFFSET])
#define fltXmScaleX (FltDataCodeMap[eFltXmScaleX - FLTOP_DATA_OFFSET])
#define fltXmScaleY (FltDataCodeMap[eFltXmScaleY - FLTOP_DATA_OFFSET])
#define fltXmScaleZ (FltDataCodeMap[eFltXmScaleZ - FLTOP_DATA_OFFSET])
#define fltXrefFilename (FltDataCodeMap[eFltXrefFilename - FLTOP_DATA_OFFSET])
#define fltXrefUnits (FltDataCodeMap[eFltXrefUnits - FLTOP_DATA_OFFSET])
#define fltIZone (FltDataCodeMap[eFltIZone - FLTOP_DATA_OFFSET])
#define fltStrucOn (FltDataCodeMap[eFltStrucOn - FLTOP_DATA_OFFSET])
#define fltStrucInstBelow (FltDataCodeMap[eFltStrucInstBelow - FLTOP_DATA_OFFSET])
#define fltVertexNo (FltDataCodeMap[eFltVertexNo - FLTOP_DATA_OFFSET])
#define fltBottomLeftFrontX (FltDataCodeMap[eFltBottomLeftFrontX - FLTOP_DATA_OFFSET])
#define fltBottomLeftFrontY (FltDataCodeMap[eFltBottomLeftFrontY - FLTOP_DATA_OFFSET])
#define fltBottomLeftFrontZ (FltDataCodeMap[eFltBottomLeftFrontZ - FLTOP_DATA_OFFSET])
#define fltTopRightBackX (FltDataCodeMap[eFltTopRightBackX - FLTOP_DATA_OFFSET])
#define fltTopRightBackY (FltDataCodeMap[eFltTopRightBackY - FLTOP_DATA_OFFSET])
#define fltTopRightBackZ (FltDataCodeMap[eFltTopRightBackZ - FLTOP_DATA_OFFSET])
#define fltBoundingCenterX (FltDataCodeMap[eFltBoundingCenterX - FLTOP_DATA_OFFSET])
#define fltBoundingCenterY (FltDataCodeMap[eFltBoundingCenterY - FLTOP_DATA_OFFSET])
#define fltBoundingCenterZ (FltDataCodeMap[eFltBoundingCenterZ - FLTOP_DATA_OFFSET])

#endif /* FLTCODE_H_ */
/* eof */
