#ifndef FLTECODE_H_
#define FLTECODE_H_

#define FLTOP_RECORD_OFFSET 256
#define FLTOP_DATA_OFFSET 2048

/*----------------------------------------------------------------------------*/

/* Record table index symbols */
typedef enum {
	eFltBoundingCenter = FLTOP_RECORD_OFFSET,
	eFltBoundingOrientation,
	eFltBoundingSphere,
	eFltBoundingCylinder,
	eFltBoundingHull,
	eFltBHNext,
	eFltBHPnt1,
	eFltBHPnt2,
	eFltBHPnt3,
	eFltBoundingHistogram,
	eFltHistPosts,
	eFltXrefGfxCntx,
	eFltPolyGfxCntx,
	eFltTxtGeoCoordData,
	eFltTxtGeoCoord,
	eFltTxtGetCoordLst,
	eFltTGData,
	eFltTGNext,
	eFltTGCoords,
	eFltImgGeoCoords,
	eFltSound,
	eFltSoundPalette,
	eFltSndNext,
	eFltSndOffset,
	eFltSndNormal,
	eFltPath,
	eFltFCoord,
	eFltEyePoint,
	eFltEyeRotCenter,
	eFltEyeRotMatrix,
	eFltEyeFlyMatrix,
	eFltEyeLookFrom,
	eFltEyeEyeDir,
	eFltEyeImageOffset,
	eFltFPoint,
	eFltSWIfmt,
	eFltTerTrans,
	eFltAmbient,
	eFltBottomLeftFront,
	eFltBoundingBox,
	eFltBox,
	eFltBsp,
	eFltColorRGBA,
	eFltCylinder,
	eFltDPlane,
	eFltIDblInfo,
	eFltIDfadInfo,
	eFltVDfadInfo,
	eFltDiffuse,
	eFltDof,
	eFltIDownBead,
	eFltEmissive,
	eFltFMaterial,
	eFltIFirstInstance,
	eFltGfxCntx,
	eFltGroup,
	eFltHeader,
	eFltIMaterial,
	eFltIPoint,
	eFltIbead,
	eFltIcoord,
	eFltImage,
	eFltImgPivot,
	eFltImgUp,
	eFltIInsert,
	eFltLightSource,
	eFltLightSourcePalette,
	eFltILinkInfo,
	eFltVLinkInfo,
	eFltLodCenterPoint,
	eFltLod,
	eFltLtsPosition,
	eFltLtspAmbient,
	eFltLtspDiffuse,
	eFltLtspSpecular,
	eFltIMasterBead,
	eFltMatrix,
	eFltIMesh,
	eFltINextBead,
	eFltVNextBead,
	eFltINextInstance,
	eFltINextSelect,
	eFltVNextSelect,
	eFltINextSelect2,
	eFltVNextSelect2,
	eFltNormColor,
	eFltOSWIfmt,
	eFltObject,
	eFltOterTrans,
	eFltPackedColor,
	eFltPolyColor2Rgb,
	eFltPolyColorRgb,
	eFltPolygon,
	eFltRecDummy,
	eFltIRecInfo,
	eFltVExtInfo,
	eFltVRecInfo,
	eFltRecUndef,
	eFltShareVtxS,
	eFltISoundPath,
	eFltSpecular,
	eFltISplit,
	eFltStrucrec,
	eFltISubBead,
	eFltVSubVertex,
	eFltISuperBead,
	eFltVSuperVertex,
	eFltSwSwitches,
	eFltSwitch,
	eFltTopRightBack,
	eFltIUpBead,
	eFltVUpBead,
	eFltVNormal,
	eFltVertex,
	eFltVector,
	eFltXformPtr,
	eFltXmDblInfo,
	eFltXmGeneral,
	eFltXmHeader,
	eFltXmLimits,
	eFltXmNext,
	eFltXmPut,
	eFltXmPutFromAlign,
	eFltXmPutFromOrigin,
	eFltXmPutFromTrack,
	eFltXmPutToAlign,
	eFltXmPutToOrigin,
	eFltXmPutToTrack,
	eFltXmRotRefPoint1,
	eFltXmRotRefPoint2,
	eFltXmScaleRefPoint1,
	eFltXmScaleRefPoint2,
	eFltXmRotate,
	eFltXmRotateAxis,
	eFltXmRotateCenter,
	eFltXmRotateEdge,
	eFltXmScale,
	eFltXmScaleCenter,
	eFltXmScalePointCenter,
	eFltXmScaleToPoint,
	eFltXmTranslate,
	eFltXmTranslateDelta,
	eFltXmTranslateFrom,
	eFltXref,
	FLT_RECORD_MAX
} FltRecordTableDefs;

/* Data table index symbols */
typedef enum {
	eFltNlhash = FLTOP_DATA_OFFSET,
	eFltDofId,
	eFltVtxType,
	eFltDblOrig,
	eFltSoundid,
	eFltPathid,
	eFltClipid,
	eFltTextid,
	eFltBspid,
	eFltSwitchid,
	eFltLtsrcid,
	eFltLtpntid,
	eFltRoadid,
	eFltCatid,
	eFltBYaw,
	eFltBPitch,
	eFltBRoll,
	eFltBSRadius,
	eFltBCRadius,
	eFltBCHeight,
	eFltNumXincs,
	eFltNumYincs,
	eFltPlateauFunc,
	eFltLodSpecial1,
	eFltLodSpecial2,
	eFltPolyFlagFootprint,
	eFltPolyFlagHidden,
	eFltPolyTexmap,
	eFltPolyTexmap1,
	eFltPolyPrimeColor,
	eFltPolyPrimeIntensity,
	eFltPolyAltColor,
	eFltPolyAltIntensity,
	eFltImgFocalLength,
	eFltImgPixelScale,
	eFltImgPrinciplePtx,
	eFltImgPrinciplePty,
	eFltImgLon0,
	eFltImgLat0,
	eFltImgLat1,
	eFltImgLat2,
	eFltNpscale,
	eFltImgProjection,
	eFltImgEarthModel,
	eFltImgCameraType,
	eFltImgUTMzone,
	eFltImgImageOrigin,
	eFltImgUnits,
	eFltPixelScaleUnits,
	eFltImgFocalLengthUnits,
	eFltImgHemisphere,
	eFltImgFalseEasting,
	eFltImgFalseNorthing,
	eFltMirrorSmoothFlags,
	eFltImgVersion,
	eFltSndIndex,
	eFltSndOrder,
	eFltSndFound,
	eFltSndFilename,
	eFltSndPathname,
	eFltSndName,
	eFltSndAmplitude,
	eFltSndPitchBend,
	eFltSndPriority,
	eFltSndFallOff,
	eFltSndWidth,
	eFltSndDoppler,
	eFltSndAbsorption,
	eFltSndDelay,
	eFltSndDirection,
	eFltSndActive,
	eFltTGNumCoords,
	eFltTGUnits,
	eFltTGX,
	eFltTGY,
	eFltTGZ,
	eFltTGU,
	eFltTGV,
	eFltTGLat,
	eFltTGLon,
	eFltPathName,
	eFltPathSpeedlimit,
	eFltPathNoPass,
	eFltPathType,
	eFltEyeYaw,
	eFltEyePitch,
	eFltEyeRoll,
	eFltEyeFov,
	eFltEyeScale,
	eFltEyeNearClip,
	eFltEyeFarClip,
	eFltFCoordX,
	eFltFCoordY,
	eFltFCoordZ,
	eFltEyeFlyYaw,
	eFltEyeFlyPitch,
	eFltEyeNoFly,
	eFltEyeOrthoFlag,
	eFltEyeActive,
	eFltEyeImageZoom,
	eFltBHPnt1X,
	eFltBHPnt1Y,
	eFltBHPnt1Z,
	eFltBHPnt2X,
	eFltBHPnt2Y,
	eFltBHPnt2Z,
	eFltBHPnt3X,
	eFltBHPnt3Y,
	eFltBHPnt3Z,
	eFltSWCornerLat1,
	eFltSWCornerLong1,
	eFltNECornerLat1,
	eFltNECornerLong1,
	eFltOriginLat1,
	eFltOriginLong1,
	eFltUpperLat1,
	eFltLowerLat1,
	eFltFPointX,
	eFltFPointY,
	eFltAlpha,
	eFltIAltColor,
	eFltIAltIntensity,
	eFltBlue,
	eFltBoundingType,
	eFltICface,
	eFltIChanged,
	eFltVChanged,
	eFltIColor,
	eFltIIntensity,
	eFltColorA,
	eFltColorB,
	eFltColorG,
	eFltColorR,
	eFltIConstructFlag,
	eFltICurtex,
	eFltICurtex1,
	eFltICurtex2,
	eFltICurtex3,
	eFltDPlaneA,
	eFltDPlaneB,
	eFltDPlaneC,
	eFltDPlaneD,
	eFltDataUndef,
	eFltIDeadBead,
	eFltVDeadBead,
	eFltIDfd1,
	eFltIDfd2,
	eFltIDfd3,
	eFltIDfd4,
	eFltIDisable,
	eFltIDisplay,
	eFltVDisplay,
	eFltIDisplayMask,
	eFltDofCurAzim,
	eFltDofCurIncl,
	eFltDofCurTwist,
	eFltDofCurX,
	eFltDofCurXScale,
	eFltDofCurY,
	eFltDofCurYScale,
	eFltDofCurZ,
	eFltDofCurZScale,
	eFltDofIncrementAzim,
	eFltDofIncrementIncl,
	eFltDofIncrementTwist,
	eFltDofIncrementX,
	eFltDofIncrementXScale,
	eFltDofIncrementY,
	eFltDofIncrementYScale,
	eFltDofIncrementZ,
	eFltDofIncrementZScale,
	eFltDofMaxAzim,
	eFltDofMaxIncl,
	eFltDofMaxTwist,
	eFltDofMaxX,
	eFltDofMaxXScale,
	eFltDofMaxY,
	eFltDofMaxYScale,
	eFltDofMaxZ,
	eFltDofMaxZScale,
	eFltDofMinAzim,
	eFltDofMinIncl,
	eFltDofMinTwist,
	eFltDofMinX,
	eFltDofMinXScale,
	eFltDofMinY,
	eFltDofMinYScale,
	eFltDofMinZ,
	eFltDofMinZScale,
	eFltDofPutAnchorX,
	eFltDofPutAnchorY,
	eFltDofPutAnchorZ,
	eFltDofPutAlignX,
	eFltDofPutAlignY,
	eFltDofPutAlignZ,
	eFltDofPutTrackX,
	eFltDofPutTrackY,
	eFltDofPutTrackZ,
	eFltIDontExport,
	eFltIDontExportDl,
	eFltIDontExportInfo,
	eFltIDownCnt,
	eFltDummyPtr,
	eFltVEdge,
	eFltIExternal,
	eFltIFootprint,
	eFltFreezeBox,
	eFltIFreezeMesh,
	eFltVFrozen,
	eFltIGc,
	eFltGcColPal,
	eFltGcDrawMode,
	eFltGcLightMode,
	eFltGcLinPal,
	eFltGcLitPal,
	eFltGcMatPal,
	eFltGcSndPal,
	eFltGcTxtPal,
	eFltGreen,
	eFltGrpFlagAnimation,
	eFltGrpFlagAnimationFB,
	eFltGrpFlagBoxed,
	eFltGrpFlagDefaultParent,
	eFltGrpFlagFreezeBox,
	eFltGrpFlagTerrain,
	eFltGrpLayer,
	eFltGrpPrio,
	eFltGrpSignificance,
	eFltGrpSpecial1,
	eFltGrpSpecial2,
	eFltVHard,
	eFltVHard2,
	eFltHdrDbRev,
	eFltHdrFlagVtxNorms,
	eFltHdrFormatRev,
	eFltHdrLastDate,
	eFltHdrNextFacId,
	eFltHdrNextGrpId,
	eFltHdrNextLodId,
	eFltHdrNextObjId,
	eFltHdrTexWhite,
	eFltHdrUdiv,
	eFltHdrUnits,
	eFltHeight,
	eFltIHidden,
	eFltIAlpha,
	eFltIcoordX,
	eFltIcoordY,
	eFltIcoordZ,
	eFltIdbl1,
	eFltIdbl2,
	eFltIdbl3,
	eFltIdbl4,
	eFltIdbl5,
	eFltIdbl6,
	eFltIdbl7,
	eFltIdbl8,
	eFltImgChanged,
	eFltImgClamp,
	eFltImgComment,
	eFltImgControlPoint,
	eFltImgDblOrig,
	eFltImgDetail,
	eFltImgEnvType,
	eFltImgExternalFormat,
	eFltImgFormatRev,
	eFltImgHeight,
	eFltImgInAlpha,
	eFltImgInternalFormat,
	eFltImgJ,
	eFltImgK,
	eFltImgKernel,
	eFltImgLod0,
	eFltImgLod1,
	eFltImgLod2,
	eFltImgLod3,
	eFltImgLod4,
	eFltImgLod5,
	eFltImgLod6,
	eFltImgLod7,
	eFltImgLowerLeftU,
	eFltImgLowerLeftV,
	eFltImgM,
	eFltImgMagFilter,
	eFltImgMagFilterAlpha,
	eFltImgMagFilterColor,
	eFltImgMinFilter,
	eFltImgN,
	eFltImgRwSizeU,
	eFltImgRwSizeUf,
	eFltImgRwSizeV,
	eFltImgRwSizeVf,
	eFltImgScale0,
	eFltImgScale1,
	eFltImgScale2,
	eFltImgScale3,
	eFltImgScale4,
	eFltImgScale5,
	eFltImgScale6,
	eFltImgScale7,
	eFltImgScramble,
	eFltImgTile,
	eFltImgType,
	eFltImgU64AlphaClip,
	eFltImgU64CustomSize,
	eFltImgU64Format,
	eFltImgU64GenS,
	eFltImgU64GenT,
	eFltImgU64Height,
	eFltImgU64MaxResDir,
	eFltImgU64Mipmap,
	eFltImgU64PixSize,
	eFltImgU64ShrinkFlag,
	eFltImgU64Width,
	eFltImgU64WrapS,
	eFltImgU64WrapT,
	eFltImgUpperRightU,
	eFltImgUpperRightV,
	eFltImgUseFilter,
	eFltImgUser1,
	eFltImgUser2,
	eFltImgUser3,
	eFltImgUser4,
	eFltImgUser5,
	eFltImgUser6,
	eFltImgUser7,
	eFltImgUser8,
	eFltImgWidth,
	eFltImgWrap,
	eFltImgWrapU,
	eFltImgWrapV,
	eFltIImmediate,
	eFltIInstBelow,
	eFltIpointX,
	eFltIpointY,
	eFltIIrColor,
	eFltILayer,
	eFltVLeaveNorm,
	eFltILevel,
	eFltVLevel,
	eFltILibrary,
	eFltILight,
	eFltILightMode,
	eFltILineStyle,
	eFltLodFlagAdditive,
	eFltLodFlagFreezeCenter,
	eFltLodFlagRange,
	eFltLodSwitchIn,
	eFltLodSwitchOut,
	eFltLodTransition,
	eFltLowerLat,
	eFltLtsAttachedToEye,
	eFltLtsEnabled,
	eFltLtsError1,
	eFltLtsExport,
	eFltLtsGlobal,
	eFltLtsIndex,
	eFltLtsPitch,
	eFltLtsYaw,
	eFltLtspConstAtten,
	eFltLtspLinearAtten,
	eFltLtspModeling,
	eFltLtspName,
	eFltLtspOnFlag,
	eFltLtspPaletteId,
	eFltLtspPitch,
	eFltLtspQuadAtten,
	eFltLtspSpotExp,
	eFltLtspSpotSpread,
	eFltLtspType,
	eFltLtspYaw,
	eFltMatActive,
	eFltMatAlpha,
	eFltMatIndex,
	eFltMatName,
	eFltMatUsed,
	eFltMaterial,
	eFltMatrix00,
	eFltMatrix01,
	eFltMatrix02,
	eFltMatrix03,
	eFltMatrix10,
	eFltMatrix11,
	eFltMatrix12,
	eFltMatrix13,
	eFltMatrix20,
	eFltMatrix21,
	eFltMatrix22,
	eFltMatrix23,
	eFltMatrix30,
	eFltMatrix31,
	eFltMatrix32,
	eFltMatrix33,
	eFltIMgTemplate,
	eFltVMorphPercent,
	eFltNColorB,
	eFltNColorG,
	eFltNColorR,
	eFltNECornerLat,
	eFltNECornerLong,
	eFltVNameNdx,
	eFltINoBack,
	eFltINoIllum,
	eFltINoShade,
	eFltObjFlagDay,
	eFltObjFlagDusk,
	eFltObjFlagNight,
	eFltObjFlagNoillum,
	eFltObjFlagNoshade,
	eFltObjFlagShadow,
	eFltObjFlagTerrain,
	eFltObjPrio,
	eFltObjSignificance,
	eFltObjSpecial1,
	eFltObjSpecial2,
	eFltObjTransparency,
	eFltIOn,
	eFltOriginLat,
	eFltOriginLong,
	eFltIOriginalColor,
	eFltIPath,
	eFltIPathCnt,
	eFltVPathCnt,
	eFltIPercentTxt,
	eFltIPhantom,
	eFltIPln,
	eFltPolyColorName,
	eFltPolyColorName2,
	eFltPolyDrawType,
	eFltPolyDrawTypeOld,
	eFltPolyFid,
	eFltPolyFlagNocolor,
	eFltPolyFlagNocolor2,
	eFltPolyFlagRgbMode,
	eFltPolyFlagTerrain,
	eFltPolyInfrared,
	eFltPolyIrMaterial,
	eFltPolyLineStyle,
	eFltPolyLodControl,
	eFltPolyMaterial,
	eFltPolyMgTemplate,
	eFltPolyPrio,
	eFltPolySmc,
	eFltPolyTexWhite,
	eFltPolyTexture,
	eFltPolyTexture1,
	eFltPolyTransparency,
	eFltIPrio,
	eFltProjection,
	eFltRadius,
	eFltIReadOnly,
	eFltRed,
	eFltRepCnt,
	eFltIRepSel,
	eFltRGBA,
	eFltIRgbMode,
	eFltVRgbMode,
	eFltIRoad,
	eFltSWCornerLat,
	eFltSWCornerLong,
	eFltIScratch,
	eFltShininess,
	eFltISif1,
	eFltISif2,
	eFltISif3,
	eFltISif4,
	eFltISif5,
	eFltISif6,
	eFltISif7,
	eFltISif8,
	eFltISliced,
	eFltISpt,
	eFltStrucCnt,
	eFltIStrucOn,
	eFltVSubVtx,
	eFltSwCount,
	eFltSwCurMask,
	eFltSwDynamic,
	eFltSwMaxMask,
	eFltITemplateAxis,
	eFltITemplatePoint,
	eFltITerrain,
	eFltITexMap,
	eFltITexMap1,
	eFltITexMap2,
	eFltITexMap3,
	eFltITexWhite,
	eFltITmesh,
	eFltIToggle,
	eFltVU,
	eFltVU1,
	eFltUpperLat,
	eFltVV,
	eFltVV1,
	eFltVColor,
	eFltVIntensity,
	eFltVdbl1,
	eFltVdbl2,
	eFltVdbl3,
	eFltVdbl4,
	eFltVdbl5,
	eFltVdbl6,
	eFltVdbl7,
	eFltVdbl8,
	eFltVectorI,
	eFltVectorJ,
	eFltVectorK,
	eFltIVertical,
	eFltVConstructFlag,
	eFltVtxCoordX,
	eFltVtxCoordY,
	eFltVtxCoordZ,
	eFltVtxDummy,
	eFltXmLimitCur,
	eFltXmLimitInc,
	eFltXmLimitMax,
	eFltXmLimitMin,
	eFltXmOpcode,
	eFltXmRotateAngle,
	eFltXmRotEdgeAngle,
	eFltXmScaleRotAngle,
	eFltXmScaleAxis,
	eFltXmScaleOverAll,
	eFltXmScaleX,
	eFltXmScaleY,
	eFltXmScaleZ,
	eFltXrefFilename,
	eFltXrefUnits,
	eFltIZone,
	eFltStrucOn,
	eFltStrucInstBelow,
	eFltVertexNo,
	eFltBottomLeftFrontX,
	eFltBottomLeftFrontY,
	eFltBottomLeftFrontZ,
	eFltTopRightBackX,
	eFltTopRightBackY,
	eFltTopRightBackZ,
	eFltBoundingCenterX,
	eFltBoundingCenterY,
	eFltBoundingCenterZ,
	FLT_DATA_MAX
} FltDataTableDefs;
#endif
