/*
** Copyright 1991-1997, Silicon Graphics, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/
#include "g_imfncs.h"
#include "g_disp.h"
#include "g_lcfncs.h"
#include "sstimfuncs.h"

__GLdispatchState __glSSTImmedState = {
    /*
    ** number of entries
    */
    __GL_TAB_ENTRIES,

    /*
    ** dispatch
    */
    {
    __glim_NewList,
    __glim_EndList,
    __glim_CallList,
    __glim_CallLists,
    __glim_DeleteLists,
    __glim_GenLists,
    __glim_ListBase,
    __glim_Begin,
    __glim_Bitmap,
    __glim_Color3b,
    __glim_Color3bv,
    __glim_Color3d,
    __glim_Color3dv,
    __glim_Color3f,
    __glim_Color3fv,
    __glim_Color3i,
    __glim_Color3iv,
    __glim_Color3s,
    __glim_Color3sv,
    __glim_Color3ub,
    __glim_Color3ubv,
    __glim_Color3ui,
    __glim_Color3uiv,
    __glim_Color3us,
    __glim_Color3usv,
    __glim_Color4b,
    __glim_Color4bv,
    __glim_Color4d,
    __glim_Color4dv,
    __glim_Color4f,
    __glim_Color4fv,
    __glim_Color4i,
    __glim_Color4iv,
    __glim_Color4s,
    __glim_Color4sv,
    __glim_Color4ub,
    __glim_Color4ubv,
    __glim_Color4ui,
    __glim_Color4uiv,
    __glim_Color4us,
    __glim_Color4usv,
    __glim_EdgeFlag,
    __glim_EdgeFlagv,
    __glim_End,
    __glim_Indexd,
    __glim_Indexdv,
    __glim_Indexf,
    __glim_Indexfv,
    __glim_Indexi,
    __glim_Indexiv,
    __glim_Indexs,
    __glim_Indexsv,
    __glim_Normal3b,
    __glim_Normal3bv,
    __glim_Normal3d,
    __glim_Normal3dv,
    __glim_Normal3f,
    __glim_Normal3fv,
    __glim_Normal3i,
    __glim_Normal3iv,
    __glim_Normal3s,
    __glim_Normal3sv,
    __glim_RasterPos2d,
    __glim_RasterPos2dv,
    __glim_RasterPos2f,
    __glim_RasterPos2fv,
    __glim_RasterPos2i,
    __glim_RasterPos2iv,
    __glim_RasterPos2s,
    __glim_RasterPos2sv,
    __glim_RasterPos3d,
    __glim_RasterPos3dv,
    __glim_RasterPos3f,
    __glim_RasterPos3fv,
    __glim_RasterPos3i,
    __glim_RasterPos3iv,
    __glim_RasterPos3s,
    __glim_RasterPos3sv,
    __glim_RasterPos4d,
    __glim_RasterPos4dv,
    __glim_RasterPos4f,
    __glim_RasterPos4fv,
    __glim_RasterPos4i,
    __glim_RasterPos4iv,
    __glim_RasterPos4s,
    __glim_RasterPos4sv,
    __glim_Rectd,
    __glim_Rectdv,
    __glim_Rectf,
    __glim_Rectfv,
    __glim_Recti,
    __glim_Rectiv,
    __glim_Rects,
    __glim_Rectsv,
    __glim_TexCoord1d,
    __glim_TexCoord1dv,
    __glim_TexCoord1f,
    __glim_TexCoord1fv,
    __glim_TexCoord1i,
    __glim_TexCoord1iv,
    __glim_TexCoord1s,
    __glim_TexCoord1sv,
    __glim_TexCoord2d,
    __glim_TexCoord2dv,
    __glim_TexCoord2f,
    __glim_TexCoord2fv,
    __glim_TexCoord2i,
    __glim_TexCoord2iv,
    __glim_TexCoord2s,
    __glim_TexCoord2sv,
    __glim_TexCoord3d,
    __glim_TexCoord3dv,
    __glim_TexCoord3f,
    __glim_TexCoord3fv,
    __glim_TexCoord3i,
    __glim_TexCoord3iv,
    __glim_TexCoord3s,
    __glim_TexCoord3sv,
    __glim_TexCoord4d,
    __glim_TexCoord4dv,
    __glim_TexCoord4f,
    __glim_TexCoord4fv,
    __glim_TexCoord4i,
    __glim_TexCoord4iv,
    __glim_TexCoord4s,
    __glim_TexCoord4sv,
    __glim_Vertex2d,
    __glim_Vertex2dv,
    __glim_Vertex2f,
    __glim_Vertex2fv,
    __glim_Vertex2i,
    __glim_Vertex2iv,
    __glim_Vertex2s,
    __glim_Vertex2sv,
    __glim_Vertex3d,
    __glim_Vertex3dv,
    __glim_Vertex3f,
    __glim_Vertex3fv,
    __glim_Vertex3i,
    __glim_Vertex3iv,
    __glim_Vertex3s,
    __glim_Vertex3sv,
    __glim_Vertex4d,
    __glim_Vertex4dv,
    __glim_Vertex4f,
    __glim_Vertex4fv,
    __glim_Vertex4i,
    __glim_Vertex4iv,
    __glim_Vertex4s,
    __glim_Vertex4sv,
    __glim_ClipPlane,
    __glim_ColorMaterial,
    __glsstim_CullFace,
    __glsstim_Fogf,
    __glsstim_Fogfv,
    __glsstim_Fogi,
    __glsstim_Fogiv,
    __glsstim_FrontFace,
    __glim_Hint,
    __glim_Lightf,
    __glim_Lightfv,
    __glim_Lighti,
    __glim_Lightiv,
    __glim_LightModelf,
    __glim_LightModelfv,
    __glim_LightModeli,
    __glim_LightModeliv,
    __glim_LineStipple,
    __glim_LineWidth,
    __glim_Materialf,
    __glim_Materialfv,
    __glim_Materiali,
    __glim_Materialiv,
    __glim_PointSize,
    __glim_PolygonMode,
    __glim_PolygonStipple,
    __glim_Scissor,
    __glim_ShadeModel,
    __glim_TexParameterf,
    __glim_TexParameterfv,
    __glim_TexParameteri,
    __glim_TexParameteriv,
    __glim_TexImage1D,
    __glim_TexImage2D,
    __glim_TexEnvf,
    __glim_TexEnvfv,
    __glim_TexEnvi,
    __glim_TexEnviv,
    __glim_TexGend,
    __glim_TexGendv,
    __glim_TexGenf,
    __glim_TexGenfv,
    __glim_TexGeni,
    __glim_TexGeniv,
    __glim_FeedbackBuffer,
    __glim_SelectBuffer,
    __glim_RenderMode,
    __glim_InitNames,
    __glim_LoadName,
    __glim_PassThrough,
    __glim_PopName,
    __glim_PushName,
    __glsstim_DrawBuffer,
    __glsstim_Clear,
    __glim_ClearAccum,
    __glim_ClearIndex,
    __glim_ClearColor,
    __glim_ClearStencil,
    __glim_ClearDepth,
    __glim_StencilMask,
    __glsstim_ColorMask,
    __glsstim_DepthMask,
    __glim_IndexMask,
    __glim_Accum,
    __glsstim_Disable,
    __glsstim_Enable,
    __glim_Finish,
    __glim_Flush,
    __glim_PopAttrib,
    __glim_PushAttrib,
    __glim_Map1d,
    __glim_Map1f,
    __glim_Map2d,
    __glim_Map2f,
    __glim_MapGrid1d,
    __glim_MapGrid1f,
    __glim_MapGrid2d,
    __glim_MapGrid2f,
    __glim_EvalCoord1d,
    __glim_EvalCoord1dv,
    __glim_EvalCoord1f,
    __glim_EvalCoord1fv,
    __glim_EvalCoord2d,
    __glim_EvalCoord2dv,
    __glim_EvalCoord2f,
    __glim_EvalCoord2fv,
    __glim_EvalMesh1,
    __glim_EvalPoint1,
    __glim_EvalMesh2,
    __glim_EvalPoint2,
    __glsstim_AlphaFunc,
    __glsstim_BlendFunc,
    __glim_LogicOp,
    __glim_StencilFunc,
    __glim_StencilOp,
    __glsstim_DepthFunc,
    __glim_PixelZoom,
    __glim_PixelTransferf,
    __glim_PixelTransferi,
    __glim_PixelStoref,
    __glim_PixelStorei,
    __glim_PixelMapfv,
    __glim_PixelMapuiv,
    __glim_PixelMapusv,
    __glim_ReadBuffer,
    __glim_CopyPixels,
    __glim_ReadPixels,
    __glim_DrawPixels,
    __glim_GetBooleanv,
    __glim_GetClipPlane,
    __glim_GetDoublev,
    __glim_GetError,
    __glim_GetFloatv,
    __glim_GetIntegerv,
    __glim_GetLightfv,
    __glim_GetLightiv,
    __glim_GetMapdv,
    __glim_GetMapfv,
    __glim_GetMapiv,
    __glim_GetMaterialfv,
    __glim_GetMaterialiv,
    __glim_GetPixelMapfv,
    __glim_GetPixelMapuiv,
    __glim_GetPixelMapusv,
    __glim_GetPolygonStipple,
    __glim_GetString,
    __glim_GetTexEnvfv,
    __glim_GetTexEnviv,
    __glim_GetTexGendv,
    __glim_GetTexGenfv,
    __glim_GetTexGeniv,
    __glim_GetTexImage,
    __glim_GetTexParameterfv,
    __glim_GetTexParameteriv,
    __glim_GetTexLevelParameterfv,
    __glim_GetTexLevelParameteriv,
    __glim_IsEnabled,
    __glim_IsList,
    __glim_DepthRange,
    __glim_Frustum,
    __glim_LoadIdentity,
    __glim_LoadMatrixf,
    __glim_LoadMatrixd,
    __glim_MatrixMode,
    __glim_MultMatrixf,
    __glim_MultMatrixd,
    __glim_Ortho,
    __glim_PopMatrix,
    __glim_PushMatrix,
    __glim_Rotated,
    __glim_Rotatef,
    __glim_Scaled,
    __glim_Scalef,
    __glim_Translated,
    __glim_Translatef,
    __glim_Viewport,

    /* OpenGL 1.1 commands */

    __glim_ArrayElement,
    __glim_ColorPointer,
    __glim_DisableClientState,
    __glim_DrawArrays,
    __glim_DrawElements,
    __glim_EdgeFlagPointer,
    __glim_EnableClientState,
    __glim_GetPointerv,
    __glim_IndexPointer,
    __glim_InterleavedArrays,
    __glim_NormalPointer,
    __glim_TexCoordPointer,
    __glim_VertexPointer,
    __glim_PolygonOffset,
    __glim_CopyTexImage1D,
    __glim_CopyTexImage2D,
    __glim_CopyTexSubImage1D,
    __glim_CopyTexSubImage2D,
    __glim_TexSubImage1D,
    __glim_TexSubImage2D,
    __glim_AreTexturesResident,
    __glim_BindTexture,
    __glim_DeleteTextures,
    __glim_GenTextures,
    __glim_IsTexture,
    __glim_PrioritizeTextures,
    __glim_Indexub,
    __glim_Indexubv,
    __glim_PopClientAttrib,
    __glim_PushClientAttrib,
    },

    /*
    ** extensions
    */
    {
    __glim_ArrayElementEXT,
    __glim_ColorPointerEXT,
    __glim_DrawArraysEXT,
    __glim_EdgeFlagPointerEXT,
    __glim_GetPointervEXT,
    __glim_IndexPointerEXT,
    __glim_NormalPointerEXT,
    __glim_TexCoordPointerEXT,
    __glim_VertexPointerEXT,
    __glim_ColorSubTableEXT,
    __glim_ColorTableEXT,
    __glim_CopyColorTableEXT,
    __glim_GetColorTableEXT,
    __glim_GetColorTableParameterfvEXT,
    __glim_GetColorTableParameterivEXT,
    __glim_LockArraysSGI,
    __glim_UnlockArraysSGI,
    __glim_CullParameterdvSGI,
    __glim_CullParameterfvSGI,
    __glim_IndexFuncSGI,
    __glim_IndexMaterialSGI,
    __glim_AddSwapHintRectWIN,
    }
};
