/*
** Copyright 1991-1997, Silicon Graphics, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
**
** $Revision: 2$
** $Date: 10/11/00 8:03:50 PM$
*/
/*
 * C version of __glMipsCopyDispatch which is found in mips_copydisp.s
 */

#ifndef __GL_USE_MIPSASMCODE
#include "types.h"
#include "g_disp.h"
#include "context.h"

void 
__glCopyDispatch(const __GLdispatchState *src,
		     __GLdispatchState *dst)
{
    if ((dst != src) && src && dst) {
	*dst = *src;
    }
#ifdef _WINDOWS
    if (dst == &__gl_dispatch) {
	/* this means copy into the windows dispatch state */
	__wglSetProcTable(__gl_context, src);
    }
#endif /* _WINDOWS */
}

__GLdispatchState *
__glGetCurrentDispatch()
{
    return &__gl_dispatch;
}

#endif /* __GL_USE_MIPSASMCODE */
